{$G+}
uses gurofill,threed,realtime,radtpu;

const
 maxnobj = 10;
 maxnfaces = 1900;
 maxnvertices = 1000;
 nobj : byte = 0;
 radius : word = 14000;

type
 VertexArrType  = array [1..10000,1..3] of integer;
 FacesArrType   = array [1..10000,1..3] of word;
 NormalsArrType = array [1..10000,1..3] of integer;
 vid3dtype      = array [1..maxnvertices,1..3] of integer;
 obj2dtype      = array [1..maxnvertices,1..2] of integer;
 colorstype     = array [1..maxnfaces] of word;
 newnormalstype = array [1..maxnfaces,1..3] of integer;
 U_poly_3dtype  = array [1..maxnfaces,1..3,1..3] of integer;
 U_poly_2dtype  = array [1..maxnfaces,1..3,1..2] of integer;
 U_colors3type  = array [1..maxnfaces,1..3] of word;

 laga = record
    ofs,seg: word
        end;

var
 t: longint;
 poly_3d : array [1..4,1..3] of integer;
 poly_2d : array [1..4,1..2] of integer;

 obj_vertices: array [1..maxnobj] of ^vertexarrtype;
 obj_faces : array [1..maxnobj] of ^facesarrtype;
 obj_names : array [1..maxnobj] of string;
 obj_normals : array [1..maxnobj] of ^normalsarrtype;
 obj_nfaces : array [1..maxnobj] of word;
 obj_nvertices : array [1..maxnobj] of word;
 i,j,k: integer;
 vid3d : ^vid3dtype;
 obj2d : ^obj2dtype;
 colors : ^colorstype;
 observer : observertype;
 newnormals : ^newnormalstype;
 backbuf : pointer;
 backbufseg: word;
 zbuf: pointer;
 zbufseg : word;
 a,b,c,n : longint;
 u_poly_2d : ^u_poly_2dtype;
 u_poly_3d : ^u_poly_3dtype;
 u_colors3 : ^u_colors3type;
 upl3d,upl2d,upcl : pointer;
 palette : array [1..768] of byte;
 f: file;
 gpoi: pointer;

{$F+}
procedure revenge; external;
procedure guropal; external;
procedure eugene; external;
{$L d:\eugene}
{$L d:\revenge}
{$L d:\guropal}
{$F-}

procedure my_blockread(p: pointer;count:word); assembler;
asm
 push ds
 mov cx,count
 mov bx,cx
 les di,p
 cld
 lds si,gpoi
 rep movsb
 pop ds
 add laga(gpoi).ofs,bx
end;

function keytouch: boolean; assembler;
asm
 xor ax,ax
 mov es,ax
 mov ax,es:[41ah]
 sub ax,es:[41ch]
 jz  @l1
 mov al,true
 @l1:
end;

{
function getnextline(var ft:text): string;
var
 s: string;
 label l1,l2;
begin
 l1:
 if eof(ft) then
   begin
    s:='';
    goto l2;
   end;
 readln(ft,s);
 while (length(s)>0) and (s[1]=' ') do s:=copy(s,2,255);
 if s='' then goto l1;
 if copy(s,1,4)='Page' then goto l1;
 l2:
 getnextline:=s;
end;

procedure LoadAscFile (fname:string);
var
 ft: text;
 s,s1,s2,s3 : string;
 i: integer;
 nvertices,nfaces: word;
 curvertex,curface: word;
 r: real;
 label l1,l2,l3;
begin
 writeln('Loading ASC file "',fname,'"');

 assign(ft,fname); reset(ft);

 while not eof (ft) do
   begin
    s:=getnextline(ft);

    if copy(s,1,12)='Named object' then
      begin
       s1:=getnextline(ft);
       if copy (s1,1,19)<>'Tri-mesh, Vertices:' then
            begin
             writeln('Skiped "',s);
             writeln('        ',s1);
             goto l1;
            end;
       inc(nobj);
       s:=copy(s,15,255);
       obj_names[nobj]:=s;
       writeln('Loading object: ',s);
       writeln('        ',s1);

       s1:=copy(s1,21,255);
       i:=1;
       while s1[i] in ['0'..'9'] do inc(i);
       s2:=copy(s1,1,i-1);
       val(s2,nvertices,i);
       i:=1;
       while s1[i]<>'F' do inc(i);
       s1:=copy(s1,i+7,255);
       val(s1,nfaces,i);

       obj_nfaces[nobj]:=nfaces;
       obj_nvertices[nobj]:=nvertices;

       getmem(obj_vertices[nobj],nvertices*3*2);
       getmem(obj_faces[nobj],nfaces*3*2);

       writeln('        Loading vertex list');
       s:=getnextline(ft);

       for curvertex:=1 to nvertices do
         begin
          write('        Vertex: ',curvertex,#13);
          l2:
          s:=getnextline(ft);
          if copy(s,1,6)<>'Vertex' then goto l2;

          i:=6;
          while s[i]<>':' do inc(i);
          inc(i);
          while s[i]<>':' do inc(i);
          s:=copy(s,i+2,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val (s1,r,i);
          obj_vertices[nobj]^[curvertex,1]:=round(r*20);

          while s[i]<>':' do inc(i);
          s:=copy(s,i+2,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val(s1,r,i);
          obj_vertices[nobj]^[curvertex,2]:=round(r*20);

          while s[i]<>':' do inc(i);
          s:=copy(s,i+2,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val(s1,r,i);
          obj_vertices[nobj]^[curvertex,3]:=round(r*20);
         end;
       writeln;
       writeln('        Loading Face list');
       s:=getnextline(ft);

       for curface:=1 to nfaces do
         begin
          write('        Face: ',curface,#13);
          l3:
          s:=getnextline(ft);
          if copy(s,1,4)<>'Face' then goto l3;

          i:=4;
          while s[i]<>':' do inc(i);
          inc(i);
          while s[i]<>':' do inc(i);
          s:=copy(s,i+1,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val (s1,r,i);
          obj_faces[nobj]^[curface,1]:=round(r)+1;

          while s[i]<>':' do inc(i);
          s:=copy(s,i+1,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val(s1,r,i);
          obj_faces[nobj]^[curface,2]:=round(r)+1;

          while s[i]<>':' do inc(i);
          s:=copy(s,i+1,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val(s1,r,i);
          obj_faces[nobj]^[curface,3]:=round(r)+1;
         end;
       writeln;
      end;


    l1:
   end;

 close(ft);
 writeln('Ok');
 writeln;
end;
 }

procedure calcnormal(norm: pointer);
type
 normalt = array [1..3] of integer;
var
 x1,y1,z1   : integer;
 x21,x31, y21,y31, z21,z31    : longint;
 a,b,c,m : real;
 i,j : word;

begin
 x1:=poly_3d[1,1];
 y1:=poly_3d[1,2];
 z1:=poly_3d[1,3];

 x21:=poly_3d[2,1]-x1;
 y21:=poly_3d[2,2]-y1;
 z21:=poly_3d[2,3]-z1;

 x31:=poly_3d[3,1]-x1;
 y31:=poly_3d[3,2]-y1;
 z31:=poly_3d[3,3]-z1;

 a:= y21*z31 - y31*z21;
 b:= z21*x31 - x21*z31;
 c:= x21*y31 - x31*y21;

 m:=sqrt(sqr(a)+sqr(b)+sqr(c));
if m<>0 then
 begin
  a:=(a*127)/m;
  b:=(b*127)/m;
  c:=(c*127)/m;
 end
   else
     begin
      writeln('normal length = 0 !');
      halt;
     end;
 normalt(norm^)[1]:=round(a);
 normalt(norm^)[2]:=round(b);
 normalt(norm^)[3]:=round(c);
end;


begin
 getmem(backbuf,64000+32);
 backbufseg:=laga(backbuf).seg+1;

 getmem(zbuf,64000+16);
 zbufseg:=laga(zbuf).seg+1;
 getmem(zbuf,64000+32);

 getmem(vid3d,sizeof(vid3dtype));
 getmem(obj2d,sizeof(obj2dtype));
 getmem(colors,sizeof(colorstype));
 getmem(newnormals,sizeof(newnormalstype));
 getmem(u_poly_2d,sizeof(u_poly_2dtype));
 getmem(u_poly_3d,sizeof(u_poly_3dtype));
 getmem(u_colors3,sizeof(u_colors3type));

 gpoi:=addr(eugene);
 my_blockread(addr(nobj),1);
 my_blockread(addr(obj_nfaces),sizeof(obj_nfaces));
 my_blockread(addr(obj_nvertices),sizeof(obj_nvertices));
 for i:=1 to nobj do
   begin
    getmem(obj_vertices[i],2*3*obj_nvertices[i]);
    getmem(obj_faces[i],2*3*obj_nfaces[i]);
    my_blockread(obj_vertices[i],2*3*obj_nvertices[i]);
    my_blockread(obj_faces[i],2*3*obj_nfaces[i]);
   end;

{ loadascfile('allboar1.asc');}

 write('Thinking: ',#8,#8,#8,#8,#8);

  for i:=1 to nobj do
    begin
     write('');
      for j:=1 to obj_nfaces[i] do
       begin
        move(obj_vertices[i]^[obj_faces[i]^[j,1]],poly_3d[1],6);
        move(obj_vertices[i]^[obj_faces[i]^[j,2]],poly_3d[2],6);
        move(obj_vertices[i]^[obj_faces[i]^[j,3]],poly_3d[3],6);
        calcnormal(addr(newnormals^[j]));
       end;
     getmem(obj_normals[i],obj_nvertices[i]*2*3);
     for j:=1 to obj_nvertices[i] do
       begin
         a:=0; b:=0; c:=0; n:=0;

         for k:=1 to obj_nfaces[i] do
            if (obj_faces[i]^[k,1]=j) or
               (obj_faces[i]^[k,2]=j) or
               (obj_faces[i]^[k,3]=j) then
                 begin
                  inc(n);
                  inc(a,newnormals^[k,1]);
                  inc(b,newnormals^[k,2]);
                  inc(c,newnormals^[k,3]);
                 end;

         if n=0 then
           begin
{            writeln;
            writeln ('-------- null normal !');}
            inc(n);
           end;
         obj_normals[i]^[j,1]:=a div n;
         obj_normals[i]^[j,2]:=b div n;
         obj_normals[i]^[j,3]:=c div n;
       end;
     write(#8,'');
    end;

{ assign(f,'d:\eugene.dat'); rewrite(f,1);
 blockwrite(f,nobj,1);
 blockwrite(f,obj_nfaces,sizeof(obj_nfaces));
 blockwrite(f,obj_nvertices,sizeof(obj_nvertices));
 for i:=1 to nobj do
   begin
    blockwrite(f,obj_vertices[i]^,2*3*obj_nvertices[i]);
    blockwrite(f,obj_faces[i]^,2*3*obj_nfaces[i]);
   end;
 close(f);}

 observer.alfa_rad:=0;
 observer.beta_rad:=0;
 observer.gama_rad:=0;

 asm
  mov ax,13h
  int 10h
 end;

 fillchar(palette,768,0);
 morfpalette(addr(palette),addr(guropal),8000);

 startplay(addr(revenge),7784,18);

 kr:=15+32+32;
 kd:=16+1;

 repeat

 t:=timercounter;
 stosword(ptr(backbufseg,0),0,32000);
 initzbuf(zbufseg);
 spherelook(addr(observer),radius);

 for i:=1 to nobj do
   begin
    case i of
     1..3: begin
            kr:=15+96+3;
            kd:=16;
          end;
        4: begin
            kr:=15+160;
            kd:=16;
           end;
     5: begin
            kr:=15+128;
            kd:=16;
          end;
    end;

    Rotate_3d(obj_nvertices[i],obj_normals[i],addr(observer),newnormals);
    transform(obj_nvertices[i],obj_vertices[i],addr(observer),vid3d);
    proectpoints(obj_nvertices[i],vid3d,obj2d);
    calccolors(obj_nfaces[i],newnormals,colors);

    unpacktriangle (obj_nfaces[i], vid3d, obj2d, obj_faces[i],
           colors, u_poly_3d, u_poly_2d, u_colors3);

    upl3d:=u_poly_3d;
    upl2d:=u_poly_2d;
    upcl:=u_colors3;

    for j:=1 to obj_nfaces[i] do
      begin
       if visible(upl2d) then

        { filltriangle_zbuf_guro(upl3d,upl2d,
          memw[laga(upcl).seg:laga(upcl).ofs],
            memw[laga(upcl).seg:laga(upcl).ofs+2],
              memw[laga(upcl).seg:laga(upcl).ofs+4],
                   backbufseg,zbufseg);}
          asm
           push word ptr upl3d+2;
           push word ptr upl3d;
           push word ptr upl2d+2;
           push word ptr upl2d;
           les si,upcl
           push word ptr es:[si]
           push word ptr es:[si+2]
           push word ptr es:[si+4]
           push word ptr backbufseg
           push word ptr zbufseg
           call filltriangle_zbuf_guro
          end;

        inc(laga(upl3d).ofs,6*3);
        inc(laga(upl2d).ofs,4*3);
        inc(laga(upcl).ofs,2*3);
      end;

   end;
  move(mem[backbufseg:0],mem[$a000:0],64000);
  incangles(addr(observer),round(1.5*1444/200*(timercounter-t)),0,0);
  while palettecounter>0 do;
 until (keytouch) and (palettecounter=0);

 asm
  mov ax,3
  int 10h
 end;

 writeln('27.01.96');
 writeln('Done by Lout Roman & Babich Eugen');
 writeln('for  Eugene Krashtan`s Birthday.');
 writeln;

 asm
  mov ax,0c0bh
  int 21h
 end;
end.