Unit GeomLIB;

INTERFACE

 Procedure crossing;
 Function  Crossing1 (Line1,Line1,Cross: Pointer): Boolean;
 procedure crossing2(line1,line2,cross: pointer);
 Function  Inbar (Poly,Point : Pointer): Boolean;
 Function  CrossBars(Poly1,Poly2: Pointer): Boolean;
 function getspline(p: pointer; t: longint; tmax: word): LongInt;
 Procedure StosWord (P: Pointer;  W,Count: Word);

 Function  Visible (Poly: Pointer): Boolean;

IMPLEMENTATION

{$F+}
 Procedure crossing; external;
 Function Crossing1 (Line1,Line1,Cross: Pointer): Boolean; External;
 Function  Inbar (Poly,Point : Pointer): Boolean; External;
 Function  CrossBars(Poly1,Poly2: Pointer): Boolean; External;
 Function  visible(Poly: Pointer): Boolean; External;
 Procedure StosWord (P: Pointer;  W,Count: Word); External;

{$F-}
{$L GeomLIB}

function getspline(p: pointer; t: longint; tmax: word): LongInt;
type
 intar = array [0..30000] of integer;
 laga = record
         ofs,seg: word;
        end;
var
 ti,xp0,xp1,xp2,xp3,xp4,xp5: longint;
 tr,x01,x12,x23,x34,x45,x012,x123,x234,x345,x0123,x1234,x2345,x01234,x12345,x012345: real;

label l1;
begin
if (tmax<3) or (t<0) or (laga(t).seg>tmax) then
  begin
   getspline:=0;
   goto l1;
  end;

ti:=laga(t).seg;

if (ti<2) then xp0:=intar(p^)[0]
          else xp0:=intar(p^)[ti-2];

if (ti<1) then xp1:=intar(p^)[0]
          else xp1:=intar(p^)[ti-1];

xp2:=intar(p^)[ti];

if (ti+1>tmax) then xp3:=intar(p^)[tmax]
               else xp3:=intar(p^)[ti+1];

if (ti+2>tmax) then xp4:=intar(p^)[tmax]
               else xp4:=intar(p^)[ti+2];

if (ti+3>tmax) then xp5:=intar(p^)[tmax]
               else xp5:=intar(p^)[ti+3];

laga(t).seg:=2;
tr:=t/65536;

x01:=(tr*xp1-(tr-1)*xp0);
x12:=((tr-1)*xp2-(tr-2)*xp1);
x23:=((tr-2)*xp3-(tr-3)*xp2);
x34:=((tr-3)*xp4-(tr-4)*xp3);
x45:=((tr-4)*xp5-(tr-5)*xp4);

x012:=(tr*x12-(tr-2)*x01)/2;
x123:=((tr-1)*x23-(tr-3)*x12)/2;
x234:=((tr-2)*x34-(tr-4)*x23)/2;
x345:=((tr-3)*x45-(tr-5)*x34)/2;

x0123:=(tr*x123-(tr-3)*x012)/3;
x1234:=((tr-1)*x234-(tr-4)*x123)/3;
x2345:=((tr-2)*x345-(tr-5)*x234)/3;

x01234:=(tr*x1234-(tr-4)*x0123)/4;
x12345:=((tr-1)*x2345-(tr-5)*x1234)/4;

x012345:=(tr*x12345-(tr-5)*x01234)/5;

getspline:=round(x012345*65536);
l1:
end;

procedure crossing2(line1,line2,cross: pointer);
type
 line2d = array [1..2,1..2] of integer;
var
 A1,A2,B1,B2,C1,C2,D1,D2,S1,S2,DM1,DM2,DM3,t1,t2 : real;

begin
{================================================================
   뢠 ࠢﬨ

 / x1 = A1 + B1*t1      / x2 = A2 + B2*t2
 \ y1 = C1 + D1*t1      \ y2 = C2 + D2*t2

  

    A = X1   B = X2 - X1   (१ ᮥ 窨 (X1,Y1),(X2,Y2)
    C = Y1   D = Y2 - Y1

  祭 ࠬ t  窨 祭   
  ⥬ ࠢ

   / A1 + B1*t1 = A2 + B2*t2
   \ C1 + D1*t1 = C2 + D2*t2

   蠥 ⥬:

   / B1*t1 - B2*t2 = A2 - A1
   \ D1*t1 - D2*t2 = C2 - C1

     S1 = A2 - A1
     S2 = C2 - C1

           | B1  -B2 |
     DM1 = |         | = -D2*B1 + D1*B2
           | D1  -D2 |

     ᫨ DM1 = 0 㤥   祭 ,    
       १ ࠫ  室   אַ 
     ᮢ.

           | S1  -B2 |
     DM2 = |         | = -S1*D2 + S2*B2
           | S2  -D2 |

           | B1   S1 |
     DM3 = |         | = S2*B1 - S1*D1
           | D1   S2 |

           DM2             DM3
     t1 = -----      t2 = -----
           DM1             DM1

     ᫨ (t1=>0)  (t1<=1)  (t2>=0)  (t2<=1)  १ ᥪ.
      न 窨 祭:

     Xc = A1 + B1*t1
     Yc = C1 + D1*t1

 ==========================================================================}

 A1:=line2d(line1^)[1,1];
 A2:=line2d(line2^)[1,1];
 C1:=line2d(line1^)[1,2];
 C2:=line2d(line2^)[1,2];

 B1:=line2d(line1^)[2,1]-line2d(line1^)[1,1];
 B2:=line2d(line2^)[2,1]-line2d(line2^)[1,1];
 D1:=line2d(line1^)[2,2]-line2d(line1^)[1,2];
 D2:=line2d(line2^)[2,2]-line2d(line2^)[1,2];


 S1:=A2 - A1;
 S2:=C2 - C1;

 DM1 := -D2*B1 + D1*B2;

 DM2 := -S1*D2 + S2*B2;

 t1 := DM2/DM1;

 line2d(cross^)[1,1]:=round(A1+B1*t1);
 line2d(cross^)[1,2]:=round(C1+D1*t1);
end;

(*
function crossing(line1,line2: pointer): Boolean;
{ ===============================================================
   TRUE, ᫨ 2 १, ᮥ騥 窨 point11-point12 
   point21-point22  ᪮ ᥪ. न 窨
   祭  ⮬ 砥   cross.
  ===============================================================}
type
 line2d = array [1..2,1..2] of integer;
var
 A1,A2,B1,B2,C1,C2,D1,D2,S1,S2,DM1,DM2,DM3,t1,t2 : real;

label l1,l2;

begin
{================================================================
   뢠 ࠢﬨ

 / x1 = A1 + B1*t1      / x2 = A2 + B2*t2
 \ y1 = C1 + D1*t1      \ y2 = C2 + D2*t2

  

    A = X1   B = X2 - X1   (१ ᮥ 窨 (X1,Y1),(X2,Y2)
    C = Y1   D = Y2 - Y1

  祭 ࠬ t  窨 祭   
  ⥬ ࠢ

   / A1 + B1*t1 = A2 + B2*t2
   \ C1 + D1*t1 = C2 + D2*t2

   蠥 ⥬:

   / B1*t1 - B2*t2 = A2 - A1
   \ D1*t1 - D2*t2 = C2 - C1

     S1 = A2 - A1
     S2 = C2 - C1

           | B1  -B2 |
     DM1 = |         | = -D2*B1 + D1*B2
           | D1  -D2 |

     ᫨ DM1 = 0 㤥   祭 ,    
       १ ࠫ  室   אַ 
     ᮢ.

           | S1  -B2 |
     DM2 = |         | = -S1*D2 + S2*B2
           | S2  -D2 |

           | B1   S1 |
     DM3 = |         | = S2*B1 - S1*D1
           | D1   S2 |

           DM2             DM3
     t1 = -----      t2 = -----
           DM1             DM1

     ᫨ (t1=>0)  (t1<=1)  (t2>=0)  (t2<=1)  १ ᥪ.
      न 窨 祭:

     Xc = A1 + B1*t1
     Yc = C1 + D1*t1

 ==========================================================================}

 A1:=line2d(line1^)[1,1];
 A2:=line2d(line2^)[1,1];
 C1:=line2d(line1^)[1,2];
 C2:=line2d(line2^)[1,2];

 B1:=line2d(line1^)[2,1]-line2d(line1^)[1,1];
 B2:=line2d(line2^)[2,1]-line2d(line2^)[1,1];
 D1:=line2d(line1^)[2,2]-line2d(line1^)[1,2];
 D2:=line2d(line2^)[2,2]-line2d(line2^)[1,2];


 S1:=A2 - A1;
 S2:=C2 - C1;

 DM1 := -D2*B1 + D1*B2;

 if DM1=0 then
    begin
     l2:
     crossing:=False;
     goto l1;
    end;

 DM2 := -S1*D2 + S2*B2;
 DM3 :=  S2*B1 - S1*D1;

 t1 := DM2/DM1;

 if (t1<0) or (t1>1) then goto l2;

 t2 := DM3/DM1;

 if (t2<0) or (t2>1) then goto l2;

 crossing:=true;

l1:
end;

function inbar(poly: pointer; point: pointer): boolean;
{==============================================================
  TRUE ᫨ 窠   嬥୮ 䨣, ࠭祭
  १ (poly).    㪫.
 ==============================================================}
type xy = record
           x,y: integer;
          end;
type
 poly4 = array [1..4] of xy;
var
 count: integer;
 m,n,m1,n1 : integer;
begin
 count:=0;
 m:=poly4(poly^)[2].x-poly4(poly^)[1].x;
 n:=poly4(poly^)[2].y-poly4(poly^)[1].y;

 m1:=poly4(point^)[1].x-poly4(poly^)[1].x;
 n1:=poly4(point^)[1].y-poly4(poly^)[1].y;

 if m*n1-n*m1>0 then inc(count) else dec(count);

 m:=poly4(poly^)[3].x-poly4(poly^)[2].x;
 n:=poly4(poly^)[3].y-poly4(poly^)[2].y;

 m1:=poly4(point^)[1].x-poly4(poly^)[2].x;
 n1:=poly4(point^)[1].y-poly4(poly^)[2].y;

 if m*n1-n*m1>0 then inc(count) else dec(count);

 m:=poly4(poly^)[4].x-poly4(poly^)[3].x;
 n:=poly4(poly^)[4].y-poly4(poly^)[3].y;

 m1:=poly4(point^)[1].x-poly4(poly^)[3].x;
 n1:=poly4(point^)[1].y-poly4(poly^)[3].y;

 if m*n1-n*m1>0 then inc(count) else dec(count);

 m:=poly4(poly^)[1].x-poly4(poly^)[4].x;
 n:=poly4(poly^)[1].y-poly4(poly^)[4].y;

 m1:=poly4(point^)[1].x-poly4(poly^)[4].x;
 n1:=poly4(point^)[1].y-poly4(poly^)[4].y;

 if m*n1-n*m1>0 then inc(count) else dec(count);

 if abs(count)=4 then inbar:=true else inbaR:=false;
end;

function crossbars_p(poly1,poly2: pointer): Boolean;
{===========================================================
   True, ᫨ 嬥 㪫 䨣 poly1  poly2
    騥 窨
 ===========================================================}
var
 i,j: integer;
 polyd1,polyd2 : array [1..5,1..2] of integer;

 label l1;

begin
crossbars_p:=true;

move(poly1^,addr(polyd1)^,2*2*4);
move(poly2^,addr(polyd2)^,2*2*4);

polyd1[5]:=polyd1[1];
polyd2[5]:=polyd2[1];

for i:=1 to 4 do
  for j:=1 to 4 do
    if crossing(addr(polyd1[i]),addr(polyd2[j])) then goto l1;

if inbar(addr(polyd1),addr(polyd2)) then goto l1;

if inbar(addr(polyd2),addr(polyd1)) then goto l1;

crossbars_p:=false;
l1:
end;
*)

begin
end.