Unit GuroFill;

INTERFACE

 Const
  kr        : Byte = 128;
  kd        : Byte = 127;
  ls_normal : Array [1..3] of Integer = (42,-110,50);

 Var
  { ==== data for shading procedures ====}

  s_poly2d : Array [1..6,1..2] of Integer;
  s_poly3d : Array [1..6,1..3] of Integer;
  s_polybmp: Array [1..6,1..2] of byte;
  s_colors : Array [1..6] of word;

  s_leftx  : Array [0..199] of Integer;
  s_leftz  : Array [0..199] of Integer;
  s_rightx : Array [0..199] of Integer;
  s_rightz : Array [0..199] of Integer;
  s_leftc  : Array [0..199] of Word;
  s_rightc : Array [0..199] of Word;
  s_left_bmpxy  : Array [0..199] of word;
  s_right_bmpxy : Array [0..199] of word;

 {$IFNDEF DPMI}
  s_itblseg : word;

  s_scrbuf1seg: word;
  s_zbuf1seg: word;
  s_bmpseg : word;
 {$ELSE}
  s_scrbuf1seg: word;
  s_scrbuf2seg: word;
  s_zbuf1seg: word;
  s_zbuf2seg: word;
  s_bmpseg : word;
 {$ENDIF}

 Function  GetColor (P: Pointer): word;
 Procedure StosWord (P: Pointer;  W,Count: Word);
 Procedure MoveDwords (Source,Dest: Pointer; Count: Word);
 Procedure UnPackTriangle(n: Word; Vid3d,Points2D,Cross_Ref,Colors_p,
               Poly_3D,Poly_2D,Colors3: Pointer);
 Procedure CalcColors(NPoints: Word; Normals_p,Colors_p: Pointer);
 Procedure InitZBuf(ZBufSeg: word);
 Procedure guro_simple;
 Procedure Visible2;

{$IFNDEF DPMI}
 Procedure FillTriangle_Zbuf_Guro (Poly3d,Poly2d: Pointer;
               Color1,Color2,Color3: word; ScrSEG,ZbufSEG: Word);
 Procedure Texturemap(scrbuf,zbufseg,bmpbuf: word);
 Procedure Texturemap_guro(scrbuf,zbufseg,bmpbuf: word);
 Procedure Texturemap_guro4(scrbuf,zbufseg,bmpbuf: word);
 Procedure Texturemap_guro5(scrbuf,zbufseg,bmpbuf: word);
 Procedure Texturemap_flat(scrbuf,zbufseg,bmpbuf: word);
 Procedure Texturemap_flat4(scrbuf,zbufseg,bmpbuf: word);
 Procedure Texturemap_flat5(scrbuf,zbufseg,bmpbuf: word);
 Procedure Texturemap_Simple;
{$ELSE}
 Procedure Texturemap_flat;
 Procedure Texturemap_flat4;
 Procedure Texturemap_flat5;
 Procedure Texturemap;
 Procedure CopyToScreen_prot;
 Procedure Initzbuf_prot;
 Procedure Clearscreen_prot;
 Procedure Texturemap_Guro;
 Procedure Texturemap_Guro4;
 Procedure Texturemap_Guro5;
{$ENDIF}

IMPLEMENTATION

 var
  csalias: word;

{$F+}
 Function  GetColor (P: Pointer): word;                     External;
 Procedure StosWord (P: Pointer;  W,Count: Word);           External;
 Procedure MoveDwords (Source,Dest: Pointer; Count: Word);  External;
 Procedure UnPackTriangle(n: Word; Vid3d,Points2D,Cross_Ref,Colors_p,
               Poly_3D,Poly_2D,Colors3: Pointer);           External;
 Procedure CalcColors(NPoints: Word; Normals_p,Colors_p: Pointer); EXternal;
 Procedure InitZBuf(ZBufSeg: word); External;
 Procedure guro_simple; External;
 Procedure Visible2; External;

{$IFNDEF DPMI}
 Procedure FillTriangle_Zbuf_Guro (Poly3d,Poly2d: Pointer;
               Color1,Color2,Color3: word;
               ScrSEG,ZbufSEG: Word);                       External;
 Procedure Texturemap(scrbuf,zbufseg,bmpbuf: word); External;
 Procedure Texturemap_guro(scrbuf,zbufseg,bmpbuf: word); External;
 Procedure Texturemap_guro4(scrbuf,zbufseg,bmpbuf: word); External;
 Procedure Texturemap_guro5(scrbuf,zbufseg,bmpbuf: word); External;
 Procedure Texturemap_flat(scrbuf,zbufseg,bmpbuf: word); External;
 Procedure Texturemap_flat4(scrbuf,zbufseg,bmpbuf: word); External;
 Procedure Texturemap_flat5(scrbuf,zbufseg,bmpbuf: word); External;
 Procedure Texturemap_Simple; External;
{$ELSE}
 Procedure Texturemap_flat; External;
 Procedure Texturemap_flat4; External;
 Procedure Texturemap_flat5; External;
 Procedure Texturemap; External;
 Procedure Texturemap_Simple; External;
 Procedure CopyToScreen_prot; External;
 Procedure Initzbuf_prot; External;
 Procedure Clearscreen_prot; External;
 Procedure Texturemap_Guro; External;
 Procedure Texturemap_Guro4; External;
 Procedure Texturemap_Guro5; External;
{$ENDIF}

{$F-}
{$L GuroFILL}

{$IFNDEF DPMI}
 {$L Textmap}
 {$L textmaps}
{$ELSE}
 {$L Textmap_}
 {$L textmaps}
{$ENDIF}

begin
{$IFDEF DPMI}
 csalias:=cseg+selectorinc;
{$ELSE}
 csalias:=cseg;
{$ENDIF}
end.