unit loadasc;

INTERFACE

uses crt;

type
 VertexArrType  = array [1..10000,1..3] of integer;
 FacesArrType   = array [1..10000,1..3] of word;
 obj_namesarr   = array [1..100] of string;
 FaceBmpXYarrtype   = array [1..1000,1..3] of word;
 VertexBmpXYarrtype   = array [1..3000] of word;

 laga = record
          ofs,seg: word
        end;

function LoadAscFile (fname,obj_name: string;
   var obj_nfaces,obj_nvertices: word;
   var obj_faces_p,obj_vertices_p,obj_bmpxy_p: pointer;
   maxnfaces,maxnvertices: word;
   koef: real): integer;

procedure loadasclist(fname: string; obj_names_p: pointer;
        var nnames: word;
        maxnnames: word);

IMPLEMENTATION

function getnextline(var ft:text): string;
var
 s: string;
 label l1,l2;
begin
 l1:
 if eof(ft) then
   begin
    s:='';
    goto l2;
   end;
 readln(ft,s);
 while (length(s)>0) and (s[1]=' ') do s:=copy(s,2,255);
 if s='' then goto l1;
 if copy(s,1,4)='Page' then goto l1;
 l2:
 getnextline:=s;
end;

function LoadAscFile (fname,obj_name: string;
   var obj_nfaces,obj_nvertices: word;
   var obj_faces_p,obj_vertices_p,obj_bmpxy_p: pointer;
   maxnfaces,maxnvertices: word;
   koef: real): integer;
var
 ft: text;
 s,s1,s2,s3 : string;
 i,j: integer;
 nvertices,nfaces: word;
 curvertex,curface: word;
 r: real;
 mapped : boolean;
 vertex_bmpxy_p : ^vertexbmpxyarrtype;
 label l1,l2,l3,l4,l5;
begin
 loadascfile:=-1;
 writeln('Loading ASC file "',fname,'"');

 mapped:=false;

 assign(ft,fname); reset(ft);

 while not eof (ft) do
   begin
    s:=getnextline(ft);

    if copy(s,1,12)='Named object' then
      begin
       s1:=getnextline(ft);
       if copy (s1,1,19)<>'Tri-mesh, Vertices:' then
            begin
            l5:
             writeln('Skiped "',s);
             writeln('        ',s1);
             goto l1;
            end;
       s:=copy(s,15,255);

       if obj_name<>s then goto l5;
       writeln('Loading object: ',s);
       writeln('        ',s1);

       s1:=copy(s1,21,255);
       i:=1;
       while s1[i] in ['0'..'9'] do inc(i);
       s2:=copy(s1,1,i-1);
       val(s2,nvertices,i);
       i:=1;
       while s1[i]<>'F' do inc(i);
       s1:=copy(s1,i+7,255);
       val(s1,nfaces,i);

       obj_nfaces:=nfaces;
       obj_nvertices:=nvertices;

       if obj_nfaces>maxnfaces then
          begin
           writeln ('------ too many faces ! (skiped)');
           goto l1;
          end;

       if obj_nvertices>maxnvertices then
          begin
           writeln ('------ too many vertices ! (skiped)');
           goto l1;
          end;

       getmem(obj_vertices_p,nvertices*3*2);
       getmem(obj_faces_p,nfaces*3*2);
       getmem(obj_bmpxy_p,nfaces*3*2);
       getmem(vertex_bmpxy_p,nvertices*2);

       writeln('        Loading vertex list');
       s:=getnextline(ft);
       if s='Mapped' then
         begin
          writeln(' Mapped !');
          s:=getnextline(ft);
          mapped:=true;
         end;

       for curvertex:=1 to nvertices do
         begin
          write('        Vertex: ',curvertex,#13);
          l2:
          s:=getnextline(ft);
          if copy(s,1,6)<>'Vertex' then goto l2;

          i:=6;
          while s[i]<>':' do inc(i);
          inc(i);

          while s[i]<>':' do inc(i);
          inc(i);
          while s[i]=' ' do inc(i);
          s:=copy(s,i,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val (s1,r,i);
          vertexarrtype(obj_vertices_p^)[curvertex,1]:=round(r*koef);

          i:=1;
          while s[i]<>':' do inc(i);
          inc(i);
          while s[i]=' ' do inc(i);
          s:=copy(s,i,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val(s1,r,i);
          vertexarrtype(obj_vertices_p^)[curvertex,2]:=round(r*koef);

          i:=1;
          while s[i]<>':' do inc(i);
          inc(i);
          while s[i]=' ' do inc(i);
          s:=copy(s,i,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val(s1,r,i);
          vertexarrtype(obj_vertices_p^)[curvertex,3]:=round(r*koef);

          if mapped  then
           begin
            {== U ==}
            i:=1;
            while s[i]<>':' do inc(i);
            inc(i);
            while s[i]=' ' do inc(i);
            s:=copy(s,i,255);
            i:=1;
            while s[i]<>' ' do inc(i);
            s1:=copy(s,1,i-1);
            val(s1,r,i);

            r:=r*255;
{            if r<0 then r:=0;
            if r>255 then r:=255;}
            while r<0 do r:=r+256;
            while r>255 do r:=r-256;

            vertex_bmpxy_p^[curvertex]:=round(r);

            {== V ==}
            i:=1;
            while s[i]<>':' do inc(i);
            inc(i);
            while s[i]=' ' do inc(i);
            s:=copy(s,i,255);
            i:=1;
            while s[i]<>' ' do inc(i);
            s1:=copy(s,1,i-1);
            val(s1,r,i);

            r:=r*255;
{            if r<0 then r:=0;
            if r>255 then r:=255;}
            while r<0 do r:=r+256;
            while r>255 do r:=r-256;

            r:=255-r;
            inc(vertex_bmpxy_p^[curvertex],256*round(r));
           end
               else
           begin
            vertex_bmpxy_p^[curvertex]:=0;
           end;
         end;

       writeln;
       writeln('        Loading Face list');
       s:=getnextline(ft);

       for curface:=1 to nfaces do
         begin
          write('        Face: ',curface,#13);
          l3:
          s:=getnextline(ft);
          if copy(s,1,4)<>'Face' then goto l3;

{          writeln(s);}
          i:=4;
          while s[i]<>':' do inc(i);
          inc(i);
          while s[i]<>':' do inc(i);
          s:=copy(s,i+1,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val (s1,r,i);

{          writeln(s1);
          writeln(r);}

          facesarrtype(obj_faces_p^)[curface,1]:=round(r)+1;
          facebmpxyarrtype(obj_bmpxy_p^)[curface,1]:=
                    vertex_bmpxy_p^[round(r)+1];

          while s[i]<>':' do inc(i);
          s:=copy(s,i+1,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val(s1,r,i);
{          writeln(s1);
          writeln(r);}

          facesarrtype(obj_faces_p^)[curface,2]:=round(r)+1;
          facebmpxyarrtype(obj_bmpxy_p^)[curface,2]:=
                    vertex_bmpxy_p^[round(r)+1];

          while s[i]<>':' do inc(i);
          s:=copy(s,i+1,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val(s1,r,i);
{          writeln(s1);
          writeln(r);}

          facesarrtype(obj_faces_p^)[curface,3]:=round(r)+1;
          facebmpxyarrtype(obj_bmpxy_p^)[curface,3]:=
                    vertex_bmpxy_p^[round(r)+1];

         end;
       writeln;
       loadascfile:=0;
       goto l4;
      end;
    l1:
   end;
l4:
 freemem(vertex_bmpxy_p,nvertices*2);
 close(ft);
 writeln('Ok');
 writeln;
end;

procedure loadasclist(fname: string; obj_names_p: pointer;
        var nnames: word;
        maxnnames: word);
var
 i: integer;
 ft: text;
 s,s1: string;
 label l1,l2;
begin
 nnames:=0;
 assign(ft,fname); reset(ft);

 while not eof (ft) do
   begin
    s:=getnextline(ft);

    if copy(s,1,12)='Named object' then
      begin
       s1:=getnextline(ft);
       if copy (s1,1,19)<>'Tri-mesh, Vertices:' then goto l1;
       s:=copy(s,15,255);

       inc(nnames);
       obj_namesarr(obj_names_p^)[nnames]:=s;
       if nnames=maxnnames then goto l2;
      end;
    l1:
   end;
 l2:
 close(ft);
end;


begin
end.