uses crt,mode256,loadpcx,realtime,tpalloc;

type
 laga = record
    ofs,seg: word;
        end;

 const
  Rweigth = 30;
  Gweigth = 59;
  Bweigth = 11;
  directory : string='';
var
 palette1: array [0..255,1..3] of byte;
 bufseg: word;
 p: pointer;
 k : real;
 c1r,c1b,c1g,c2r,c2b,c2g: integer;
 ofs: word;
 i,j,m,n,o: word;
 d1,d2,d,dmin: longint;

 decodetbl : array [0..255] of byte;
 f: file;

 bigarrayp: pointer;

 label l1;

function bigarray(r,g,b: word): pointer;
begin
 bigarray:=ptr(laga(bigarrayp).seg+1+r*256,g*64+b);
end;

procedure incbigarr(fname: string);
var
 i: integer;
begin
 writeln('Processing "',fname,'":');
 if loadpcx_pal(fname,addr(palette1))>0 then
   begin
    writeln;
    writeln('Can`t open "',fname,'"');
    halt;
   end;

 write(' - analising palette...     ');

 for i:=0 to 255 do
  begin
  write(#8,#8,#8,#8,(i*100 div 255):3,'%');
  for j:=0 to 255 do
    begin
       if (palette1[i,1]=palette1[j,1]) and
        (palette1[i,2]=palette1[j,2]) and
        (palette1[i,3]=palette1[j,3]) and (i<>j) then
       begin
        palette1[i,1]:=0;
        palette1[i,2]:=0;
        palette1[i,3]:=0;
       end;
    end;
   end;

 writeln;
 write(' - encounting colors usage...     ');

for o:=0 to 63 do
{for o:=$1f to $1f do}
begin
 write(#8,#8,#8,#8,(o*100 div 63):3,'%');
 if o<$20 then
    k:=0.2+(1-0.2)*o/$20
          else
    k:=0+(0.6-0)*(o-$20)/$20;
    k:=o/55;

  for i:=0 to 255 do
    begin
    {if o<$20 then
     begin
      c2r:=round(palette1[i,1]*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette1[i,2]*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette1[i,3]*k);
      if c2b>63 then c2b:=63;
     end
      else
     begin
      c2r:=round(palette1[i,1]+(63-palette1[i,1])*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette1[i,2]+(63-palette1[i,2])*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette1[i,3]+(63-palette1[i,3])*k);
      if c2b>63 then c2b:=63;
     end;}

      c2r:=round(palette1[i,1]*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette1[i,2]*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette1[i,3]*k);
      if c2b>63 then c2b:=63;

     inc(byte(bigarray(c2r,c2g,c2b)^));
   end;
 end;
writeln;
end;

procedure genpalette;
begin
 write('Generating palette...        ');
 byte(bigarray(0,0,0)^):=0;

 for i:=255 downto 1 do
   begin
   write(#8,#8,#8,#8,#8,#8,#8,(255+1-i):3,'/255');
    dmin:=0;
{    for c1r:=0 to 63 do
     for c1g:=0 to 63 do
      for c1b:=0 to 63 do
        if byte(bigarray(c1r,c1g,c1b)^)>dmin then
          begin
           dmin:=byte(bigarray(c1r,c1g,c1b)^);
           c2r:=c1r;
           c2g:=c1g;
           c2b:=c1b;
          end;}


    for c1r:=0 to 63 do
     begin
      p:=bigarray(c1r,0,0);
     for c1g:=0 to 63 do
        asm
         les di,p
         mov al,byte ptr dmin
         cld
         mov cx,64

         @l1:
         scasb
         jc @l2
         @l5:
         dec cx
         jnz @l1
         mov word ptr p,di
         jmp @l3

         @l2:
         mov al,es:[di-1]
         mov byte ptr dmin,al
         mov ax,c1r
         mov c2r,ax
         mov ax,c1g
         mov c2g,ax
         mov ax,64
         sub ax,cx
         mov c2b,ax
         jmp @l5
         @l3:
        end;
     end;
    byte(bigarray(c2r,c2g,c2b)^):=0;
    if dmin=0 then
      begin
       c2r:=0;
       c2g:=0;
       c2b:=0;
      end;
    palette1[i,1]:=c2r;
    palette1[i,2]:=c2g;
    palette1[i,3]:=c2b;
   end;

 palette1[0,1]:=0;
 palette1[0,2]:=0;
 palette1[0,3]:=0;
 writeln;
end;

procedure sortpalette;
begin
 write('Sorting palette...     ');
 for i:=0 to 255 do
  begin
   write(#8,#8,#8,#8,(i*100 div 255):3,'%');
   d1:=palette1[i,1]*Rweigth+palette1[i,2]*Gweigth+palette1[i,3]*Bweigth;
   for j:=i+1 to 255 do
     begin
      d2:=palette1[j,1]*Rweigth+palette1[j,2]*Gweigth+palette1[j,3]*Bweigth;
      if d2<d1 then
        begin
         c1r:=palette1[i,1];
         c1g:=palette1[i,2];
         c1b:=palette1[i,3];
         palette1[i,1]:=palette1[j,1];
         palette1[i,2]:=palette1[j,2];
         palette1[i,3]:=palette1[j,3];
         palette1[j,1]:=c1r;
         palette1[j,2]:=c1g;
         palette1[j,3]:=c1b;
         d1:=palette1[i,1]*Rweigth+palette1[i,2]*Gweigth+palette1[i,3]*Bweigth;
        end;
     end;
  end;

writeln;
end;

procedure writepalette;
var
 f: file;
 palette2: array [0..255,1..3] of byte;
begin
 writeln('Updating "universl.pcx"');

 for i:=0 to 255 do
   begin
    palette2[i,1]:=palette1[i,1]*4;
    palette2[i,2]:=palette1[i,2]*4;
    palette2[i,3]:=palette1[i,3]*4;
   end;

 assign(f,directory+'universl.pcx'); reset(f,1);
 seek(f,filesize(f)-768);
 blockwrite(f,palette2,768);
 close(f);
end;

begin

 writeln;
 writeln('Phase I - generating universal palette');
 writeln;
 writeln('Allocating memory...');
 getmem(p,64000+32);
 bufseg:=laga(p).seg+1;

 hugegetmem(bigarrayp,64*64*64+32);
 if bigarrayp=nil then
   begin
    writeln('Not enougth memory');
    halt;
   end;

 writeln('Initialising array...');
(*
 for c1r:=0 to 63 do
   for c1g:=0 to 63 do
      for c1b:=0 to 63 do
        byte(bigarray(c1r,c1g,c1b)^):=0;

{ incbigarr(directory+'leprdcub.pcx');}
 incbigarr(paramstr(1));

 genpalette;

 sortpalette;
 writepalette;          *)

 setgfxmode;
 loadpcx_raw_pal(directory+'universl.pcx',ptr(bufseg,0),addr(palette1));
 setpalette(addr(palette1));
 move(mem[bufseg:0],mem[$a000:0],64000);
 directvideo:=false;
 textattr:=$70;
 gotoxy(1,22);
 write('Generating i_table.dat from universl.pcx');

 assign(f,directory+'i_table.dat'); rewrite(f,1);

for o:=0 to 63 do
begin
 gotoxy(1,22);
 writeln('Phase ][:');
 write(' generating "i_table.dat" ',(o*100 div 63):3,'%');
 if o<$20 then
    k:=0.2+(1-0.2)*o/$20
          else
    k:=0+(0.3-0)*(o-$20)/$20;

  k:=o/55;

  for i:=0 to 255 do
    begin
{    if o<$20 then
     begin
      c2r:=round(palette1[i,1]*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette1[i,2]*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette1[i,3]*k);
      if c2b>63 then c2b:=63;
     end
      else
     begin
      c2r:=round(palette1[i,1]+(63-palette1[i,1])*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette1[i,2]+(63-palette1[i,2])*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette1[i,3]+(63-palette1[i,3])*k);
      if c2b>63 then c2b:=63;
     end;}

      c2r:=round(palette1[i,1]*k);
      if c2r>63 then c2r:=63;
      c2g:=round(palette1[i,2]*k);
      if c2g>63 then c2g:=63;
      c2b:=round(palette1[i,3]*k);
      if c2b>63 then c2b:=63;
     dmin:=999999999;
     for j:=0 to 255 do
       begin
        asm
         mov ax,j
         mov si,ax
         shl ax,1
         add si,ax
         add si,offset palette1
         cld

         lodsb
         xor ah,ah
         sub ax,c2r
         imul ax
         mov  cx,30
         mul  cx
         mov word ptr d,ax
         mov word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2g
         imul ax
         mov cx,59
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx

         lodsb
         xor ah,ah
         sub ax,c2b
         imul ax
         mov cx,11
         mul cx
         add word ptr d,ax
         adc word ptr d+2,dx
        end;

        if d<dmin then
          begin
           dmin:=d;
           m:=j;
          end;
       end;
     decodetbl[i]:=m;
    end;

 if keypressed then halt;

 asm
  lea bx,decodetbl
  xor di,di
  cld
  mov cx,32000
  mov dx,0a000h
  mov si,bufseg

  @l1:
  mov es,si
  mov al,es:[di]
  xlat
  mov es,dx
  stosb
  mov es,si
  mov al,es:[di]
  xlat
  mov es,dx
  stosb
  dec cx
  jne @l1
 end;
{   gotoxy(1,1); write(k:1:3);}
 blockwrite(f,decodetbl,256);
end;
close(f);
textmode(3);
end.

