USES XLIB2,crt,xmisc2,cputype;

type
 laga = record
  ofs,seg: word;
  end;

const
 textx : integer = 0;
 texty : integer = 0;

 irqtable : array [0..9] of byte = (15,2,3,4,5,7,9,10,11,12);
 dmatable : array [1..6] of byte = (0,1,3,5,6,7);
 freqtable : array [1..7] of word = (8000,11025,16000,22050,32000,38000,44100);

var
 font: pointer;
 xmsapi : longint;

 vesainfo : record
              sign: array [1..4] of byte;
              versionlo: byte;
              versionhi: byte;
              ptreom: pointer;
              other : array [1..1218] of byte;
              present: boolean;
             end;

 timercounter: longint absolute 0:$46c;

 c:char;

 midasconfig : record
                 cardno,cardtype,cardport,cardirq,carddma,cardfreq,cardmode:word
               end;

 f:file;

procedure font_prog; external;
{$L c:\bp\xlibp202\fonts\crisp6x9}

procedure failexit;
begin
 while keypressed do readkey;
 xtextmode;
 writeln('Setup program was aborted.');
 writeln;
 halt(1);
end;

procedure coolprint(s:string);
var
 i: integer;
begin
 for i:=1 to length(s) do
   begin
    xbgprintf(textx,texty,0,10,0,s[i]);
{    sound(1000+random(1000));}
    delay(20);
{    nosound;}
    xbgprintf(textx,texty,0,2,0,s[i]);
    inc(textx,xstrwidth(s[i]));
   end;
 if keypressed then
  if readkey=#27 then failexit;
end;

procedure coolerprint(s:string);
var
 i: integer;
begin
 for i:=1 to length(s) do
   begin
    xbgprintf(textx,texty,0,12,0,s[i]);
{    sound(random(3000));}
    delay(20);
{    nosound;}
    xbgprintf(textx,texty,0,4,0,s[i]);
    inc(textx,xstrwidth(s[i]));
   end;
end;

procedure blankcursor(n:integer);
begin
 while n>0 do
  begin
    xbgprintf(textx,texty,0,10,0,'_');
    delay(300);
    xbgprintf(textx,texty,0,0,0,'_');
    delay(300);
    dec(n);
  end;
end;

procedure printlf;
begin
 inc(texty,11);
 textx:=0;
end;

function int2str(i:longint): string;
var
 s: string;
begin
 str(i,s);
 int2str:=s;
end;

function gettotaldosmemory: word; assembler;
asm
 int 12h
end;

function xmsinstalled: boolean; assembler;
asm
 mov ax,4300h
 int 2fh
 mov ah,al
 xor al,al
 cmp ah,80h
 jne @l1
 mov al,0ffh
 @l1:
 push ax
 mov ax,4310h
 int 2fh
 mov word ptr xmsapi,bx
 mov word ptr xmsapi+2,es
 pop ax
end;

function getxmsversion: word; assembler;
asm
 mov ah,0
 call dword ptr xmsapi
end;

function getfreexmsmemory: word; assembler;
asm
 mov ah,8
 call dword ptr xmsapi
end;

procedure vesatest; assembler;
asm
 mov ax,4f00h
 mov di,ds
 mov es,di
 lea di,vesainfo
 int 10h
 mov al,ah
 not al
 jne @l1
 mov al,0
 cmp byte ptr vesainfo.sign,'V'
 jne @l1
 cmp byte ptr vesainfo.sign,'E'
 jne @l1
 cmp byte ptr vesainfo.sign,'S'
 jne @l1
 cmp byte ptr vesainfo.sign,'A'
 jne @l1
 mov al,0ffh
 @l1:
 mov byte ptr vesainfo.present,al
end;

function asciiz2str(p: pointer):string;
var
 s:string;
begin
 s:='';
 while (length(s)<30) and (byte(p^)<>0) do
   begin
    s:=s+char(p^);
    inc(laga(p).ofs);
   end;
 asciiz2str:=s;
end;

function inv86:boolean;assembler;
asm
 db 0fh,01,0e0h
 and al,1
 test al,1
 jz @l1
 mov al,0ffh
 @l1:
end;

procedure fadepalette;
var
 palette1,palette2: array [1..768] of byte;
 var
  t: longint;
  a:real;
begin
 t:=timercounter;
 xgetpalstruc(palette1,255,0);
 a:=255;

 while xcpcontrastpalstruc(palette1,palette2,round(a))>0 do
  begin
   xputpalstruc(palette2);
   a:=255-(timercounter-t)*2;
  end;

  xputpalstruc(palette2);
end;

procedure xclearscreen;
var
 i:integer;
begin
 while texty>=0 do
  begin
   i:=350;
   while i>=0 do
     begin
       xbgprintf(i,texty,0,0,10,' ');
       delay(1);
       xbgprintf(i,texty,0,0,0,' ');
       dec(i,3);
     end;
   xbgprintf(0,texty,0,0,0,' ');
   dec(texty,11);
  end;
textx:=0;
texty:=0;
end;

function my_cpu_typestr: string;
begin
 my_cpu_typestr:=cpu_typestr;
 if intcpuspeed>121 then my_cpu_typestr:='Am5x86';
end;

label l1,l2,l3,l4,l5,l6,l7,l8,l9;

begin
 vesatest;
 xsetmode(Xmode360x240,360);
 xtextinit;
 xregisteruserfont(@font_prog^);
 xsetfont(2);

 coolprint('Welcome to Nosferatu setup.');
 printlf;
 coolprint('-----------------------');
 printlf;
 blankcursor(4);
 printlf;

 coolprint('Analysing your computer...');
 blankcursor(4);

 printlf;
 coolprint('Main processor:  '+my_cpu_typestr+' '+int2str(intcpuspeed)+'MHz');
 printlf;
 if cpu_type<7 then
   begin
    coolerprint('You must have at least 386sx to run this demo ! ');
    printlf;
    coolerprint('Press any key to exit...');
    while not keypressed do blankcursor(1);
    failexit;
   end;
 if intcpuspeed<66 then
   begin
    coolerprint('Warning ! At least 486dx2-66 recomended ! ');
    blankcursor(4);
    printlf;
   end;
 if fputype=2 then
   begin
    coolerprint('Coprocessor: not detected ');
    printlf;
    coolerprint('You must have coprosessor to run this demo !');
    printlf;
    coolerprint('Press any key to exit...');
    while not keypressed do blankcursor(1);
    failexit;
   end;
 coolprint('Coprocessor:     '+copro_typestr);

 printlf;
 printlf;
 coolprint(int2str(gettotaldosmemory)+'K total DOS memory, ');
 coolprint(int2str(maxavail div 1024)+'K memory avaible');
 printlf;
 coolprint('XMS manager: ');
 if xmsinstalled then
   begin
    coolprint(' present,  version '+int2str(hi(getxmsversion))+'.'+int2str(lo(getxmsversion)));
    coolprint(',  '+int2str(getfreexmsmemory)+'K memory avaible');
   end
     else
   coolprint(' not present');
 printlf;
 printlf;

 if vesainfo.present then
   begin
    coolprint('Vesa version number:  '+int2str(vesainfo.versionhi)+'.'+int2str(vesainfo.versionlo));
    printlf;
    coolprint('Vendor:  '+asciiz2str(vesainfo.ptreom));

   end
     else
   coolprint('Vesa support: not installed');

 printlf;
 printlf;

 if inv86 then
   begin
    coolerprint('Warning ! Processor in V86 mode !');
    blankcursor(2);
    printlf;
    coolerprint('Runing under Windows, QEMM, EMM386 not recomended !');
    blankcursor(4);
    printlf;
    printlf;
   end;

 coolprint('Executing sound card selection menu...');
 blankcursor(4);

 fillchar(midasconfig,sizeof(midasconfig),$ff);
 xclearscreen;

 coolprint('Select sound card');
 printlf;
 coolprint('------------------');
 printlf;
 printlf;
 coolprint('1. Gravis ultra sound');
 printlf;
 coolprint('2. Sound Blaster 2.0');
 printlf;
 coolprint('3. Sound Blaster Pro');
 printlf;
 coolprint('4. Sound Blaster 16');
 printlf;
 coolprint('5. No Sound');
 printlf;
 printlf;
 coolprint('Enter your choise: ');

 l2:
 while not keypressed do blankcursor(1);
 c:=readkey;
 case c of
  #27: failexit;
  '1':begin
       midasconfig.cardno:=0;
       midasconfig.cardtype:=1;
       midasconfig.cardmode:=10;
      end;
  '2':begin
       midasconfig.cardno:=3;
       midasconfig.cardtype:=3;
       midasconfig.cardmode:=5;
      end;
  '3':begin
       midasconfig.cardno:=3;
       midasconfig.cardtype:=4;
       midasconfig.cardmode:=6;
      end;
  '4':begin
       midasconfig.cardno:=3;
       midasconfig.cardtype:=5;
       midasconfig.cardmode:=10;
      end;
  '5':begin
       midasconfig.cardno:=4;
       midasconfig.cardtype:=1;
      end;
 end;
 coolprint(c);
 blankcursor(2);

 if c='5' then goto l4;

 xclearscreen;

 coolprint('Select base port');
 printlf;
 coolprint('------------------');
 printlf;
 printlf;
 coolprint('1. 210h');
 printlf;
 coolprint('2. 220h');
 printlf;
 coolprint('3. 230h');
 printlf;
 coolprint('4. 240h');
 printlf;
 coolprint('5. 250h');
 printlf;
 coolprint('6. 260h');
 printlf;
 printlf;
 coolprint('Enter your choise: ');

 l3:
 while not keypressed do blankcursor(1);
 c:=readkey;
 if c=#27 then failexit;
 if not (c in['1'..'6']) then goto l3;
 coolprint(c);
 blankcursor(2);
 midasconfig.cardport:=$200+(ord(c)-ord('0'))*$10;

 if midasconfig.cardno=0 then goto l7;

 xclearscreen;

 coolprint('Select card IRQ');
 printlf;
 coolprint('------------------');
 printlf;
 printlf;
 coolprint('1. 2');
 printlf;
 coolprint('2. 3');
 printlf;
 coolprint('3. 4');
 printlf;
 coolprint('4. 5');
 printlf;
 coolprint('5. 7');
 printlf;
 coolprint('6. 9');
 printlf;
 coolprint('7. 10');
 printlf;
 coolprint('8. 11');
 printlf;
 coolprint('9. 12');
 printlf;
 coolprint('0. 15');
 printlf;
 printlf;
 coolprint('Enter your choise: ');

 l5:
 while not keypressed do blankcursor(1);
 c:=readkey;
 if c=#27 then failexit;
 if not (c in['0'..'9']) then goto l5;
 coolprint(c);
 blankcursor(2);
 midasconfig.cardirq:=irqtable[ord(c)-ord('0')];


 xclearscreen;

 coolprint('Select DMA chanel');
 printlf;
 coolprint('------------------');
 printlf;
 printlf;
 coolprint('1. 0');
 printlf;
 coolprint('2. 1');
 printlf;
 coolprint('3. 3');
 printlf;
 coolprint('4. 5');
 printlf;
 coolprint('5. 6');
 printlf;
 coolprint('6. 7');
 printlf;
 printlf;
 coolprint('Enter your choise: ');

 l6:
 while not keypressed do blankcursor(1);
 c:=readkey;
 if c=#27 then failexit;
 if not (c in['1'..'6']) then goto l6;
 coolprint(c);
 blankcursor(2);
 midasconfig.carddma:=dmatable[ord(c)-ord('0')];

 l7:

 xclearscreen;

 coolprint('Mixing rate');
 printlf;
 coolprint('------------------');
 printlf;
 printlf;
 coolprint('1. 8000 Hz');
 printlf;
 coolprint('2. 11025 Hz');
 printlf;
 coolprint('3. 16000 Hz');
 printlf;
 coolprint('4. 22050 Hz');
 printlf;
 coolprint('5. 32000 Hz');
 printlf;
 coolprint('6. 38000 Hz');
 printlf;
 coolprint('7. 44100 Hz');
 printlf;
 printlf;
 coolprint('Enter your choise: ');

 l8:
 while not keypressed do blankcursor(1);
 c:=readkey;
 if c=#27 then failexit;
 if not (c in['1'..'7']) then goto l8;
 coolprint(c);
 blankcursor(2);
 midasconfig.cardfreq:=freqtable[ord(c)-ord('0')];

 l4:
 xclearscreen;

 coolprint('Configuration complete.');
 printlf;
 blankcursor(2);
 coolprint('Saving...');

 assign(f,'setup.cfg'); rewrite(f,1);
 blockwrite(f,midasconfig,sizeof(midasconfig));
 close(f);

 blankcursor(4);
 fadepalette;
 xtextmode;
 writeln('Configuration complete.');
 writeln('Now you can run demo.');
 writeln;
end.