code            segment byte    public
.386
		assume	cs:code,ds:data

		public	sCopyToScreen
		public	sClearVga
		public	sFillVga
		public	sSetGfxMode
		public	sSetTxtMode
		public	ssetvisualpage
		public	spset
		public	squadropset
		public	sblockcolpset
		public	sblockcolquadropset
		public	sline
		public	sfillpoly4
		public	scopybitmap_zoom
		public	scopypagetopage
		public	switchtosmode

;********************************************************************

SCRWIDTH = 320
SCRHEIGHT = 200

;       Outcodes used by line clipping routine:
;       ---------------------------------------
;         
; 010100011001
;         
; 
;     
; 010000001000
;     
; 
;         
; 011000101010
;         


;/***************************************************************************\
;*
;* Macro:       Outcode x, y, ocode
;*
;* Description: Calculates an outcode for a pixel
;*
;* Input:       x                       x coordinate (register)
;*              y                       y coordinate (register)
;*              ocode                   destination register for outcode
;*
;\***************************************************************************/

Outcode macro	x, y, ocode
LOCAL	no1, no2, no3, dox

	xor	ocode,ocode

	test	y,y
	jns	no1
	or	ocode,0001b
	jmp	dox

no1:	cmp	y,SCRHEIGHT
	jl	dox
	or	ocode,0010b

dox:	test	x,x
	jns	no2
	or	ocode,0100b
	jmp	no3

no2:	cmp	x,SCRWIDTH
	jl	no3
	or	ocode,1000b

no3:
ENDM

;/***************************************************************************\
;*
;* Function:    ClipLine
;*
;* Description: Clips the endpoints of a line to the screen
;*
;* Input:       bx                      x-coordinate for point 1
;*              cx                      y-coordinate for point 1
;*              si                      x-coordinate for point 2
;*              di                      y-coordinate for point 2
;*
;* Returns:     ax = 1 if the line is completely out of the screen, 0 if not.
;*              line endpoint coordinates are updated
;*
;* Destroys:
;*
;\***************************************************************************/

ClipLine proc
	push	bp

@@doclip:
	cmp	bx,si			; is the line vertical?
	je	@@vert
	cmp	cx,di
	je	@@horz			; or horizontal?

	Outcode bx,cx,al		; AL = OutCode for first point
	Outcode si,di,ah		; AH = OutCode for second point

	mov	dl,al			; don't draw if the line is fully
	and	dl,ah			; outside the screen (outcodes
	jnz	@@outside		; have at least 1 same bit set

	mov	dl,al
	or	dl,ah			; if both outcodes are zero, the line
	jz	@@done			; is completely on screen

	test	al,al
	jnz	@@cp1
	mov	al,ah			; swap points if point 1 doesn't need
	xchg	bx,si			; clipping
	xchg	cx,di

@@cp1:
	mov	bp,ax			; bp = outcode for point 1

	test	al,0001b
	jz	@@no11

	mov	ax,si			; outcode AND 1 != 0 --> point is
	sub	ax,bx			; above the window
	neg	cx
	imul	cx
	add	cx,di			; x1 = x1 + (x2-x1) * (0-y1) / (y2-y1)
	idiv	cx
	add	bx,ax

	xor	cx,cx			; y1 = 0

	jmp	@@no12


@@no11: test	bp,0010b
	jz	@@no12

	mov	ax,si			; outcode AND 2 != 0 --> point is
	sub	ax,bx			; below the window
	mov	dx,SCRHEIGHT-1
	sub	dx,cx
	imul	dx
	neg	cx
	add	cx,di			; x1 = x1 + (x2-x1) * (yMax-y1)
	idiv	cx			;       / (y2-y1)
	add	bx,ax

	mov	cx,SCRHEIGHT-1		; y1 = yMax


@@no12: cmp	bx,si
	je	@@horz

	test	bp,0100b
	jz	@@no13

	mov	ax,di			; outcode AND 4 != 0 --> point is
	sub	ax,cx			; to left of the window
	neg	bx
	imul	bx
	add	bx,si
	idiv	bx			; y1 = y1 + (y2-y1) * (0-x1) / (x2-x1)
	add	cx,ax

	xor	bx,bx			; x1 = 0

	jmp	@@doclip


@@no13: test	bp,1000b
	jz	@@doclip

	mov	ax,di			; outcode AND 8 != 0 --> point is
	sub	ax,cx			; to right of the window
	mov	dx,SCRWIDTH-1
	sub	dx,bx
	imul	dx
	neg	bx
	add	bx,si
	idiv	bx			; y1 = y1 + (y2-y1) * (xMax-x1)
	add	cx,ax			;       / (x2-x1)

	mov	bx,SCRWIDTH-1		; x1 = xMax

	jmp	@@doclip

@@outside:
	mov	ax,1
	jmp	@@exit


@@vert:
	; vertical line
	cmp	cx,di
	jle	@@v1			; swap endpoints if y2<y1
	xchg	cx,di
	xchg	bx,si

@@v1:	test	di,di
	js	@@outside		; is the line completely outside the
	cmp	cx,SCRHEIGHT		; screen?
	jge	@@outside
	cmp	bx,SCRWIDTH		; in X direction?
	jae	@@outside

	cmp	di,SCRHEIGHT
	jl	@@v2
	mov	di,SCRHEIGHT-1

@@v2:	test	cx,cx
	jns	@@done
	xor	cx,cx
	jmp	@@done


@@horz:
	; horizontal line
	cmp	bx,si
	jle	@@h1			; swap endpoints if x2<x1
	xchg	bx,si
	xchg	cx,di

@@h1:	test	si,si
	js	@@outside		; is the line completely outside the
	cmp	bx,SCRWIDTH		; screen?
	jge	@@outside
	cmp	cx,SCRHEIGHT		; in Y direction?
	jae	@@outside

	cmp	si,SCRWIDTH
	jl	@@h2
	mov	si,SCRWIDTH-1

@@h2:	test	bx,bx
	jns	@@done
	xor	bx,bx


@@done:
	xor	ax,ax

@@exit:
	pop	bp

	ret
clipline	ENDP

;procedure sline(x1,y1,x2,y2: integer; color:byte; page: word);

backseg =	6
color		=	8
y2		=	10
x2		=	12
y1		=	14
x1		=	16

sline		proc	far
		push	bp
		mov	bp,sp

		mov	bx,[bp+x1]
		mov	cx,[bp+y1]
		mov	si,[bp+x2]
		mov	di,[bp+y2]

                call    clipline

		or	ax,ax
		je	slll1

;line completely out of the screen
		pop	bp
		ret	12

slll1:
		mov	[bp+x1],bx
		mov	[bp+y1],cx
		mov	[bp+x2],si
		mov	[bp+y2],di

                mov     al,[bp+backseg]
		xor	ah,ah
		shl	ax,10
		add	ax,0a000h
		mov	es,ax

		mov	ax,[bp+x2]
		sub	ax,[bp+x1]
		mov	plinedx,ax
		jns	linel1
		neg	ax
linel1:
		mov	plineabsdx,ax

		mov	bx,[bp+y2]
		sub	bx,[bp+y1]
		mov	plinedy,bx
		jns	linel2
		neg	bx
linel2:
		jnz	slll2

;gorisontal line
		push	word ptr [bp+y1]
		push	word ptr [bp+x1]
		push	word ptr [bp+x2]
		push	word ptr [bp+color]
		call	gorline

		pop	bp
		ret	12

slll2:
		mov	plineabsdy,bx

		cmp	ax,bx
		jnc	linel3
                jmp     linel4
linel3:
;  x
		or	ax,ax
		jnz	linel5
; 窠
		mov	bx,[bp+y1]
		shl	bx,1
		mov	di,word ptr cs:[offset ydata+bx]
		mov	si,[bp+x1]
		mov	bx,si
		shr	si,2
		add	di,si
		and	bx,3
		mov	ah,byte ptr cs:[offset linedata1+bx]
		mov	al,2
		mov	dx,3c4h
		out	dx,ax
		mov	al,[bp+color]
		stosb
linel10:
                pop     bp
		ret	12
linel5:
;  
		mov	cx,ax
		inc	cx
		movzx	ebx,ax
		mov	ax,plinedy
		shl	eax,16
		cdq
		idiv	ebx
		mov	dword ptr cs:[offset lineaddd1-4],eax

		mov	al,47h
		cmp	word ptr plinedx,0
		jns	linel6
		mov	al,4fh
linel6:
		mov	byte ptr cs:[offset linexdata1-1],al

                mov     al,[bp+color]
		mov	byte ptr cs:[offset linecold1-1],al

		mov	di,[bp+x1]
		mov	si,[bp+y1]
		shl	esi,16
		mov	dx,3c4h
		mov	al,2
		out	dx,al
		inc	dx
linel8:
		mov	bx,di
		and	bx,3
		mov	al,byte ptr cs:[offset linedata1+bx]
		out	dx,al
		shld	ebx,esi,16
		shl	bx,1
		mov	bx,word ptr cs:[offset ydata+bx]

                mov     ax,di
                shr     ax,2
		add	bx,ax

		mov	byte ptr es:[bx],12h
linecold1:
linel7:
		add	esi,12345678h
lineaddd1:
		inc	di
linexdata1:
		loop	linel8

                pop     bp
		ret	12

linel4:
;  y
		mov	cx,bx
		inc	cx
		movzx	ebx,bx
		mov	ax,plinedx
		shl	eax,16
		cdq
		idiv	ebx
		mov	dword ptr cs:[offset lineaddd2-4],eax

		mov	al,47h
		cmp	word ptr plinedy,0
		jns	linel12
		mov	al,4fh
linel12:
		mov	byte ptr cs:[offset lineydata1-1],al

		mov	al,[bp+color]
		mov	byte ptr cs:[offset linecoldata2-1],al

		mov	di,word ptr [bp+y1]
		mov	si,[bp+x1]
		shl	esi,16
		mov	dx,3c4h
		mov	al,2
		out	dx,al
		inc	dx
linel9:
                shld    ebx,esi,16

		and	bx,3
		mov	al,byte ptr cs:[offset linedata1+bx]
		out	dx,al

		shld	bx,di,17
		mov	bx,word ptr cs:[offset ydata+bx]

		shld	eax,esi,16
		shr	ax,2
		add	bx,ax
                mov     byte ptr es:[bx],12h
linecoldata2:
linel11:
		add	esi,12345678h
lineaddd2:
		inc	di
lineydata1:
		loop	linel9
		pop	bp
		ret	12

linedata1	db	1,2,4,8
sline		endp



;param = (y,x1,x2: int; color: byte),   es= seg
color	=	4
x2	=	6
x1	=	8
oy	=	10

GorLine proc
		push	bp
		mov	bp,sp

		cld

		movzx	edi,word ptr [bp+oy]
;                or      di,di
;                js      l_gl1
;                cmp     di,199
;                ja      l_gl1
;;;;;;;;;;;;;;;;;;;;;;;;
;                mov     di,word ptr cs:[offset ydata+edi*2]
		db	2eh,67h,8bh,3ch,7dh
		dw	offset ydata
		dw	0
;;;;;;;;;;;;;;;;;;;;;;;;;;
		mov	ax,[bp+x1]
		mov	cx,[bp+x2]

;                cmp     ax,319
;                jg      l_gl1
;                or      ah,ah
;                jns     l_gl2
;                xor     ax,ax
;l_gl2:
;                cmp     cx,ax
;                jl      l_gl1
;                cmp     cx,319
;                jna     l_gl3
;                mov     cx,319
;l_gl3:
		sub	cx,ax
		inc	cx

		cmp	cx,4
		jc	l_gl10

                xor     si,si
                shr     ax,1
                rcl     si,1
                shr     ax,1
                rcl     si,1
                add     di,ax

                mov     dx,3c4h
                mov     al,2
                mov     ah,byte ptr cs:[offset gld2+si]
                out     dx,ax

		mov	ah,[bp+color]
		mov	byte ptr es:[di],ah

		shl	si,1
		sub	cx,word ptr cs:[offset gld3+si]
		add	di,word ptr cs:[offset gld4+si]

		inc	dx
                mov     al,0fh
		out	dx,al

		mov	si,cx
		shr	cx,2

		mov	al,ah
		shr	cx,1
	rep	stosw
		jnc	l_gl9
		stosb
l_gl9:
		and	si,3
		je	l_gl7

                mov     al,byte ptr cs:[offset gld1-1+si]
		out	dx,al
		mov	byte ptr es:[di],ah
l_gl7:
l_gl1:
		pop	bp
		ret	8

l_gl10:
		dec	cx
		shl	cx,3
		mov	bx,ax
		and	bx,3
		shl	bx,1
		add	bx,cx
		shr	ax,2
		add	di,ax

		mov	al,2
		mov	ah,byte ptr cs:[offset gld5+bx]
		mov	dx,3c4h
		out	dx,ax
		mov	cl,[bp+color]
		mov	byte ptr es:[di],cl
		inc	di
		mov	ah,byte ptr cs:[offset gld5+bx+1]
		out	dx,ax
		mov	byte ptr es:[di],cl
		jmp	l_gl1

gld1:		db	1,3,7
gld2:		db	0,4+8,2+4+8,8
gld3:		dw	0,2,3,1
gld4:		dw	0,1,1,1

gld5		db	1,0,2,0,4,0,8,0
		db	1+2,0,2+4,0,4+8,0,8,1
		db	1+2+4,0,2+4+8,0,4+8,1,8,1+2
GorLine endp

polyline	proc
;ࠬ  plinex1...
		mov	ax,plinex2
		sub	ax,plinex1

		mov	bx,pliney2

;get minimum y
		cmp	bx,poly_miny
		jnc	lmnp1
		mov	poly_miny,bx
lmnp1:

;get maximum y
		cmp	bx,itr
		jna	lmxp1
		mov	itr,bx
lmxp1:

		sub	bx,pliney1
		mov	plinedy,bx
		jns	plin2
		neg	bx
plin2:
		mov	plineabsdy,bx
		je	plin20		;ਧ⠫쭠  ?

;********************************
;  y
		shl	eax,16
		cdq
		movzx	ebx,bx
		idiv	ebx
		mov	edx,eax

		mov	byte ptr cs:[offset plinadd1_d2-1],47h;inc     di
		cmp	word ptr plinedy,0
		jns	plin12
		mov	byte ptr cs:[offset plinadd1_d2-1],4fh;dec     di
plin12:
		movzx	edi,pliney1
		mov	si,plinex1
		shl	esi,16
		mov	cx,plineabsdy
		inc	cx
plin15:
		shld	eax,esi,16

;-------------------------------------------------
;                cmp     ax,polyarr[edi*4]
		db	67h,3bh,04,0bdh
		dw	offset polyarr
		dw	0
;-------------------------------------------------

                jnl     plin14

;-------------------------------------------------
;               mov     polyarr[edi*4],ax
		db	67h,89h,04,0bdh
		dw	offset polyarr
		dw	0
;-------------------------------------------------

plin14:
;-------------------------------------------------
;                cmp     ax,polyarr[edi*4+2]
		db	67h,3bh,04,0bdh
		dw	offset polyarr+2
		dw	0
;-------------------------------------------------

		jng	plin13

;-------------------------------------------------
;               mov     polyarr[edi*4+2],ax
		db	67h,89h,04,0bdh
		dw	offset polyarr+2
		dw	0
;-------------------------------------------------
plin13:
		inc	di
plinadd1_d2:
		add	esi,edx
		loop	plin15
		ret

;====  窠
plin20:
		mov	bx,pliney1
		shl	bx,2
		add	bx,offset polyarr
		mov	ax,plinex1
		cmp	ax,[bx]
		jnl	plin7
		mov	[bx],ax
plin7:
		inc	bx
		inc	bx
                cmp     ax,[bx]
		jng	plin6
		mov	[bx],ax
plin6:
		ret
polyline	endp

;==========================================
; same as clipline, but only y cliping
;==========================================
pclipline	proc
		push	bp

		cmp	cx,di
		jne	l_cl5

;gorizontal line
		or	cx,cx
		js	l_cl6	;out

		cmp	cx,199
		ja	l_cl6	;out

		xor	ax,ax	;ok
		pop	bp
		ret

l_cl5:
		or	cx,cx
		jns	l_cl1

		or	di,di
		jns	l_cl2

;y1<0, y2<0 - line completely out of the screen
l_cl6:
		mov	ax,1
		pop	bp
		ret
l_cl2:

;y1<0, let y1:=0, x1:=x1-(x2-x1)*y1/(y2-y1)

		push	di
		mov	ax,si
		sub	ax,bx
		imul	cx
		sub	di,cx
		idiv	di
		sub	bx,ax
		xor	cx,cx
		pop	di
l_cl1:
		mov	bp,199

		cmp	cx,bp
		jna	l_cl7

                cmp     di,bp
		jna	l_cl4

;y1>199,y2>199 - line completely out of the screen
		mov	ax,1
		pop	bp
		ret
l_cl4:

;y1>199, let x1:=x1+(x2-x1)*(199-y1)/(y2-y1)

		push	di
		mov	ax,si
		sub	ax,bx
		sub	bp,cx
		imul	bp
		sub	di,cx
		idiv	di
		add	bx,ax
		mov	cx,199
		pop	di
l_cl7:

; swap point1 and 2 and repeat test
		xchg	bx,si
		xchg	cx,di

                cmp     cx,di
		jne	l_cl5a

;gorizontal line
		or	cx,cx
		js	l_cl6a	;out

		cmp	cx,199
		ja	l_cl6a	;out

		xor	ax,ax	;ok
		pop	bp
		ret

l_cl5a:
		or	cx,cx
		jns	l_cl1a

		or	di,di
		jns	l_cl2a

;y1<0, y2<0 - line completely out of the screen
l_cl6a:
		mov	ax,1
		pop	bp
		ret
l_cl2a:

;y1<0, let y1:=0, x1:=x1-(x2-x1)*y1/(y2-y1)

		push	di
		mov	ax,si
		sub	ax,bx
		imul	cx
		sub	di,cx
		idiv	di
		sub	bx,ax
		xor	cx,cx
		pop	di
l_cl1a:
		mov	bp,199

		cmp	cx,bp
		jna	l_cl7a

                cmp     di,bp
		jna	l_cl4a

;y1>199,y2>199 - line completely out of the screen
		mov	ax,1
		pop	bp
		ret
l_cl4a:

;y1>199, let x1:=x1+(x2-x1)*(199-y1)/(y2-y1)

		push	di
		mov	ax,si
		sub	ax,bx
		sub	bp,cx
		imul	bp
		sub	di,cx
		idiv	di
		add	bx,ax
		mov	cx,199
		pop	di
l_cl7a:

		pop	bp
                xor     ax,ax
		ret
pclipline	endp

;procedure sfilpoly4(p:pointer;color: byte; page:byte);
sfillpoly4	proc	far
backseg =	6
color		=	8
pofs		=	10
pseg		=	12

                push    bp
		mov	bp,sp

		mov	ax,ds
		mov	es,ax
		mov	cx,200
		mov	eax,0FFFF0140h
		lea	di,polyarr
		cld
	rep	stosd

		mov	poly_miny,200
		mov	itr,0

		les	si,[bp+pofs]

                mov     bx,es:[si]
                mov     cx,es:[si+2]
                mov     di,es:[si+6]
                mov     si,es:[si+4]
                call    pclipline
		or	ax,ax
		jne	lom1
                mov     plinex1,bx
                mov     pliney1,cx
                mov     plinex2,si
                mov     pliney2,di

		call	polyline
lom1:

		les	si,[bp+pofs]

                mov     bx,es:[si+4]
                mov     cx,es:[si+6]
                mov     di,es:[si+10]
                mov     si,es:[si+8]
                call    pclipline
		or	ax,ax
		jne	lom1a
                mov     plinex1,bx
                mov     pliney1,cx
                mov     plinex2,si
                mov     pliney2,di

		call	polyline
lom1a:
		les	si,[bp+pofs]

                mov     bx,es:[si+8]
                mov     cx,es:[si+10]
                mov     di,es:[si+14]
                mov     si,es:[si+12]
                call    pclipline
		or	ax,ax
		jne	lom1b
                mov     plinex1,bx
                mov     pliney1,cx
                mov     plinex2,si
                mov     pliney2,di

		call	polyline
lom1b:
		les	si,[bp+pofs]

                mov     bx,es:[si+12]
                mov     cx,es:[si+14]
                mov     di,es:[si+2]
                mov     si,es:[si]
                call    pclipline
		or	ax,ax
		jne	lom1c
                mov     plinex1,bx
                mov     pliney1,cx
                mov     plinex2,si
                mov     pliney2,di

		call	polyline
lom1c:

		lea	si,polyarr

		mov	al,byte ptr [bp+backseg]
		xor	ah,ah
		shl	ax,10
		add	ax,0a000h
		mov	es,ax

		mov	al,[bp+color]
		mov	ah,al
		mov	byte ptr cs:[offset fplcoldata-1],al
		mov	byte ptr cs:[offset fplcoldata1-1],al
		mov	word ptr cs:[offset fplcoldata2-2],ax
		mov	byte ptr cs:[offset fplcoldata3-1],al
		mov	byte ptr cs:[offset fplcoldata4-1],al

		mov	ax,poly_miny
		cmp	ax,200
		jc	lmnp2

;polygon is completely out of the screen
		pop	bp
		ret	8
lmnp2:
		sub	itr,ax
		inc	itr

		mov	bx,ax
		mov	cx,ax
		shl	ax,6
		shl	bx,4
		add	ax,bx
		mov	word ptr cs:[offset fplydata-2],ax
		shl	cx,2
		add	si,cx

		mov	dx,3c4h
		mov	al,2
		out	dx,al

fpl1:
		lodsw
		mov	dx,ax
		or	dx,dx
		jns	fpl2
		xor	dx,dx
fpl2:
		lodsw
		cmp	ax,319
		jng	fpl3
		mov	ax,319
fpl3:
		mov	cx,ax
		sub	cx,dx
		jl	fpl5
		inc	cx

		cmp	cx,4
		jc	fpl4

		mov	bx,dx
		shr	dx,2
		mov	di,1234h
fplydata:
		add	di,dx

		and	bx,3

		mov	dx,3c5h
		mov	al,byte ptr cs:[offset fpld1+bx]
		out	dx,al
		shl	bx,1
		sub	cx,word ptr cs:[offset fpld3+bx]

		mov	al,1
fplcoldata:
		stosb

		mov	al,0fh
		out	dx,al

		mov	bx,cx
		shr	cx,2
		mov	ax,1234h
fplcoldata2:
		shr	cx,1
	rep	stosw
		jnc	fpl6
		stosb
fpl6:
		and	bx,3
                jz      fpl5

		mov	al,byte ptr cs:[offset fpld2+bx]
		out	dx,al

		mov	al,1
fplcoldata1:
                stosb

fpl5:
		add	word ptr cs:[offset fplydata-2],80
		dec	itr
		jnz	fpl1

		pop	bp
		ret	8

fpl4:
		mov	di,dx
		shr	di,2
		add	di,word ptr cs:[offset fplydata-2]

		shl	cx,3
		and	dx,3
		shl	dx,1
		mov	bx,dx
		add	bx,cx

		mov	dx,3c5h
		mov	al,byte ptr cs:[offset fpld4+bx-8]
		out	dx,al

		mov	al,1
fplcoldata3:
                stosb

		mov	al,byte ptr cs:[offset fpld4+bx+1-8]
		out	dx,al

		mov	al,1
fplcoldata4:
		stosb

		jmp	fpl5

fpld1:		db	0fh,2+4+8,4+8,8
fpld2:		db	0,1,1+2,1+2+4
fpld3:		dw	4,3,2,1
fpld4:		db	1,0,2,0,4,0,8,0
		db	1+2,0,2+4,0,4+8,0,8,1
		db	1+2+4,0,2+4+8,0,4+8,1,8,1+2
sfillpoly4	endp

;procedure switchtosmode;
switchtosmode	proc	far
		mov	dx,3c4h
		mov	al,04h
		out	dx,al
		inc	dx
		in	al,dx
		and	al,0f7h
		or	al,4
		out	dx,al

		mov	dx,3ceh
		mov	al,05h
		out	dx,al
		inc	dx
		in	al,dx
		and	al,0efh
		out	dx,al

		mov	dx,3ceh
		mov	al,06h
		out	dx,al
		inc	dx
		in	al,dx
		and	al,0fdh
		out	dx,al

		mov	dx,3d4h
		mov	al,014h
		out	dx,al
		inc	dx
		in	al,dx
		and	al,0bfh
		out	dx,al

		mov	dx,3d4h
		mov	al,017h
		out	dx,al
		inc	dx
		in	al,dx
		or	al,40h
		out	dx,al
		ret
switchtosmode	endp

;procedure ssetgfxmode;
ssetgfxmode	proc	far
		mov	ax,13h
		int	10h

		mov	ax,1201h
		mov	bl,36h
		int	10h

		call	switchtosmode

		mov	cx,4000h
		cld
		mov	ax,0a000h
		mov	es,ax
		xor	di,di

                xor     eax,eax
	rep	stosd

		mov	ax,1200h
		mov	bl,36h
		int	10h

                ret
ssetgfxmode	endp

;procedure ssettxtmode;
ssettxtmode	proc	far
		mov	ax,3
		int	10h
		ret
ssettxtmode	endp

idiv32_16_32	proc
;dx:ax/si = cx:bx
;si    - unsign
;dx:ax - sign
;cx:dx - sign
		or	dx,dx
		js	l_idq1

		mov	di,dx
		mov	bx,ax

		mov	ax,dx
		xor	dx,dx
		div	si
		mov	cx,ax
		mul	si
		sub	di,ax

		mov	dx,di
		mov	ax,bx
		div	si
		mov	bx,ax

		ret

l_idq1:
		not	ax
		neg	dx
		add	ax,1
		adc	dx,-1

		mov	di,dx
		mov	bx,ax

		mov	ax,dx
		xor	dx,dx
		div	si
		mov	cx,ax
		mul	si
		sub	di,ax

		mov	dx,di
		mov	ax,bx
		div	si
		mov	bx,ax

		not	bx
		neg	cx
		add	bx,1
		adc	cx,-1
		ret
idiv32_16_32	endp

scopytoscreen   proc    far
		push	bp
		mov	bp,sp
		push	ds

		cld

		mov	ax,[bp+8]
		mov	cx,400h
		mul	cx
		add	ax,0a000h
		mov	es,ax
		mov	ds,[bp+6]

		cld

		mov	dx,3c4h
		mov	ax,0102h
		out	dx,ax

		mov	cx,2000
		xor	si,si
		xor	di,di
		mov	ax,3
sc1_1:
		movsb
		add	si,ax
		movsb
		add	si,ax
		movsb
		add	si,ax
		movsb
		add	si,ax
		movsb
		add	si,ax
		movsb
		add	si,ax
		movsb
		add	si,ax
		movsb
		add	si,ax
		loop	sc1_1

		mov	ax,0202h
		out	dx,ax

		mov	cx,2000
		xor	si,si
		xor	di,di
		inc	si
sc1_2:
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
                loop    sc1_2

		mov	ax,0402h
		out	dx,ax

		mov	cx,2000
		xor	si,si
		xor	di,di
		inc	si
		inc	si
sc1_3:
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
                loop    sc1_3

		mov	ax,0802h
		out	dx,ax

		mov	cx,2000
		xor	si,si
		xor	di,di
		inc	si
		inc	si
		inc	si
sc1_4:
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
		movsb
		add	si,3
                loop    sc1_4

		pop	ds
		pop	bp
		ret	4
scopytoscreen	endp

scopytoscreen1	proc	far
		push	bp
		mov	bp,sp
		push	ds

		cld

		mov	ax,[bp+8]
		mov	cx,400h
		mul	cx
		add	ax,0a000h
		mov	es,ax
		mov	ds,[bp+6]

		xor	si,si
		xor	di,di
		mov	cx,16000
		cld

		mov	dx,3c4h
		mov	al,2
		out	dx,al
		inc	dx
		mov	al,00010001b
sc11:
		out	dx,al
		movsb
		rol	al,1
		cmc
		sbb	di,0
		out	dx,al
		movsb
		rol	al,1
		cmc
		sbb	di,0
		out	dx,al
		movsb
		rol	al,1
		cmc
		sbb	di,0
		out	dx,al
		movsb
		rol	al,1
		cmc
		sbb	di,0

		loop	sc11

		pop	ds
		pop	bp
		ret	4
scopytoscreen1	endp

;procedure sshowpicbar(bar: pointer; screenseg: word;
;  picx,picy,piclenx,picleny,picseg : word);

picseg		=	6
picleny =	8
piclenx =	10
picy		=	12
picx		=	14
screenseg	=	16
barofs		=	18
barseg		=	20

sshowpicbar	proc	far
		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	ax,seg	data
		mov	es,ax

		lea	di,tx1
		lds	si,[bp+barofs]
		cld
		mov	cx,8
	rep	movs	word ptr [di],[si]

		mov	ax,seg data
		mov	ds,ax

		mov	ax,ty1
		sub	ax,ty2
		mov	dya,ax
		jns	l_spb1
		neg	ax
l_spb1:
		mov	dyaabs,ax

                mov     ax,ty4
		sub	ax,ty3
		mov	dyb,ax
		jns	l_spb2
		neg	ax
l_spb2:
		mov	dybabs,ax

		mov	ax,tx1
		sub	ax,tx2
		mov	dxa,ax
		jns	l_spb3
		neg	ax
l_spb3:
		mov	dxaabs,ax

                mov     ax,tx4
		sub	ax,tx3
		mov	dxb,ax
		jns	l_spb4
		neg	ax
l_spb4:
		mov	dxbabs,ax

		mov	si,dyaabs
		cmp	si,dxaabs
		ja	l_spb5
		mov	si,dxaabs
l_spb5:

		mov	di,dybabs
		cmp	di,dxbabs
		ja	l_spb6
		mov	di,dxbabs
l_spb6:
		cmp	si,di
		ja	l_spb7
		mov	si,di
l_spb7:
		or	si,si
		jne	l_spb8
		inc	si
l_spb8:
		mov	itr,si

		mov	dx,dxa
		xor	ax,ax
		call	idiv32_16_32
		mov	xainc,bx
		mov	xainc+2,cx

                mov     dx,dxb
		xor	ax,ax
		call	idiv32_16_32
		mov	xbinc,bx
		mov	xbinc+2,cx

                mov     dx,dya
		xor	ax,ax
		call	idiv32_16_32
		mov	yainc,bx
		mov	yainc+2,cx

                mov     dx,dyb
		xor	ax,ax
		call	idiv32_16_32
		mov	ybinc,bx
		mov	ybinc+2,cx

                mov     dx,[bp+picleny]
		xor	ax,ax
		call	idiv32_16_32
		mov	picyinc,bx
		mov	picyinc+2,cx


		xor	bx,bx

		mov	ax,tx2
		mov	xa+2,ax
		mov	xa,bx

		mov	ax,tx3
		mov	xb+2,ax
		mov	xb,bx

		mov	ax,ty2
		mov	ya+2,ax
		mov	ya,bx

		mov	ax,ty3
		mov	yb+2,ax
		mov	yb,bx

		mov	ax,[bp+picy]
		mov	pic_y+2,ax
		mov	pic_y,bx

		inc	itr

		mov	es,[bp+screenseg]

l_spb21:
		mov	dx,xb+2
		sub	dx,xa+2
		mov	si,dx
		jns	l_spb9
		neg	si
l_spb9:
		mov	cx,yb+2
		sub	cx,ya+2
		mov	di,cx
		jns	l_spb10
		neg	di
l_spb10:



		cmp	si,di
		jna	l_spb11

		or	si,si
		jne	l_spb12
		inc	si
l_spb12:
		mov	lineitr,si
		mov	word ptr linexinc,0
		mov	word ptr linexinc+2,1
		or	dx,dx
		jns	l_spb13
		mov	word ptr linexinc+2,-1
l_spb13:
		xor	ax,ax
		mov	dx,cx
		call	idiv32_16_32
		mov	lineyinc,bx
		mov	lineyinc+2,cx
		jmp	l_spb14


l_spb11:
		or	di,di
		jne	l_spb15
		inc	di
l_spb15:
		mov	lineitr,di
		mov	word ptr lineyinc,0
		mov	word ptr lineyinc+2,1
		or	cx,cx
		jns	l_spb16
		mov	word ptr lineyinc+2,-1
l_spb16:
		xor	ax,ax
		mov	si,di
		call	idiv32_16_32
		mov	linexinc,bx
		mov	linexinc+2,cx

l_spb14:

		mov	dx,[bp+piclenx]
		xor	ax,ax
		call	idiv32_16_32
		mov	picxinc,bx
		mov	picxinc+2,cx

		mov	ax,xa
		mov	linex,ax
		mov	ax,xa+2
		mov	linex+2,ax

		mov	ax,ya
		mov	liney,ax
		mov	ax,ya+2
		mov	liney+2,ax

		mov	ax,[bp+picx]
		mov	pic_x+2,ax
		mov	word ptr pic_x,0

		cld
		inc	lineitr

l_spb19:
		mov	ax,liney+2
		cmp	ax,0
		jl	l_spb17
		cmp	ax,199
		jg	l_spb17

		mov	di,linex+2
		cmp	di,0
		jl	l_spb17
		cmp	di,319
		jg	l_spb17

		mov	ah,al
		xor	al,al
		add	di,ax
		shr	ax,1
		shr	ax,1
		add	di,ax

		mov	ax,pic_y+2
		mov	ah,al
		xor	al,al
		mov	si,ax
		shr	ax,1
		shr	ax,1
		add	si,ax
		add	si,pic_x+2

		mov	bx,ds
		mov	ds,[bp+picseg]
		mov	al,[si]
		mov	ah,al
		mov	ds,bx

		stosw
		add	di,320-1
		stosb

l_spb17:
		mov	ax,linexinc
		mov	dx,linexinc+2
		add	linex,ax
		adc	linex+2,dx

                mov     ax,lineyinc
		mov	dx,lineyinc+2
		add	liney,ax
		adc	liney+2,dx

                mov     ax,picxinc
		mov	dx,picxinc+2
		add	pic_x,ax
		adc	pic_x+2,dx

		dec	lineitr
		jz	l_spb18

		jmp	l_spb19
l_spb18:

                mov     ax,xainc
		mov	dx,xainc+2
		add	xa,ax
		adc	xa+2,dx

                mov     ax,xbinc
		mov	dx,xbinc+2
		add	xb,ax
		adc	xb+2,dx

                mov     ax,yainc
		mov	dx,yainc+2
		add	ya,ax
		adc	ya+2,dx

                mov     ax,ybinc
		mov	dx,ybinc+2
		add	yb,ax
		adc	yb+2,dx

                mov     ax,picyinc
		mov	dx,picyinc+2
		add	pic_y,ax
		adc	pic_y+2,dx


		dec	itr
		jz	l_spb20

		jmp	l_spb21
l_spb20:

		pop	es
		pop	ds
		pop	bp
		ret	16
sshowpicbar	endp

;procedure sclearvga(pagenum);
sclearvga	proc	far
		mov	bx,sp
		mov	ax,ss:[bx+4]
		shl	ax,10
		add	ax,0a000h
		mov	es,ax
		mov	dx,3c4h
		mov	ax,0f02h
		out	dx,ax
		cld
		mov	cx,8000
		xor	di,di
		xor	ax,ax
	rep	stosw
		ret	2
sclearvga	endp

;procedure sfillvga(pagenum,b:byte);
sfillvga	proc	far
		mov	bx,sp
		mov	al,ss:[bx+6]
		shl	ax,10
		add	ax,0a000h
		mov	es,ax
		mov	dx,3c4h
		mov	ax,0f02h
		out	dx,ax
		cld
		mov	cx,8000
		xor	di,di
		mov	al,ss:[bx+4]
		mov	ah,al
	rep	stosw
		ret	4
sfillvga	endp

;procedure ssetvisualpage(page:word);
ssetvisualpage	proc	far
		push	bp
		mov	bp,sp

		mov	ax,[bp+6]
		mov	cx,4000h
		mul	cx
		mov	[bp+6],ax
		mov	cl,8

		mov	dx,3dah
svpl1:
		in	al,dx
		test	al,cl
		jne	svpl1


		mov	dl,0d4h
		mov	al,12
		mov	ah,[bp+7]
		out	dx,ax
		inc	al
		mov	ah,[bp+6]
		out	dx,ax

                mov     dl,0dah
svpl2:
		in	al,dx
		test	al,cl
		je	svpl2

		pop	bp
		ret	2
ssetvisualpage	endp

;procedure spset(x,y: integer; color,pagenum:byte);
pagenum =	6
color		=	8
cory		=	10
corx		=	12

spset		proc	far
		push	bp
		mov	bp,sp

		mov	al,[bp+pagenum]
		xor	ah,ah
		shl	ax,10
		add	ax,0a000h
		mov	es,ax

		mov	ax,[bp+cory]
		or	ah,ah
		js	l_sps1
		cmp	ax,199
		ja	l_sps1
		shl	ax,6
		mov	di,ax
		shr	ax,2
		add	di,ax

		xor	si,si
		mov	bx,[bp+corx]
		or	bh,bh
		js	l_sps1
		cmp	bx,319
		ja	l_sps1
		shr	bx,1
		rcl	si,1
		shr	bx,1
		rcl	si,1

		mov	dx,3c4h
		mov	al,2
		mov	ah,byte ptr cs:[offset spsetd1+si]
		out	dx,ax

		mov	ah,[bp+color]
		mov	byte ptr es:[di+bx],ah
l_sps1:
		pop	bp
		ret	8

spsetd1:	db	1,4,2,8

spset		endp

;procedure sblockcolpset(nobj: word; koord,colors: pointer; pagenum:byte);

pagenum =	6
colorsofs	=	8
colorsseg	=	10
koordofs	=	12
koordseg	=	14
nobj		=	16

sblockcolpset	proc	far
		push	bp
		mov	bp,sp
		push	ds

		mov	al,[bp+pagenum]
		xor	ah,ah
		shl	ax,10
		add	ax,0a000h
		mov	es,ax

		lds	si,[bp+koordofs]
		lgs	di,[bp+colorsofs]
		mov	dx,3c4h
		mov	al,2
		out	dx,al
		inc	dx

		cld
		mov	cx,[bp+nobj]

l_sbp3:
		lodsw
		cmp	ax,07fffh
		je	l_sbp4

		add	ax,160

                mov     bp,ax
		push	bp
		and	bp,3
                mov     al,byte ptr cs:[offset portdata+bp]
		pop	bp
                out     dx,al
                shr     bp,2

		lodsw
		neg	ax
		add	ax,100

                mov     bx,ax
                shl     bx,1
                add     bp,word ptr cs:[offset ydata+bx]

		mov	al,gs:[di]
		mov	byte ptr es:[bp],al
		inc	di
l_sbp2:
		loop	l_sbp3

		pop	ds
		pop	bp
		ret	12

l_sbp4:
		lodsw
		inc	di
		jmp	l_sbp2
sblockcolpset	endp

;procedure sblockcolquadrospset(nobj: word; koord,colors: pointer; pagenum:byte);

pagenum =	6
colorsofs	=	8
colorsseg	=	10
koordofs	=	12
koordseg	=	14
nobj		=	16

sblockcolquadropset	proc	far
		push	bp
		mov	bp,sp
		push	ds

		mov	al,[bp+pagenum]
		xor	ah,ah
		shl	ax,10
		add	ax,0a000h
		mov	es,ax

		lds	si,[bp+koordofs]
		lgs	di,[bp+colorsofs]
		mov	dx,3c4h
		mov	al,2
		out	dx,al
		inc	dx

		cld
l_sbp3q:
		lodsw
		cmp	ax,07fffh
		jne	l_sbp1q
l_sbp4q:
		lodsw
l_sbp5q:
		inc	di
		jmp	l_sbp2q
l_sbp1q:
		add	ax,160

		mov	cx,ax
		xor	bx,bx
		shr	cx,1
		rcl	bx,1
		shr	cx,1
		rcl	bx,1

		mov	al,byte ptr cs:[offset spbd1q+bx]
		out	dx,al

		lodsw
		neg	ax
                add     ax,100

		shl	ax,6
		add	cx,ax
		shr	ax,2
		add	cx,ax

		mov	al,byte ptr cs:[offset spbd2q+bx]
		mov	ah,byte ptr cs:[offset spbd3q+bx]

		mov	bx,cx
		mov	cl,gs:[di]
		mov	byte ptr es:[bx],cl
		mov	byte ptr es:[bx+80],cl
		out	dx,al
		add	bl,ah
		adc	bh,0
		mov	byte ptr es:[bx],cl
		mov	byte ptr es:[bx+80],cl


		inc	di
l_sbp2q:
		dec	word ptr [bp+nobj]
		jne	l_sbp3q

		pop	ds
		pop	bp
		ret	12
spbd1q: db	1,4,2,8
spbd2q: db	2,8,4,1
spbd3q: db      0,0,0,1
sblockcolquadropset	endp

;procedure squadropset(x,y: integer; color,pagenum:byte);
pagenum =	6
color		=	8
cory		=	10
corx		=	12

squadropset	proc	far
		push	bp
		mov	bp,sp

		mov	al,[bp+pagenum]
		xor	ah,ah
		shl	ax,10
		add	ax,0a000h
		mov	es,ax

		mov	ax,[bp+cory]
		or	ah,ah
		js	l_sps1q
		cmp	ax,198
		ja	l_sps1q
		shl	ax,6
		mov	di,ax
		shr	ax,2
		add	di,ax

		xor	si,si
		mov	bx,[bp+corx]
		or	bh,bh
		js	l_sps1q
		cmp	bx,318
		ja	l_sps1q
		shr	bx,1
		rcl	si,1
		shr	bx,1
		rcl	si,1

		mov	dx,3c4h
		mov	al,2
		mov	ah,byte ptr cs:[offset spsetd1q+si]
		out	dx,ax

		mov	ch,[bp+color]
		mov	byte ptr es:[di+bx],ch
		mov	byte ptr es:[di+bx+80],ch

                shl     ah,1
		jnc	l_sps2q
		inc	bx
		mov	ah,1
l_sps2q:
		out	dx,ax
		mov	byte ptr es:[di+bx],ch
		mov	byte ptr es:[di+bx+80],ch

l_sps1q:
		pop	bp
		ret	8

spsetd1q:	db	1,4,2,88h
squadropset	endp

;procedure copbitmap_zoom (x1,y1,x2,y2,tox1,toy1,tox2,toy2: integer;
;      minindex: byte; picseg,apage : word);

par_apage	=	6
par_bseg	=	8
par_minindex	=	10
par_toy2	=	12
par_tox2	=	14
par_toy1	=	16
par_tox1	=	18
par_y2		=	20
par_x2		=	22
par_y1		=	24
par_x1		=	26

scopybitmap_zoom proc	far
		push	bp
		mov	bp,sp

zo2:
		mov	ax,[bp+par_tox2]
		sub	ax,[bp+par_tox1]
		mov	data_tcx,ax

                mov     ax,[bp+par_toy2]
		sub	ax,[bp+par_toy1]
		mov	data_tcy,ax

		cmp	data_tcx,0
		jns	zo1

		mov	ax,[bp+par_x1]
		mov	bx,[bp+par_x2]
		mov	[bp+par_x1],bx
		mov	[bp+par_x2],ax

		mov	ax,[bp+par_tox1]
		mov	bx,[bp+par_tox2]
		mov	[bp+par_tox1],bx
		mov	[bp+par_tox2],ax
		jmp	zo2
zo1:
		cmp	data_tcy,0
		jns	zo3

		mov	ax,[bp+par_y1]
		mov	bx,[bp+par_y2]
		mov	[bp+par_y1],bx
		mov	[bp+par_y2],ax

		mov	ax,[bp+par_toy1]
		mov	bx,[bp+par_toy2]
		mov	[bp+par_toy1],bx
		mov	[bp+par_toy2],ax
		jmp	zo2
zo3:
		cmp	word ptr [bp+par_tox1],319
zo6:
		jng	zo4
		jmp	zo5
zo4:
		cmp	word ptr [bp+par_tox2],0
		js	zo6

		mov	ax,[bp+par_tox1]
		or	ax,ax
		jns	zo7

		mov	bx,[bp+par_x2]
		sub	bx,[bp+par_x1]
		imul	bx
		idiv	data_tcx
		sub	[bp+par_x1],ax
		mov	word ptr [bp+par_tox1],0
		mov	ax,[bp+par_tox2]
		mov	data_tcx,ax
zo7:
		mov	ax,[bp+par_tox2]
		sub	ax,319
		jng	zo8

		mov	bx,[bp+par_x2]
		sub	bx,[bp+par_x1]
		imul	bx
		idiv	data_tcx
		sub	[bp+par_x2],ax
		mov	ax,319
		mov	word ptr [bp+par_tox2],ax
		sub	ax,[bp+par_tox1]
		mov	data_tcx,ax
zo8:
		mov	ax,[bp+par_toy1]
		or	ax,ax
		jns	zo7a

		mov	bx,[bp+par_y2]
		sub	bx,[bp+par_y1]
		imul	bx
		idiv	data_tcy
		sub	[bp+par_y1],ax
		mov	word ptr [bp+par_toy1],0
		mov	ax,[bp+par_toy2]
		mov	data_tcy,ax
zo7a:
		mov	ax,[bp+par_toy2]
		sub	ax,199
		jng	zo8a

		mov	bx,[bp+par_y2]
		sub	bx,[bp+par_y1]
		imul	bx
		idiv	data_tcy
		sub	[bp+par_y2],ax
		mov	ax,199
		mov	word ptr [bp+par_toy2],ax
		sub	ax,[bp+par_toy1]
		mov	data_tcy,ax
zo8a:
		mov	ax,[bp+par_apage]
		shl	ax,10
		add	ax,0a000h
		mov	es,ax

		cmp	data_tcx,0
		jne	zo9
		inc	data_tcx
zo9:
		cmp	data_tcy,0
		jne	zo10
		inc	data_tcy
zo10:

		mov	ax,[bp+par_x2]
		sub	ax,[bp+par_x1]
		shl	eax,16
		cdq
		movzx	ebx,data_tcx
		idiv	ebx
		mov	dword ptr cs:[offset csxadd-4],eax

                mov     ax,[bp+par_y2]
		sub	ax,[bp+par_y1]
		shl	eax,16
		cdq
		movzx	ebx,data_tcy
		idiv	ebx
		mov	word ptr cs:[offset csyadd-2],ax
		shr	eax,16
		mov	bx,ax
		shl	ax,8
		shl	bx,6
		add	ax,bx
		mov	word ptr cs:[offset csyadd320-2],ax

		mov	bx,[bp+par_toy1]
		shl	bx,1
		mov	ax,word ptr cs:[offset ydata+bx]
		mov	bx,[bp+par_tox1]
		shr	bx,2
		add	ax,bx
		mov	word ptr cs:[offset csbofs-2],ax

		mov	bx,[bp+par_tox1]
		and	bx,3
		mov	al,byte ptr cs:[offset portdata+bx]
		mov	data_bport,al

		mov	dx,3c4h
		mov	al,2
		out	dx,al

		mov	ax,[bp+par_y1]
		mov	bx,ax
		shl	ax,8
		shl	bx,6
		add	ax,bx
		add	ax,[bp+par_x1]
		shl	eax,16
		mov	data_x,eax

		mov	al,[bp+par_minindex]
		mov	byte ptr cs:[offset csminindex-1],al

		mov	bx,1234h
csyadd:
		push	ds
		pop	gs
		mov	ds,[bp+par_bseg]
		cld

;=============== tcx cycle
zo15:
		mov	di,1234h
csbofs:
		mov	si,word ptr gs:[offset data_x+2]

		mov	dx,3c5h
		mov	al,gs:data_bport
		out	dx,al

		xor	dx,dx
		mov	cx,gs:data_tcy
;=============== tcy cycle
zo13:
		lodsb
		dec	si
		cmp	al,12h
csminindex:
		jc	zo11
		stosb
		dec	di
zo11:
		add	di,80
		add	si,1234h
csyadd320:
		add	dx,bx
		jnc	zo12
		add	si,320
zo12:
		dec	cx
		jne	zo13
;============ end tcx cycle

		rol	byte ptr gs:data_bport,1
		jnc	zo14
		inc	word ptr cs:[offset csbofs-2]
zo14:
		add	gs:data_x,12345678h
csxadd:
		dec	gs:data_tcx
		jne	zo15
zo5:
		push	gs
		pop	ds
		pop	bp
		ret	22
scopybitmap_zoom endp

;procedure scopypagetopage(p1,p2: word);
scopypagetopage proc	far
		push	bp
		mov	bp,sp
		push	ds

		mov	dx,3c4h
		mov	ax,0f02h
		out	dx,ax

		mov	dx,3ceh
		mov	al,5
		out	dx,al
		inc	dx
		in	al,dx
		push	ax
		or	al,1
		out	dx,al

		mov	ax,[bp+6]
		shl	ax,10
		add	ax,0a000h
		mov	es,ax

                mov     ax,[bp+8]
		shl	ax,10
		add	ax,0a000h
		mov	ds,ax

		xor	si,si
		xor	di,di
		cld

		mov	cx,4000h
	rep	movsb

		pop	ax
		out	dx,al

		pop	ds
		pop	bp
		ret	4
scopypagetopage endp

ydata:
dw     0,   80,  160,  240,  320,  400,  480,  560,  640,  720,  800,  880
dw   960, 1040, 1120, 1200, 1280, 1360, 1440, 1520, 1600, 1680, 1760, 1840
dw  1920, 2000, 2080, 2160, 2240, 2320, 2400, 2480, 2560, 2640, 2720, 2800
dw  2880, 2960, 3040, 3120, 3200, 3280, 3360, 3440, 3520, 3600, 3680, 3760
dw  3840, 3920, 4000, 4080, 4160, 4240, 4320, 4400, 4480, 4560, 4640, 4720
dw  4800, 4880, 4960, 5040, 5120, 5200, 5280, 5360, 5440, 5520, 5600, 5680
dw  5760, 5840, 5920, 6000, 6080, 6160, 6240, 6320, 6400, 6480, 6560, 6640
dw  6720, 6800, 6880, 6960, 7040, 7120, 7200, 7280, 7360, 7440, 7520, 7600
dw  7680, 7760, 7840, 7920, 8000, 8080, 8160, 8240, 8320, 8400, 8480, 8560
dw  8640, 8720, 8800, 8880, 8960, 9040, 9120, 9200, 9280, 9360, 9440, 9520
dw  9600, 9680, 9760, 9840, 9920,10000,10080,10160,10240,10320,10400,10480
dw 10560,10640,10720,10800,10880,10960,11040,11120,11200,11280,11360,11440
dw 11520,11600,11680,11760,11840,11920,12000,12080,12160,12240,12320,12400
dw 12480,12560,12640,12720,12800,12880,12960,13040,13120,13200,13280,13360
dw 13440,13520,13600,13680,13760,13840,13920,14000,14080,14160,14240,14320
dw 14400,14480,14560,14640,14720,14800,14880,14960,15040,15120,15200,15280
dw 15360,15440,15520,15600,15680,15760,15840,15920

portdata:
	db 11h,22h,44h,88h

.286
code		ends

data		segment word	public
dy		dw	0
y		dw	0
xainc		dw	0,0
xbinc		dw	0,0
xa		dw	0,0
xb		dw	0,0

tx1		dw	0
ty1		dw	0
tx2		dw	0
ty2		dw	0
tx3		dw	0
ty3		dw	0
tx4		dw	0
ty4		dw	0

dxa		dw	0
dxb		dw	0
dya		dw	0
dyb		dw	0

dxaabs		dw	0
dxbabs		dw	0
dyaabs		dw	0
dybabs		dw	0

yainc		dw	0,0
ybinc		dw	0,0
picyinc dw	0,0
picxinc dw	0,0

ya		dw	0,0
yb		dw	0,0

pic_y		dw	0,0
pic_x		dw	0,0

lineyinc	dw	0,0
linexinc	dw	0,0

lineitr dw	0

linex		dw	0,0
liney		dw	0,0

itr		dw	0

plinex1 dw	0
pliney1 dw	0
plinex2 dw	0
pliney2 dw	0

plinedx dw	0
plinedy dw	0
plineabsdy	dw	0
plineabsdx	dw	0

		dw	0,0	;safety
polyarr dw	400 dup (0)
		dw	0,0	;safety
poly_miny	dw	0

;======= data for copybitmap_zoom ======
data_tcx	dw	0
data_tcy	dw	0
data_bport	db	0
data_x		dd	0

data		ends

		end