{$S-,R-,V-,I-,B-,F+,X+,G+,A+}
{$M $4000,$20000,$A0000}

unit
  STMPlay;

interface

USES
  Crt, Dos;

CONST
  TempoMul : Array[0..17] of Byte = (
	$8C,$32,$19,$0F,$0A,$07,$06,$04,$03,$03,$02,$02,$02,$02,$01,$01,
	$01,$01 );

  VibratoTab : Array[0..63] of Word = (
	$0000,$0018,$0031,$004A,$0061,$0078,$008D,$00A1,
	$00B4,$00C5,$00D4,$00E0,$00EB,$00F4,$00FA,$00FD,
	$00FF,$00FD,$00FA,$00F4,$00EB,$00E0,$00D4,$00C5,
	$00B4,$00A1,$008D,$0078,$0061,$004A,$0031,$0018,
	$0000,$FFE8,$FFCF,$FFB6,$FF9F,$FF88,$FF73,$FF5F,
	$FF4C,$FF3B,$FF2C,$FF20,$FF15,$FF0C,$FF06,$FF03,
	$FF01,$FF03,$FF06,$FF0C,$FF15,$FF20,$FF2C,$FF3B,
	$FF4C,$FF5F,$FF73,$FF88,$FF9F,$FFB6,$FFCF,$FFE8);

  ComVar : Byte = $0A;

  SmBut  : Array[0..1]  OF Char = (#138,#15);
  SmBut1 : Array[0..1]  OF Char = (#11,#12);
  PianP  : Array[0..11] OF Byte = (0,1,2,3,4,6,7,8,9,10,11,12);

  zbyte  : byte = 0;

TYPE
  OnePat  = Array[0..63,0..4,0..4] of Byte;
  Buffer  = Array[0..65534] of Byte;
  BufPtr  = ^Buffer;

  InsType = RECORD
              Name : String[12];
              Tran : Word;
              Volm : Byte;
              LopS : Word;
              LopE : Word;
              Leng : Word;
              Inst : BufPtr;
              W1   : Word;
              W2   : Word;
              Res1 : Word;
            END;

  SetupTp = RECORD
              PSpeed  : Word;
              Res1    : Byte;
              TimerOn : Boolean;
              Lpt     : Word;
              Sbport  : Word;
              sbirq   : byte;
              sbdma   : byte;
            END;

  ChnType = RECORD
              OnV     : WORD;
              On      : WORD;
              InsOfs  : Word;
              InsSeg  : Word;
              InsEnd  : Word;
              Loop    : Word;
              Free    : WORD;
              Trans1  : Word;
              Trans2  : Word;
              TAdd    : Word;
              Res1    : Byte;
              Volume  : Byte;
              LstNote : Word;
              LstIns  : Word;
              LstPVol : Word;
              LstCmd  : Word;
              LstInfo : Word;
              NInsOfs : Word;
              InsTrns : Word;
              Row     : Word;
              PatOfs  : Word;
              CVol    : Word;
              IVol    : Word;
              TmpNote : Word;
              TmpTrn1 : Word;
              TmpTrn2 : Word;
              TremVar : Word;
              ArpeVar : Word;
              VibrVar : Word;
              LevVol  : Word;
              LevVol1 : Word;
              Color   : Word;
            END;

VAR
  Cw,Cw1,W  : Word;
  Cb        : Byte;
  Cr        : Real;
  Cl        : LongInt;
  F         : File;
  SName     : Array[1..20] of Char;
  VTab      : Array[0..64,0..255] of Byte;
  NTab      : Array[0..4,0..15] of Word;
  OrdB      : Array[0..127] of Byte;
  InsB      : Array[1..31] of InsType;
  PatB      : BufPtr;
  Ov08      : Procedure;
  GTempo    : Byte;
  GOctave   : Byte;
  Gvolume   : Byte;
  Lpt1      : Word ABSOLUTE $0000:$0408;
  Lpt2      : Word ABSOLUTE $0000:$040A;
  Setup     : SetupTp;
  Ch1       : ChnType;
  Ch2       : ChnType;
  Ch3       : ChnType;
  Ch4       : ChnType;
  FastTime  : Word;
  AddWCur   : Word;
  AddWBegin : Word;
  TempoD16  : Word;
  TempoD16S : Word;
  Play1Note : Boolean;
  ChangePat : Boolean;
  TimerC    : Word;
  TimerA    : Word;
  CTempo    : Word;
  NextPatO  : Word;
  LoopCount : Word;
  FirstOrd  : Word;
  CurOrder  : Word;
  CurPat    : Word;
  NextPat   : Boolean;
  Port40    : Word;
  TotPat    : word;
  SpTabOfs,
  SpTabSeg  : Word;
  tempovars  : array [0..255] of word;
  sptab   : array [0..255] of byte;


PROCEDURE SetDefaultSetup;
FUNCTION  ReadSTM(Name:String):Boolean;
PROCEDURE PlayAllPatterns(Device:byte);
procedure Stop;
procedure InitPlayer;
function getordnum: byte;
function getrownum: byte;
procedure gotopattern(b: byte);

implementation

var
 oldexit: pointer;
 dmabufseg: word;
 sbport   : word;
 sbirq    : byte;
 sbdma    : byte;
 samplerate: word;
 sdevice  : byte;

{$F+}
procedure covoxint08; external;
procedure copydatas; external;
procedure setsdevice(device: byte); external;
procedure shutupsb20; external;
{$L stmplay}
{$F-}

function getordnum: byte;
begin
 getordnum:=curorder-firstord;
end;

function getrownum: byte;
begin
 getrownum:=ch1.row;
end;

PROCEDURE InitTabs;
BEGIN
  FillChar(VTab,256,0);
  FOR Cw:= 1 TO 64 DO
  BEGIN
    FOR Cb:=0 TO 127 DO
    BEGIN
      VTab[Cw,Cb]:=Trunc(Cw*cb/256);
      VTab[Cw,255-Cb]:=not VTab[Cw,Cb];
    END;
  END;
  FOR Cw:=0 TO 59 DO
    NTab[Cw DIV 12,Cw MOD 12]:=Round($42B8/(Exp(Ln(2)*Cw/12)));
END;

PROCEDURE SetDefaultSetup;
BEGIN
  Setup.Lpt:=Lpt1;
  Setup.Sbport:=$220;
  setup.sbirq:=7;
  setup.sbdma:=1;
  Setup.TimerOn:=False;
  Setup.PSpeed:=19889;
END;

PROCEDURE ResetTempoVars;NEAR;ASSEMBLER;
ASM
  MOV  CTempo,AX
  mov bx,ax
  shl bx,1
  mov ax,tempovars[bx].word
  mov addwbegin,ax

  shr  bx,5
  MOV  TempoD16S,BX
  RET
END;

PROCEDURE ResetTempoVars1;NEAR;ASSEMBLER;
ASM
  MOV  CTempo,AX
  MOV  BX,AX
  shr  bx,4
  MOV  TempoD16S,BX
  AND  AX,0FH
  MOV  CX,AX
  MOV  AL,TempoMul[BX].Byte
  MUL  CX
  shr  ax,4
  MOV  BX,AX
  MOV  AX,Setup.PSpeed
  MOV  CX,31H
  SUB  CX,BX
  XOR  DX,DX
  DIV  CX
  MOV  AddWBegin,AX
  RET
END;

PROCEDURE MulTran;NEAR;ASSEMBLER;
ASM
  PUSH BX
  PUSH CX
  MOV  CX,ChnType([SI]).TmpTrn1
  CMP  CX,227H
  JNC  @OkCX
  XOR  AX,AX
  MOV  ChnType([SI]).Trans2,AX
  MOV  ChnType([SI]).Trans1,AX
  POP  CX
  POP  BX
  RET
 @OkCX:
  MOV  DX,226H
  MOV  AX,6C34H
  DIV  CX
  XOR  DX,DX
  DIV  Setup.PSpeed
  MOV  CX,AX
  XOR  AX,AX
  DIV  Setup.PSpeed
  MOV  ChnType([SI]).Trans2,AX
  MOV  ChnType([SI]).Trans1,CX
  POP  CX
  POP  BX
  RET
END;

PROCEDURE DoCommand;NEAR;ASSEMBLER;
ASM
  MOV  AH,ChnType([SI]).LstCmd.Byte
  MOV  AL,ChnType([SI]).LstInfo.Byte
  CMP  AH,5
  JZ   @PortUp
  CMP  AH,6
  JZ   @PortDown
  CMP  AH,4
  JZ   @VolSlide
  CMP  AH,9
  JNZ  @C1
  JMP  @Tremor
@C1:
  CMP  AH,0AH
  JNZ  @C2
  JMP  @Arped
@C2:
  MOV  ChnType([SI]).TremVar,0
  MOV  ChnType([SI]).ArpeVar,1
  CMP  AH,7
  JNZ  @C3
  JMP  @GNop
@C3:
  CMP  AH,8
  JNZ  @C4
  JMP  @Vibrato
@C4:
  MOV  ChnType([SI]).VibrVar,0
  RET
 @PortDown:
  XOR  AH,AH
  MUL  ComVar
  SUB  ChnType([SI]).TmpTrn1,AX
  CALL MulTran
  RET
 @PortUp:
  XOR  AH,AH
  MUL  ComVar
  ADD  ChnType([SI]).TmpTrn1,AX
  CALL MulTran
  RET
 @VolSlide:
  MOV  DL,AL
  AND  DL,0FH
  CMP  DL,0
  JZ   @UpVol
  XOR  DH,DH
  SUB  ChnType([SI]).CVol,DX
  CMP  ChnType([SI]).CVol,0FFFFH
  JG   @OkRet
  MOV  ChnType([SI]).CVol,0
 @OkRet:
  RET
 @UpVol:
  XOR  AH,AH
  SHR  AL,4
  ADD  ChnType([SI]).CVol,AX
  CMP  ChnType([SI]).CVol,041H
  JC   @OkRet
  MOV  ChnType([SI]).CVol,040H
  RET
 @GNop:
  MOV  AX,ChnType([SI]).TmpTrn1
  CMP  AX,ChnType([SI]).TmpTrn2
  JNZ  @Differ
  RET
 @Differ:
  JA   @SetDown
  ADD  AX,ChnType([SI]).LstInfo
  ADD  AX,ChnType([SI]).LstInfo
  ADD  AX,ChnType([SI]).LstInfo
  ADD  AX,ChnType([SI]).LstInfo
  ADD  AX,ChnType([SI]).LstInfo
  ADD  AX,ChnType([SI]).LstInfo
  ADD  AX,ChnType([SI]).LstInfo
  ADD  AX,ChnType([SI]).LstInfo
  ADD  AX,ChnType([SI]).LstInfo
  ADD  AX,ChnType([SI]).LstInfo
  CMP  AX,ChnType([SI]).TmpTrn2
  JNA  @NoAbove
  MOV  AX,ChnType([SI]).TmpTrn2
 @NoAbove:
  MOV  ChnType([SI]).TmpTrn1,AX
  CALL MulTran
  RET
 @SetDown:
  SUB  AX,ChnType([SI]).LstInfo
  SUB  AX,ChnType([SI]).LstInfo
  SUB  AX,ChnType([SI]).LstInfo
  SUB  AX,ChnType([SI]).LstInfo
  SUB  AX,ChnType([SI]).LstInfo
  SUB  AX,ChnType([SI]).LstInfo
  SUB  AX,ChnType([SI]).LstInfo
  SUB  AX,ChnType([SI]).LstInfo
  SUB  AX,ChnType([SI]).LstInfo
  SUB  AX,ChnType([SI]).LstInfo
  CMP  AX,ChnType([SI]).TmpTrn2
  JNC  @NoAbove1
  MOV  AX,ChnType([SI]).TmpTrn2
 @NoAbove1:
  MOV  ChnType([SI]).TmpTrn1,AX
  CALL MulTran
  RET
 @Vibrato:
  MOV  CL,AL
  MOV  CH,AL
  AND  CL,0FH
  MOV  BX,ChnType([SI]).VibrVar
  MOV  AX,VibratoTab[BX].WORD
  PUSH CX
  XOR  CH,CH
  IMUL CX
  POP  CX
  MOV  CL,6
  SAR  AX,CL
  IMUL ComVar
  ADD  AX,ChnType([SI]).TmpTrn2
  MOV  ChnType([SI]).TmpTrn1,AX
  CALL MulTran
  SHR  CH,4
  SHL  CH,1
  ADD  BL,CH
  AND  BL,7EH
  MOV  ChnType([SI]).VibrVar,BX
  RET
 @Tremor:
  MOV  AX,ChnType([SI]).TremVar
  CMP  AX,0
  JZ   @InTrem
  DEC  AX
  MOV  ChnType([SI]).TremVar,AX
  RET
 @InTrem:
  MOV  AX,ChnType([SI]).ArpeVar
  CMP  AX,1
  JZ   @InTrem1
  MOV  ChnType([SI]).ArpeVar,1
  MOV  AX,ChnType([SI]).IVol
  MOV  ChnType([SI]).CVol,AX
  MOV  AX,ChnType([SI]).LstInfo
  SHR  AL,4
  MOV  ChnType([SI]).TremVar,AX
  RET
 @InTrem1:
  MOV  ChnType([SI]).ArpeVar,0
  MOV  AX,0
  MOV  ChnType([SI]).CVol,AX
  MOV  AX,ChnType([SI]).LstInfo
  AND  AX,0FH
  MOV  ChnType([SI]).TremVar,AX
  RET
 @Arped:
  MOV  AX,TempoD16
  MOV  CL,3
  DIV  CL
  MOV  DL,AL
  XOR  AL,AL
  MOV  BL,ChnType([SI]).TmpNote.Byte
  CMP  DL,2
  JZ   @It2
  CMP  DL,1
  JZ   @It1
  MOV  AL,ChnType([SI]).LstInfo.Byte
  AND  AL,0FH
  JMP  @It2
 @It1:
  INC   CL
  SHR   AL,CL
 @It2:
  MOV   BH,BL
  AND   BL,0F0H
  AND   BH,00FH
  ADD   BH,AL
  CMP   BH,0BH
  JBE   @Caron
  SUB   BH,0CH
  ADD   BL,10H
 @Caron:
  OR    BL,BH
  XOR   BH,BH
  SHL   BX,1
  MOV   AX,NTab[BX].WORD
  MOV   CX,2100H
  MUL   CX
  MOV   CX,ChnType([SI]).InsTrns
  CMP   CX,0
  JNZ   @NoZTr
  MOV   CX,22B8H
 @NoZTr:
  DIV   CX
  MOV  ChnType([SI]).TmpTrn1,AX
  MOV  ChnType([SI]).TmpTrn2,AX
  CALL MulTran
  RET
END;

PROCEDURE ChangePattern;NEAR;ASSEMBLER;
ASM
  XOR  AH,AH
  MOV  BX,NextPatO
  MOV  AL,[BX]
  CMP  AX,63H
  JNZ  @NoPlayEnd
  INC  LoopCount
  MOV  BX,FirstOrd
  MOV  AL,[BX]
 @NoPlayEnd:
  MOV  CurOrder,BX
  INC  BX
  CMP  AX,62H
  JNZ  @No62
  INC  LoopCount
  MOV  BX,OFFSET OrdB
  MOV  AL,[BX]
  INC  BX
  MOV  NextPat,True
 @No62:
  MOV  NextPatO,BX
  MOV  CurPat,AX
  MOV  AH,AL
  XOR  AL,AL
  SHL  AX,2
  MOV  Ch1.PatOfs,AX
  ADD  AX,4
  MOV  Ch2.PatOfs,AX
  ADD  AX,4
  MOV  Ch3.PatOfs,AX
  ADD  AX,4
  MOV  Ch4.PatOfs,AX
  XOR  AX,AX
  MOV  Ch1.Row,AX
  MOV  Ch2.Row,AX
  MOV  Ch3.Row,AX
  MOV  Ch4.Row,AX
END;

PROCEDURE CheckOptions;NEAR;ASSEMBLER;
ASM
  MOV  AH,ChnType([SI]).LstCmd.Byte
  MOV  AL,ChnType([SI]).LstInfo.Byte
  CMP  AH,1
  JZ   @ChgTempo
  CMP  AH,2
  JZ   @GotoPat
  CMP  AH,3
  JZ   @BreakPat
 @RetFromChk:
  RET
 @ChgTempo:
  CMP  AL,0
  JZ   @RetFromChk
  XOR  AH,AH
  CALL ResetTempoVars
  RET
 @GotoPat:
  XOR  AH,AH
  ADD  AX,OFFSET OrdB
  MOV  NextPatO,AX
  RET
 @BreakPat:
  MOV  ChangePat,True
END;

PROCEDURE SetNoteTrans;NEAR;ASSEMBLER;
ASM
  MOV  AX,ChnType([SI]).LstPVol
  CMP  AX,41H
  JZ   @NoPVol
  MOV  ChnType([SI]).CVol,AX
  MOV  ChnType([SI]).IVol,AX
 @NoPVol:
  CMP  ChnType([SI]).LstCmd,7
  JNZ  @NoGOption
  JMP  @GOption
 @NoGOption:
  MOV  BX,ChnType([SI]).LstIns
  CMP  BX,0
  JZ   @NoInsInPat
  MOV  ChnType([SI]).Color,BX
  SHL  BX,5
  ADD  BX,(OFFSET InsB)-32
  MOV  ChnType([SI]).NInsOfs,BX
  CMP  ChnType([SI]).LstPVol,41H
  JNZ  @LstPVolNo41
  MOV  AL,InsType([BX]).Volm
  XOR  AH,AH
  MOV  ChnType([SI]).CVol,AX
  MOV  ChnType([SI]).IVol,AX
 @LstPVolNo41:
  MOV  AX,InsType([BX]).Tran
  MOV  ChnType([SI]).InsTrns,AX
  MOV  AX,InsType([BX+2]).Inst.WORD
  CMP  AX,0
  JNZ  @ItIns
  MOV  ChnType([SI]).LstNote,0FEH
 @ItIns:
  MOV  ChnType([SI]).InsSeg,AX
  MOV  AX,InsType([BX]).LopE
  CMP  AX,0FFFFH
  JZ   @NoLoop
  MOV  ChnType([SI]).InsEnd,AX
  MOV  AX,InsType([BX]).LopS
  MOV  ChnType([SI]).Loop,AX
  JMP  @NoInsInPat
 @NoLoop:
  MOV  ChnType([SI]).Loop,AX
  MOV  AX,InsType([BX]).Leng
  MOV  ChnType([SI]).InsEnd,AX
 @NoInsInPat:
  MOV  BX,ChnType([SI]).LstNote
  CMP  BX,0FEH
  JNZ  @ItNote
  XOR  AX,AX
  MOV  ChnType([SI]).TAdd,AX
  MOV  ChnType([SI]).InsOfs,AX
  MOV  ChnType([SI]).InsEnd,AX
  MOV  ChnType([SI]).Loop,0FFFFH
  JMP  @CheckOpt
 @ItNote:
  CMP  BX,0FFH
  JZ   @CheckOpt
  MOV  ChnType([SI]).TmpNote,BX
  MOV  AX,ChnType([SI]).CVol
  SHR  AL,1
  MOV  ChnType([SI]).LevVol,AX
  MOV  ChnType([SI]).LevVol1,AX
  SHL  BX,1
  MOV  AX,NTab[BX].WORD
  MOV  CX,2100H
  MUL  CX
  MOV  CX,ChnType([SI]).InsTrns
  CMP  CX,0
  JNZ  @NoZeroTrans
  MOV  CX,22B8H
 @NoZeroTrans:
  DIV  CX
  MOV  ChnType([SI]).TmpTrn1,AX
  MOV  ChnType([SI]).TmpTrn2,AX
  CALL MulTran
  XOR  AX,AX
  MOV  ChnType([SI]).TAdd,AX
  MOV  ChnType([SI]).InsOfs,AX
 @CheckOpt:
  CALL CheckOptions
  RET
 @GOption:
  MOV  BX,ChnType([SI]).LstNote
  CMP  BX,0FFH
  JZ   @DoneGOp
  SHL  BX,1
  MOV  AX,NTab[BX].WORD
  MOV  ChnType([SI]).TmpTrn2,AX
 @DoneGOp:
END;

PROCEDURE ResetVars;NEAR;ASSEMBLER;
ASM
  MOV  ES,[PatB+2].WORD
  INC  ChnType([SI]).Row
  CMP  ChnType([SI]).Row,40H
  JC   @NoOverPat
  MOV  ChangePat,True
 @NoOverPat:
  CMP  ChnType([SI]).On,0
  JZ   @OFF
  MOV  BX,ChnType([SI]).PatOfs
  XOR  AH,AH
  MOV  AL,ES:[BX]
  MOV  ChnType([SI]).LstNote,AX
  MOV  AL,ES:[BX+1]
  SHR  AL,3
  MOV  ChnType([SI]).LstIns,AX
  MOV  AL,ES:[BX+1]
  AND  AL,7
  MOV  DL,ES:[BX+2]
  SHR  DL,1
  AND  DL,78H
  OR   AL,DL
  MOV  ChnType([SI]).LstPVol,AX
  MOV  AL,ES:[BX+2]
  AND  AL,0FH
  MOV  ChnType([SI]).LstCmd,AX
  MOV  AL,ES:[BX+3]
  MOV  ChnType([SI]).LstInfo,AX
  ADD  BX,10H
  MOV  ChnType([SI]).PatOfs,BX
  CALL SetNoteTrans
  CMP  ChnType([SI]).LstCmd,9
  JNZ  @DoneResetVars
  CALL DoCommand
 @DoneResetVars:
  RET
 @OFF:
  ADD  CHNTYPE([SI]).PATOFS,10H
END;

PROCEDURE Stack08;NEAR;ASSEMBLER;
ASM
  DW 0 { For CS IP and FLAGS   }
  DW 0
  DW 0
  DW 0 { Add Play Proc Segment }
  DW 0 { Add Play Proc Offset  }
  DW 0
END;


PROCEDURE SetAddProcAddr(P:Pointer);NEAR;
TYPE
  SO =RECORD
        O,S:Word;
      END;
BEGIN
  MemW[Seg(Stack08):Ofs(Stack08)+6]:=SO(P).O;
  MemW[Seg(Stack08):Ofs(Stack08)+8]:=SO(P).S;
END;

PROCEDURE AddPlay;NEAR;ASSEMBLER;
ASM
  PUSHF
  PUSH   AX
  PUSH   BX
  PUSH   CX
  PUSH   DX
  PUSH   ES
  PUSH   DS
  PUSH   SI
  MOV    AX,SEG Cw
  MOV    DS,AX
  MOV    AX,TempoD16
  CMP    AX,0
  JZ     @Td16z
  DEC    AX
  MOV    TempoD16,AX
  MOV    SI,OFFSET Ch1
  CALL   DoCommand
  MOV    SI,OFFSET Ch2
  CALL   DoCommand
  MOV    SI,OFFSET Ch3
  CALL   DoCommand
  MOV    SI,OFFSET Ch4
  CALL   DoCommand
  JMP    @ResetVol
 @Td16z:
  CMP    Play1Note,False
  JZ     @ResetVol
  CMP    ChangePat,True
  JNZ    @NoChgPat
  MOV    ChangePat,False
  CALL   ChangePattern
 @NoChgPat:
  MOV    SI,OFFSET Ch1
  CALL   ResetVars
  MOV    SI,OFFSET Ch2
  CALL   ResetVars
  MOV    SI,OFFSET Ch3
  CALL   ResetVars
  MOV    SI,OFFSET Ch4
  CALL   ResetVars
  MOV    AX,TempoD16S
  CMP    AX,0
  JZ     @ZeroTempo
  DEC    AX
 @ZeroTempo:
  MOV    TempoD16,AX
 @ResetVol:

  call copydatas;

  CMP    Setup.TimerOn,False
  JZ     @DoneAddPlay
  MOV    AX,TimerA
  ADD    AX,TimerC
  MOV    TimerA,AX
  JNC    @DoneAddPlay
  PUSHF
  CALL   Ov08
 @DoneAddPlay:
  POP    SI
  POP    DS
  POP    ES
  POP    DX
  POP    CX
  POP    BX
  POP    AX
  POPF
  PUSH   CS:[Stack08+2].WORD
  PUSH   CS:[Stack08+0].WORD
  RETF
END;

FUNCTION ReadSTM(Name:String):Boolean;
TYPE
  STMIns = RECORD
            Name  : Array[1..13] of char;
            Dsk   : Byte;
            Res1  : Word;
            Len   : Word;
            LoopS : Word;
            LoopE : Word;
            Vol   : Byte;
            Res2  : Byte;
            Tran  : Word;
            Res3  : Word;
            Res4  : Word;
            Sef   : Word;
           END;
laga = record
     ofs,seg:word;
     end;
VAR
  F : file;
  I : STMIns;
  A : word;
  L : longint;
  j: word;

BEGIN
  ReadSTM:=False;
  Assign(F,name);
  Reset(F,1);
  IF IOResult<>0 THEN Exit;
  BlockRead(F,SName,20);
  Seek(F,32);
  BlockRead(F,Gtempo,1);
  BlockRead(F,Cb,1);
  TotPat:=Cb;
  BlockRead(F,GVolume,1);
  Seek(F,48);
  FOR CW:=1 TO 31 DO
  BEGIN
    BlockRead(f,I,SizeOf(I));
    InsB[cw].Name:='';
    FOR A:=1 TO 13 DO IF I.Name[A]<>#0 THEN
      InsB[Cw].Name:=InsB[Cw].Name+I.Name[A] ELSE InsB[Cw].Name:=InsB[Cw].Name+' ';
    InsB[cw].leng:=I.Len;
    InsB[cw].lops:=I.LoopS;
    InsB[cw].lope:=I.LoopE;
    InsB[cw].volm:=I.Vol;
    InsB[cw].tran:=I.Tran;
    insb[cw].res1:=I.Res1;
  END;
  FOR Cw1:=1 to 31 DO
  BEGIN
    IF InsB[Cw1].Leng<>0 THEN
    BEGIN
      L:=InsB[Cw1].Res1;
      L:=L*16;
      Seek(F,L);
      GetMem(InsB[Cw1].Inst,InsB[Cw1].Leng+4);
      FillChar(InsB[Cw1].Inst^,InsB[Cw1].Leng+4,0);
      IF Word(InsB[Cw1].Inst)<>0 THEN
      BEGIN
        W:=Word(InsB[Cw1].Inst);
        FreeMem(InsB[Cw1].Inst,InsB[Cw1].Leng+4);
        GetMem(InsB[Cw1].Inst,W);
        GetMem(InsB[Cw1].Inst,InsB[Cw1].Leng+4);
        FillChar(InsB[Cw1].Inst^,InsB[Cw1].Leng+4,0);
        IF Word(InsB[Cw1].Inst)<>0 THEN
        BEGIN
          WriteLn('Pointer error');
          Halt(1);
        END;
      END;
      BlockRead(F,InsB[cw1].Inst^,InsB[Cw1].Leng);
    END ELSE InsB[Cw1].Inst:=NIL;
  END;
  Seek(F,$410);
  BlockRead(F,OrdB,SizeOf(OrdB));
  L:=Cb;
  L:=L*1024;
  IF L>=65536 THEN L:=65535;
  BlockRead(F,PatB^,L);
  ReadSTM:=True;
  Close(F);
END;

PROCEDURE PlayAllPatterns(Device:byte);
var
 i,j1,j2: integer;
BEGIN
  if device>3 then setup.pspeed:=(100000 div (100000 div setup.pspeed));
  sdevice:=device;
  samplerate:=setup.pspeed;
  sbirq:=setup.sbirq;
  sbdma:=setup.sbdma;
  sbport:=setup.sbport;

  if device>3 then inc(setup.pspeed,20);

  setsdevice(device);

  delay(300);

  for i:=0 to 255 do
    begin
     asm
      mov ax,i
      call resettempovars1
     end;
      tempovars[i]:=addwbegin;
    end;

  SpTabSeg:=Seg(SpTab);
  SpTabOfs:=Ofs(SpTab);
  IF OrdB[0]>=99 THEN Exit;
  FastTime  :=0;
  ASM
    MOV  AL,GTempo
    XOR  AH,AH
    CALL ResetTempoVars
  END;
  AddWCur   :=AddWBegin;
  TempoD16  :=TempoD16S;
  Play1Note :=True;
  ChangePat :=True;
  ASM
    MOV  DX,12H
    MOV  AX,34DCH
    DIV  Setup.PSpeed
    MOV  Port40,AX
  END;

  j1:=port40-2;
  for i:=0 to 255 do
         sptab[i]:=1+longint(i)*j1 div 255;

  TimerC    :=Port40*AddWBegin;
  TimerA    :=0;
  CTempo    :=GTempo;
  NextPatO  :=Ofs(OrdB);
  CurOrder  :=Ofs(OrdB);
  LoopCount :=0;
  CurPat    :=OrdB[0];
  FirstOrd  :=Ofs(OrdB);
  NextPat   :=False;
  Ch1.PatOfs:=$00;
  Ch2.PatOfs:=$10;
  Ch3.PatOfs:=$20;
  Ch4.PatOfs:=$30;
  SetAddProcAddr(@AddPlay);

  asm
   mov ax,offset zbyte
   mov ch1.insofs,ax
   mov ch1.insend,ax
   mov ch2.insofs,ax
   mov ch2.insend,ax
   mov ch3.insofs,ax
   mov ch3.insend,ax
   mov ch4.insofs,ax
   mov ch4.insend,ax
   mov ax,seg zbyte
   mov  ch1.insseg,ax
   mov  ch2.insseg,ax
   mov  ch3.insseg,ax
   mov  ch4.insseg,ax
   xor ax,ax
   mov ch1.cvol,ax
   mov ch2.cvol,ax
   mov ch3.cvol,ax
   mov ch4.cvol,ax
  end;

  copydatas;

  SetIntVec($08,@CovoxInt08);

  Port[$43] :=$36;
  Port[$40] :=Lo(Port40);
  Port[$40] :=Hi(Port40);
END;

procedure Stop;
  begin
    Port[$43]:=$36;
    SetIntVec($08,@Ov08);
    Port[$40]:=0;
    Port[$40]:=0;
    asm
     in al,61h
     and al,0fch
     out 61h,al
    end;
    if sdevice=4 then shutupsb20;
    if sdevice=5 then shutupsb20;
  end;

procedure InitPlayer;
type
 laga = record
   ofs,seg: word;
 end;
var
 p: pointer;
BEGIN
  getmem(p,1100);
  fillchar(p^,1100,$80);
  dmabufseg:=laga(p).seg+1;
  SetDefaultSetup;
  GetIntVec($08,@Ov08);
  GTempo :=$60;
  GOctave:=$01;
  FillChar(OrdB,128,99);
  InsB[1].Name:='';
  InsB[1].Tran:=$2100;
  InsB[1].Volm:=$40;
  InsB[1].LopS:=0;
  InsB[1].LopE:=$FFFF;
  InsB[1].Leng:=0;
  InsB[1].Inst:=NIL;
  InsB[1].W1:=0;
  InsB[1].W2:=0;
  FOR Cb:=2 TO 31 DO
    InsB[Cb]:=InsB[1];
  GetMem(PatB,65535);
  ASM
    PUSH ES
    LES  DI,PatB
    MOV  CX,0FFFFH
  @Again:
    MOV  WORD PTR ES:[DI+0],01FFH
    MOV  WORD PTR ES:[DI+2],0080H
    ADD  DI,4
    LOOP @Again
    POP  ES
  END;
  InitTabs;
  FillChar(Ch1,SizeOf(Ch1),0);
  FillChar(Ch2,SizeOf(Ch1),0);
  FillChar(Ch3,SizeOf(Ch1),0);
  FillChar(Ch4,SizeOf(Ch1),0);
  Ch1.On:=$1;
  Ch2.On:=$1;
  Ch3.On:=$1;
  Ch4.On:=$1;
  Ch1.OnV:=$1;
  Ch2.OnV:=$1;
  Ch3.OnV:=$1;
  Ch4.OnV:=$1;
  Ch1.Loop:=$FFFF;
  Ch2.Loop:=$FFFF;
  Ch3.Loop:=$FFFF;
  Ch4.Loop:=$FFFF;
END;

{$F+}
procedure myexit;
begin
 stop;
 exitproc:=oldexit;
end;

procedure gotopattern(b: byte);
begin
 nextpato:=ofs(ordb)+b-1;
 changepattern;
end;

begin
 initplayer;
 oldexit:=exitproc;
 exitproc:=@myexit;
 sdevice:=255;
end.
