{$G+}
uses mode256,crt,gurofill,loadpcx,realtime;

type
  laga = record
           ofs,seg: word;
         end;
var
 p: pointer;
 zbufseg,scrseg,bmpseg: word;
 palette: array [0..767] of byte;
 i,j,k: longint;

 s_right3dx,s_right3dy,s_right3dz,
      s_left3dx,s_left3dy,s_left3dz: array [0..199] of integer;
 n_3d : array [1..3] of integer;

procedure textmap_line(ind1,ind2,scrseg,zbufseg,bmpseg: word);

var
 x3,y3,z3,x2,y2: longint;
 x3add,y3add,z3add,x2add,y2add: longint;
 xb,yb,xbadd,ybadd: word;
 dx3,dy3,dz3,dx2,dy2: longint;
 dxb,dyb: integer;
 dy: longint;
 i,x,y: integer;

 label l1;
begin
 x3:=s_poly3d[ind1,1];
 y3:=s_poly3d[ind1,2];
 z3:=s_poly3d[ind1,3];

 x2:=s_poly2d[ind1,1];
 y2:=s_poly2d[ind1,2];

 xb:=s_polybmp[ind1,1];
 yb:=s_polybmp[ind1,2];

 dx3:=s_poly3d[ind2,1]-x3;
 dy3:=s_poly3d[ind2,2]-y3;
 dz3:=s_poly3d[ind2,3]-z3;

 dx2:=s_poly2d[ind2,1]-x2;
 dy2:=s_poly2d[ind2,2]-y2;

 dxb:=s_polybmp[ind2,1]-xb;
 dyb:=s_polybmp[ind2,2]-yb;

 dy:=abs(dy2);
 if dy=0 then goto l1;

 x3add:=dx3*65536 div dy;
 y3add:=dy3*65536 div dy;
 z3add:=dz3*65536 div dy;

 x2add:=dx2*65536 div dy;
 y2add:=dy2*65536 div dy;

 xbadd:=dxb*256 div dy;
 ybadd:=dyb*256 div dy;

 x3:=x3*65536;
 y3:=y3*65536;
 z3:=z3*65536;

 x2:=x2*65536;
 y2:=y2*65536;

 xb:=xb*256;
 yb:=yb*256;

 for i:=0 to dy do
   begin
    x:=laga(x2).seg;
    y:=laga(y2).seg;

    if x<s_leftx[y] then
        begin
         s_leftx[y]:=x;
         s_left3dx[y]:=laga(x3).seg;
         s_left3dy[y]:=laga(y3).seg;
         s_left3dz[y]:=laga(z3).seg;
         s_left_bmpxy[y]:=hi(yb)*256+hi(xb);
        end;
    if x>s_rightx[y] then
        begin
         s_rightx[y]:=x;
         s_right3dx[y]:=laga(x3).seg;
         s_right3dy[y]:=laga(y3).seg;
         s_right3dz[y]:=laga(z3).seg;
         s_right_bmpxy[y]:=hi(yb)*256+hi(xb);
        end;

    inc(x2,x2add);
    inc(y2,y2add);

    inc(xb,xbadd);
    inc(yb,ybadd);

    inc(x3,x3add);
    inc(y3,y3add);
    inc(z3,z3add);
   end;

 l1:
end;

procedure textmap_phong(srcseg,zbufseg,bmpseg: word);

var
 i: integer;
 x2: word;
 x2add: integer;
 y3,y3add: longint;
 dx2,dy3 : longint;
 xb,yb : word;
 dxb,dyb: integer;
 xbadd,ybadd: word;
 y: word;
 dx: word;
 b: byte;
 i1,i2,i3: word;
 i_,i_add,i_add2: longint;
 a_,b_,c_,k_: longint;
 l_3d : array [1..3] of longint;
 len : longint;

begin
 for i:=0 to 199 do
   begin
    s_rightx[i]:=-1;
    s_leftx[i]:=400;
   end;

 textmap_line(1,2,scrseg,zbufseg,bmpseg);
 textmap_line(2,3,scrseg,zbufseg,bmpseg);
 textmap_line(3,4,scrseg,zbufseg,bmpseg);
 textmap_line(4,1,scrseg,zbufseg,bmpseg);

 for y:=0 to 199 do
  begin
   dx2:=s_rightx[y]-s_leftx[y];
   if dx2>0 then
     begin
      dx:=abs(dx2);

      x2:=s_leftx[y];
      xb:=word(lo(s_left_bmpxy[y]))*256;
      yb:=word(hi(s_left_bmpxy[y]))*256;
      y3:=longint(s_left3dy[y])*65536;

      dxb:=lo(s_right_bmpxy[y])-lo(s_left_bmpxy[y]);
      dyb:=hi(s_right_bmpxy[y])-hi(s_left_bmpxy[y]);
      dy3:=s_right3dy[y]-s_left3dy[y];

      if dx2>0 then x2add:=1 else x2add:=0;
      y3add:=dy3*65536 div dx;
      xbadd:=dxb*256 div dx;
      ybadd:=dyb*256 div dx;

      l_3d[1]:=s_left3dx[y];
      l_3d[2]:=s_left3dy[y];
      l_3d[3]:=s_left3dz[y];

      len:=round(sqrt(sqr(longint(l_3d[1]))+sqr(longint(l_3d[2]))
          +sqr(longint(l_3d[3]))));

      i1:=round(128*(n_3d[1]*l_3d[1] + n_3d[2]*l_3d[2]+
               n_3d[3]*l_3d[3])/(len*128));

      l_3d[1]:=s_right3dx[y];
      l_3d[2]:=s_right3dy[y];
      l_3d[3]:=s_right3dz[y];

      len:=round(sqrt(sqr(longint(l_3d[1]))+sqr(longint(l_3d[2]))
          +sqr(longint(l_3d[3]))));

      i2:=round(128*(n_3d[1]*l_3d[1] + n_3d[2]*l_3d[2]+
               n_3d[3]*l_3d[3])/(len*128));

      l_3d[1]:=s_left3dx[y]+(s_right3dx[y]-s_left3dx[y]) div 2;
      l_3d[2]:=s_left3dy[y]+(s_right3dy[y]-s_left3dy[y]) div 2;
      l_3d[3]:=s_left3dz[y]+(s_right3dz[y]-s_left3dz[y]) div 2;

      len:=round(sqrt(sqr(longint(l_3d[1]))+sqr(longint(l_3d[2]))
          +sqr(longint(l_3d[3]))));

      i3:=round(128*(n_3d[1]*l_3d[1] + n_3d[2]*l_3d[2]+
               n_3d[3]*l_3d[3])/(len*128));

      c_:=longint(i1)*65536;
      k_:=(longint(i1+i2-2*i3)*2*65536) div dx;
      a_:=k_ div dx;
      b_:=longint(i2-i1)*65536 div dx - k_;

      i_:=c_;
      i_add:=a_+b_;
      i_add2:=2*a_;

    {  i_:=128*65536;
      i_add:=-128*65536 div dx;
      i_add2:=0;}

      for i:=0 to dx do
        begin
         b:=mem[bmpseg:hi(yb)*256+hi(xb)];
         b:=10;
         b:=b+(laga(i_).seg);

         mem[scrseg:y*320+x2]:=b;

         inc(x2,x2add);
         inc(xb,xbadd);
         inc(yb,ybadd);
         inc(y3,y3add);

         inc(i_,i_add);
         inc(i_add,i_add2);
        end;
     end;
  end;

end;

begin
 getmem(p,64000+32);
 zbufseg:=laga(p).seg+1;
 getmem(p,64000);

 getmem(p,64000+32);
 scrseg:=laga(p).seg+1;

 getmem(p,64000);
 bmpseg:=laga(p).seg+1;
 getmem(p,2000);

 loadpcx_raw_pal('c:\tmp\asc\texturei.pcx',ptr(bmpseg,0),addr(palette));

 asm
  mov es,bmpseg
  mov cx,65535
  xor si,si
  @l1:
  shr byte ptr es:[si],1
  inc si
  loop @l1
 end;

 setgfxmode;
{ setpalette(addr(palette));}
 setbwpalette256;

 for j:=0 to 255 do
    begin
     port[$3c8]:=j;
     k:=round(sin(j/255*pi/2)*63);
     port[$3c9]:=k;
     port[$3c9]:=k;
     port[$3c9]:=k;
    end;

 s_poly2d[1,1]:=0;    s_poly2d[1,2]:=0;
 s_poly2d[2,1]:=199;  s_poly2d[2,2]:=0;
 s_poly2d[3,1]:=199;  s_poly2d[3,2]:=199;
 s_poly2d[4,1]:=0;    s_poly2d[4,2]:=199;

 s_polybmp[1,1]:=0;   s_polybmp[1,2]:=0+128;
 s_polybmp[2,1]:=127;  s_polybmp[2,2]:=0+128;
 s_polybmp[3,1]:=127;  s_polybmp[3,2]:=127+128;
 s_polybmp[4,1]:=0;   s_polybmp[4,2]:=127+128;

 s_poly3d[1,1]:=-50;  s_poly3d[1,2]:=-5;  s_poly3d[1,3]:=-50;
 s_poly3d[2,1]:=50;   s_poly3d[2,2]:=-25;  s_poly3d[2,3]:=-50;
 s_poly3d[3,1]:=50;   s_poly3d[3,2]:=-25;  s_poly3d[3,3]:=50;
 s_poly3d[4,1]:=-50;  s_poly3d[4,2]:=-5;  s_poly3d[4,3]:=50;

{ s_poly3d[1,1]:=0;     s_poly3d[1,2]:=-100;  s_poly3d[1,3]:=0;
 s_poly3d[2,1]:=199;   s_poly3d[2,2]:=-100;  s_poly3d[2,3]:=0;
 s_poly3d[3,1]:=199;   s_poly3d[3,2]:=-100;  s_poly3d[3,3]:=199;
 s_poly3d[4,1]:=0;     s_poly3d[4,2]:=-100;  s_poly3d[4,3]:=199;}

 n_3d[1]:=0; n_3d[2]:=-128; n_3d[3]:=0;

 scrseg:=$a000;
 initzbuf(zbufseg);

 textmap_phong(scrseg,zbufseg,bmpseg);

 readln;

end.