unit Threed;

Interface

{$IFDEF DPMI}
 uses winapi;
{$ENDIF}

type
 ObserverType = record
                 x,y,z: Integer;
                 alfa_rad,beta_rad,gama_rad : LongInt;
                end;
Const
 eye_k  : word = 300;
 eye_hx : word = 320;
 eye_hz : word = 200;
 Delta_r : word = 5;
 cut_ymin : word = 20;

 Procedure Transform (n: Word; Obj3d, Observer, Vid3d: Pointer);
 Procedure Transform2 (n: Word; Obj3d, Observer, Vid3d: Pointer);
 Procedure Rotate_3D (n: Word; Obj3d, Observer, Vid3d: Pointer);
 Procedure Rotate_3D_back (n: Word; Obj3d, Observer, Vid3d: Pointer);
 Procedure ProectPoints (n: Word; Vid3d, Points: Pointer);
 Function  CalcSIN (alfa_rad_65536: longint): longint;
 Function  CalcCOS (alfa_rad_65536: longint): longint;
 Procedure Normalise (Observer: Pointer);
 Procedure IncAngles (Observer: Pointer; IncAlfa,IncBeta,IncGama: Longint);
 Procedure SphereLook (Observer: Pointer; Rad: Word);

{$IFNDEF DPMI}
 Procedure Calculate_h (n: Word; Vid3d,PolyData,PolyData_H: Pointer);
 Function  CalcPoint (i,j,num: integer;
     Vid3D,PolyData,PolyData_h: Pointer): Integer;
 Procedure CalcZnak (j,i: Integer; Vid3D,PolyData,Polydata_H: Pointer;
     var NNeg,NNul,NPos: integer);
 Function GetYmax (Poly: Pointer): Integer;
 Function GetYmin (Poly: Pointer): Integer;
 Function NoCrossX (poly2a,poly2b: Pointer): Boolean;
 Function NoCrossY (poly2a,poly2b: Pointer): Boolean;
 Function Behind (i,j: Word; Vid3D,
         PolyData,PolyData_h: Pointer): Boolean;
 Function InFront (i,j: Word; Vid3D,
         PolyData,PolyData_h: Pointer): Boolean;
 Procedure SwapPolys (i,j: word; Vid3D,Bars2D, Colors,
         PloyData,PolyData_H :Pointer);
 Procedure PriorSort (n: Word; Vid3D, Bars2D, Colors,
        PolyData, Polydata_h: Pointer);
 Procedure Cut_Ypl(P1,P2: Pointer; Ymin: Word; var p_out: Pointer;
      var Out_N: Word);
 Procedure Cut_Forward(Poly_Inp,Pily_Outp : Pointer; var Out_N: Word);
 Procedure Cut_Xpl(P1,P2: Pointer; tgalfa0xcut: LongInt; var p_out: Pointer;
      var Out_N: Word);

{$ENDIF}
 function visible (poly: pointer): boolean;
 Procedure SphereLook_p (Observer: Pointer; Rad: Word);


Implementation
 var
  csalias : word;

 {$F+}
 Procedure Transform(n: Word; Obj3d, Observer, Vid3d: Pointer); External;
 Procedure Transform2(n: Word; Obj3d, Observer, Vid3d: Pointer); External;
 Procedure Rotate_3D (n: Word; Obj3d, Observer, Vid3d: Pointer); EXternal;
 Procedure Rotate_3D_back (n: Word; Obj3d, Observer, Vid3d: Pointer); External;
 Procedure ProectPoints(n: Word; Vid3d, Points: Pointer);       External;
 Function  CalcSIN(alfa_rad_65536: longint): longint; external;
 Function  CalcCOS(alfa_rad_65536: longint): longint; external;

 {$IFNDEF DPMI}
 Procedure Calculate_h (n: Word; Vid3d,PolyData,PolyData_H: Pointer); External;
 Function  CalcPoint (i,j,num: integer;
     Vid3D,PolyData,PolyData_h: Pointer): Integer; External;
 Procedure CalcZnak (j,i: Integer; Vid3D,PolyData,Polydata_H: Pointer;
     var NNeg,NNul,NPos: integer); EXternal;
 Function GetYmax (Poly: Pointer): Integer; External;
 Function GetYmin (Poly: Pointer): Integer; External;
 Function NoCrossX (poly2a,poly2b: Pointer): Boolean; External;
 Function NoCrossY (poly2a,poly2b: Pointer): Boolean; External;
 Function Behind (i,j: Word; Vid3D,
         PolyData,PolyData_h: Pointer): Boolean;  External;
 Function Infront (i,j: Word; Vid3D,
         PolyData,PolyData_h: Pointer): Boolean;  External;
 Procedure SwapPolys (i,j: word; Vid3D,Bars2D, Colors,
         PloyData,PolyData_H :Pointer);  External;
 Procedure PriorSort (n: Word; Vid3D, Bars2D, Colors,
        PolyData, Polydata_h: Pointer);  External;
 Procedure Cut_Ypl(P1,P2: Pointer; Ymin: Word; var p_out: Pointer;
      var Out_N: Word);   External;
 Procedure Cut_Forward(Poly_Inp,Pily_Outp : Pointer; var Out_N: Word); External;
Procedure Cut_Xpl(P1,P2: Pointer; tgalfa0xcut: LongInt; var p_out: Pointer;
      var Out_N: Word);       External;

 {$ENDIF}
 Procedure SphereLook (Observer: Pointer; Rad: Word); External;
 {$F-}
 {$L threed}

 Procedure Normalise (Observer: Pointer);
 begin
  if ObserverType(Observer^).alfa_rad>411775
         then dec(ObserverType(Observer^).alfa_rad,411775);
 if ObserverType(Observer^).beta_rad>411775
         then dec(ObserverType(Observer^).beta_rad,411775);
 if ObserverType(Observer^).gama_rad>411775
         then dec(ObserverType(Observer^).gama_rad,411775);
 end;

 Procedure IncAngles (Observer: Pointer; IncAlfa,IncBeta,IncGama: Longint);
 begin
  inc(ObserverType(Observer^).alfa_rad,IncAlfa);
  inc(ObserverType(Observer^).beta_rad,IncBeta);
  inc(ObserverType(Observer^).gama_rad,IncGama);
  Normalise (Observer);
 end;

function visible (poly: pointer): boolean; assembler;
 asm
  push ds
  lds si,poly
  mov ax,[si+0*4+0*2]             {1,1}
  imul word ptr [si+1*4+1*2]      {2,2}
  mov cx,ax
  mov di,dx

  mov ax,[si+0*4+1*2]             {1,2}
  imul word ptr [si+2*4+0*2]      {3,1}
  add cx,ax
  adc di,dx

  mov ax,[si+1*4+0*2]             {2,1}
  imul word ptr [si+2*4+1*2]      {3,2}
  add cx,ax
  adc di,dx

  mov ax,[si+2*4+0*2]             {3,1}
  imul word ptr [si+1*4+1*2]      {2,2}
  sub cx,ax
  sbb di,dx

  mov ax,[si+1*4+0*2]             {2,1}
  imul word ptr [si+0*4+1*2]      {1,2}
  sub cx,ax
  sbb di,dx

  mov ax,[si+0*4+0*2]             {1,1}
  imul word ptr [si+2*4+1*2]      {3,2}
  sub cx,ax
  sbb di,dx

  mov al,true
  jns @l1
  mov al,false
  @l1:
  pop ds
 end;


 Procedure SphereLook_p (Observer: Pointer; Rad: Word);
 var
  re: Longint;
 begin
  ObserverType(Observer^).z:=
     -rad*calcsin(ObserverType(Observer^).beta_rad) div 65536;
  re:=rad*calccos(ObserverType(Observer^).beta_rad) div 65536;
  ObserverType(Observer^).x:=
     -re*calcsin(ObserverType(Observer^).alfa_rad) div 65536;
  ObserverType(Observer^).y:=
     -re*calccos(ObserverType(Observer^).alfa_rad) div 65536;
 end;

{function visible_p (poly: pointer): boolean;
var
 poly2d: array [1..4,1..2] of integer;
begin
 move(poly^,poly2d,sizeof(poly2d));
 if poly2d[1,1]*poly2d[2,2]+
    poly2d[1,2]*poly2d[3,1]+
    poly2d[2,1]*poly2d[3,2]-
    poly2d[3,1]*poly2d[2,2]-
    poly2d[2,1]*poly2d[1,2]-
    poly2d[1,1]*poly2d[3,2]>0 then
       visible_p:=true
            else
             visible_p:=false;
end;}


begin
 {$IFNDEF DPMI}
  csalias:=cseg;
 {$ELSE}
  csalias:=cseg+selectorinc;
 {$ENDIF}
end.