unit titl;

INTERFACE
function run_titl:byte;
var
midasproc:pointer;
mode13,mode10,mode12:word;

IMPLEMENTATION

uses loadpcx,realtime,mode256,mytimer,palete,timer,mycrt;
type
 laga= record
  ofs,seg: word;
 end;

 const
  rnddata: longint= $0;

type
  arr1 = array [0..10000] of word;
var
 w:word;
 fade: byte;
 buf1p,buf2p: pointer;
 buf1,buf2: word;
 i,x,y: integer;
 palette : array [1..768] of byte;
 palette1 : array [1..768] of byte;
 palette2 : array [1..768] of byte;
 f:file;
 coordbuf: pointer;
 npoi:word;
 t,r,tfreq: real;

procedure fire(buf1,buf2,ofss,sizex,sizey:word); assembler;
asm
 push ds
 mov es,buf2
 mov ds,buf1
 mov di,ofss
 inc di

 mov dx,sizey
 @l2:
 mov cx,sizex
 push di
 @l1:
 xor ax,ax
 mov al,[di]
 add al,[di+320]
 adc ah,dh
 add al,[di+320-1]
 adc ah,dh
 add al,[di+640]
 adc ah,dh

 shr ax,2
 sub al,8
{ jnc @l3
 xor al,al
 @l3:}
 rcl ah,4
 add al,ah
 stosb
 dec cx
 jne @l1
 pop di
 add di,320
 dec dx
 jne @l2
 pop ds
end;

function checkexit:boolean;
begin
checkexit:=false;
 if keypressed then
     if readkey=#27 then checkexit:=true;
end;

procedure copytoscreen(p:pointer;ofss,len:word); assembler;
asm
 mov dx,3ceh
 mov ax,0ff08h
 out dx,ax
 mov ax,0005h
 out dx,ax
 mov dx,3c4h
 mov ax,0ff02h
 out dx,ax
 push ds
 mov cx,len
 mov ax,sega000
 mov es,ax
 mov di,ofss
 lds si,p
 cld
 rep movsb
 pop ds
end;

procedure clearscreen; assembler;
asm
 mov dx,3ceh
 mov ax,0ff08h
 out dx,ax
 mov ax,0005h
 out dx,ax
 mov dx,3c4h
 mov ax,0ff02h
 out dx,ax
 mov cx,14000
 mov ax,sega000
 mov es,ax
 xor di,di
 xor ax,ax
 cld
 rep stosw
end;

procedure encode(buf1seg,buf2seg,len:word);assembler;
asm
 push ds
 mov es,buf2seg
 mov ds,buf1seg
 cld
 xor si,si
 xor di,di
 mov cx,len
 add cx,7
 shr cx,3
 shl cx,3
 @l2:
 mov bl,8

 @l1:
 lodsb
 shl al,1
 rcl bh,1
 dec bl
 jne @l1

 mov al,bh
 stosb

 sub cx,8
 jnz @l2
 pop ds
end;

function present(fname:string;sy,starty,time:word):boolean;
label l2;
begin
 present:=true;
 t:=bigcounter;

 clearscreen;
 loadpcx_raw(fname,ptr(buf1,0));
 encode(buf1,buf2,640*sy);
 copytoscreen(ptr(buf2,0),starty*80,80*sy);

 r:=0;
 repeat
  fadepalette(@palette,@palette1,round(r));
  waitvertsync;
  setpalette(@palette1);
  r:=(bigcounter-t)/tfreq*150;
  if checkexit then goto l2;
 until r>255;

 setpalette(@palette);

 t:=bigcounter;
 while (bigcounter-t)/tfreq<time do if checkexit then goto l2;

 t:=bigcounter;
 r:=255;
 repeat
  fadepalette(@palette,@palette1,round(r));
  waitvertsync;
  setpalette(@palette1);
  r:=255-(bigcounter-t)/tfreq*150;
  if checkexit then goto l2;
 until r<0;
 present:=false;
 l2:
end;

procedure showverse(bufseg,scrofs,sx,sy:word); assembler;
asm
 mov dx,3ceh
 mov ax,0ff08h
 out dx,ax
 mov ax,0005h
 out dx,ax
 mov dx,3c4h
 mov ax,0ff02h
 out dx,ax
 push ds
 mov ax,sega000
 mov es,ax
 mov di,scrofs
 mov ds,bufseg
 xor si,si
 mov dx,sy

 @l1:
 push si
 push di
 mov cx,sx
 cld
 rep movsb
 pop di
 pop si
 add si,sx
 add di,80
 dec dx
 jne @l1
 pop ds
end;

{==========================================================
 MAIN
 ==========================================================}
function run_titl:byte;
label l1,l2,l3,l4;
begin
 run_titl:=1;

 getmem(buf1p,64016);
 getmem(buf2p,64016);
 buf1:=laga(buf1p).seg;
 buf2:=laga(buf2p).seg;
 getmem(coordbuf,20000);

 smartsetmode($12);

 tmrSyncScr(mode12,midasproc,nil,nil);
 tfreq:=2386363/mode12;

 t:=bigcounter;
 while (bigcounter-t)/tfreq<1 do if checkexit then goto l2;

 getpalette(@palette);
 fillchar(palette1,768,0);
 setpalette(@palette1);

 t:=bigcounter;

 assign(f,'verse.bin'); reset(f,1);
 blockread(f,ptr(buf1,0)^,6567);
 close(f);

 showverse(buf1,23+120*80,33,199);

 r:=0;
 repeat
  fadepalette(@palette,@palette1,round(r));
  waitvertsync;
  setpalette(@palette1);
  r:=(bigcounter-t)/tfreq*30;
  if checkexit then goto l2;
 until r>255;

 setpalette(@palette);

 t:=bigcounter;
 while (bigcounter-t)/tfreq<5 do if checkexit then goto l2;

 t:=bigcounter;
 r:=255;
 repeat
  fadepalette(@palette,@palette1,round(r));
  waitvertsync;
  setpalette(@palette1);
  r:=255-(bigcounter-t)/tfreq*100;
  if checkexit then goto l2;
 until r<0;

 tmrstopscrsync;
 smartsetmode($13);
 tmrSyncScr(mode13,midasproc,nil,nil);
 tfreq:=2386363/mode13;

 fillchar(palette1,768,0);
 setpalette(@palette1);

 t:=bigcounter;
 while (bigcounter-t)/tfreq<3 do if checkexit then goto l2;

 fillchar(palette1,768,255);
 setpalette(@palette1);
 waitvertsync;
 waitvertsync;
 fillchar(palette1,768,0);
 setpalette(@palette1);

 t:=bigcounter;
 while (bigcounter-t)/tfreq<3 do if checkexit then goto l2;

 fillchar(palette1,768,255);
 setpalette(@palette1);
 waitvertsync;
 waitvertsync;
 fillchar(palette1,768,0);
 setpalette(@palette1);

 t:=bigcounter;
 while (bigcounter-t)/tfreq<0.1 do if checkexit then goto l2;

 fillchar(palette1,768,255);
 setpalette(@palette1);
 waitvertsync;
 waitvertsync;
 fillchar(palette1,768,0);
 setpalette(@palette1);

 t:=bigcounter;
 while (bigcounter-t)/tfreq<2 do if checkexit then goto l2;

 fillchar(palette1,768,255);
 setpalette(@palette1);
 waitvertsync;
 waitvertsync;
 fillchar(palette1,768,0);
 setpalette(@palette1);

 t:=bigcounter;
 while (bigcounter-t)/tfreq<2 do if checkexit then goto l2;

 t:=bigcounter;

 loadpcx_raw_pal('titl.pcx',ptr(buf1,0),@palette);

 fillchar(palette2,768,63);
 setpalette(@palette1);
 move(mem[buf1:0],mem[sega000:0],64000);

 r:=0;
 repeat
  morfpalette(@palette2,@palette,@palette1,round(r));
  waitvertsync;
  setpalette(@palette1);
  r:=(bigcounter-t)/tfreq*200;
  if checkexit then goto l2;
 until r>255;

 setpalette(@palette);
 t:=bigcounter;
 while (bigcounter-t)/tfreq<1 do if checkexit then goto l2;

 t:=bigcounter;

 if paramstr(1)<>'/wearesuperk00l' then goto l4;
 loadpcx_raw_pal('titlk00l.pcx',ptr(buf1,0),@palette);

 fillchar(palette1,768,63);
 setpalette(@palette1);
 move(mem[buf1:0],mem[sega000:0],64000);
 waitvertsync;
 waitvertsync;
 setpalette(@palette);

 l4:
 while (bigcounter-t)/tfreq<2 do if checkexit then goto l2;

 for i:=1 to 768 do
      if (i mod 3)=1 then  palette1[i]:=63 else palette1[i]:=10;

 setpalette(@palette1);

 t:=bigcounter;
 fillchar(mem[sega000:0],64000,0);

 assign(f,'fire.pal'); reset(f,1);
 blockread(f,palette,768);
 close(f);
 assign(f,'titlfir.fir');reset(f,1);
 npoi:=filesize(f) div 2;
 blockread(f,coordbuf^,npoi*2);
 close(f);

 fillchar(mem[buf1:0],64000,0);
 fillchar(mem[buf2:0],64000,0);
 fade:=0;
 l1:

 if fade=0 then
   begin
    r:=(bigcounter-t)/tfreq*200;
    if r>255 then
      begin
       fade:=1;
       setpalette(@palette);
       fillchar(palette1,768,0);
      end
        else
      begin
       morfpalette(@palette1,@palette,@palette2,round(r));
       waitvertsync;
       setpalette(@palette2);
      end;
   end;

 if (bigcounter-t)/tfreq>5 then fade:=2;

 if fade=1 then waitvertsync;

 if  fade=2 then
   begin
    r:=((bigcounter-t)/tfreq-5)*150;
    if r>255 then goto l3
        else
      begin
       morfpalette(@palette,@palette1,@palette2,round(r));
       waitvertsync;
       setpalette(@palette2);
      end;
   end;

 fire(buf1,buf2,320*50,320,90);
 copybitmap(320,50,320,90,320,50,buf2,sega000);
{ move(mem[buf2:0],mem[sega000:0],64000);}

 i:=buf1;
 buf1:=buf2;
 buf2:=i;

{ for i:=1 to 1000 do mem[buf1:coordbuf[random(npoi)]]:=255;}

 asm
  push bp
  push ds
  mov es,buf1
  mov si,word ptr rnddata
  mov di,word ptr rnddata+2
  mov cx,700
  mov bp,npoi

  mov ds,word ptr coordbuf+2

  @l1:
  MOV BX,di
  add bh,bl
  add bx,si
  inc si
  MOV di,bX

  mov ax,bx
  xor dx,dx
  div bp
  mov bx,dx

  shl bx,1
  mov bx,[bx]
{ add byte ptr es:[bx],100}
  mov byte ptr es:[bx],255

  dec cx
  jne @l1
  pop ds
  pop bp
  mov word ptr rnddata,si
  mov word ptr rnddata+2,di
 end;

 if checkexit then goto l2;
 goto l1;

 l3:

 tmrstopscrsync;
 smartsetmode($10);
 tmrSyncScr(mode10,midasproc,nil,nil);
 tfreq:=2386363/mode10;

 getpalette(@palette);
 fillchar(palette1,768,0);
 setpalette(@palette1);

 t:=bigcounter;
 while (bigcounter-t)/tfreq<1 do if checkexit then goto l2;

 if present('present.pcx',39,155,2) then goto l2;

 if present('hax.pcx',91,0,2) then goto l2;

 if present('demiurg.pcx',100,250,2) then goto l2;

 run_titl:=0;
 l2:
 freemem(buf1p,64016);
 freemem(buf2p,64016);
 freemem(coordbuf,20000);
 tmrstopscrsync;
 clearkeyb;
end;

begin
end.