{$G+}
uses gurofill,crt,mode256,threed,realtime;

const
 maxnobj = 40;
 maxnfaces = 2000;
 maxnvertices = 1000;
 nobj : byte = 0;
 radius : word = 4000;
 q1: word = 1;
 q2: word = 1;
 q3: word = 1;

type
 VertexArrType  = array [1..10000,1..3] of integer;
 FacesArrType   = array [1..10000,1..3] of word;
 NormalsArrType = array [1..10000,1..3] of integer;
 vid3dtype      = array [1..maxnvertices,1..3] of integer;
 obj2dtype      = array [1..maxnvertices,1..2] of integer;
 colorstype     = array [1..maxnfaces] of word;
 newnormalstype = array [1..maxnfaces,1..3] of integer;
 U_poly_3dtype  = array [1..maxnfaces,1..3,1..3] of integer;
 U_poly_2dtype  = array [1..maxnfaces,1..3,1..2] of integer;
 U_colors3type  = array [1..maxnfaces,1..3] of word;

 laga = record
    ofs,seg: word
        end;

var
 t: longint;
 poly_3d : array [1..4,1..3] of integer;
 poly_2d : array [1..4,1..2] of integer;

 obj_vertices: array [1..maxnobj] of ^vertexarrtype;
 obj_faces : array [1..maxnobj] of ^facesarrtype;
 obj_names : array [1..maxnobj] of string;
 obj_normals : array [1..maxnobj] of ^normalsarrtype;
 obj_nfaces : array [1..maxnobj] of word;
 obj_nvertices : array [1..maxnobj] of word;
 i,j,k: integer;
 vid3d : ^vid3dtype;
 obj2d : ^obj2dtype;
 colors : ^colorstype;
 observer : observertype;
 newnormals : ^newnormalstype;
 backbuf : pointer;
 backbufseg: word;
 zbuf: pointer;
 zbufseg : word;
 a,b,c,n : longint;
 u_poly_2d : ^u_poly_2dtype;
 u_poly_3d : ^u_poly_3dtype;
 u_colors3 : ^u_colors3type;
 upl3d,upl2d,upcl : pointer;
 f: file;
 fname  :string;
 dist,maxdist : longint;
 ch:char;
 maxx,minx,maxy,miny,maxz,minz : integer;

 {$F+}
procedure guropal; external;
{$L d:\guropal}
{$F-}

function getnextline(var ft:text): string;
var
 s: string;
 label l1,l2;
begin
 l1:
 if eof(ft) then
   begin
    s:='';
    goto l2;
   end;
 readln(ft,s);
 while (length(s)>0) and (s[1]=' ') do s:=copy(s,2,255);
 if s='' then goto l1;
 if copy(s,1,4)='Page' then goto l1;
 l2:
 getnextline:=s;
end;

procedure LoadAscFile (fname:string);
var
 ft: text;
 s,s1,s2,s3 : string;
 i: integer;
 nvertices,nfaces: word;
 curvertex,curface: word;
 r: real;
 label l1,l2,l3,l4;
begin
 writeln('Loading ASC file "',fname,'"');

 assign(ft,fname); reset(ft);

 while not eof (ft) do
   begin
    s:=getnextline(ft);

    if copy(s,1,12)='Named object' then
      begin
       s1:=getnextline(ft);
       if copy (s1,1,19)<>'Tri-mesh, Vertices:' then
            begin
             writeln('Skiped "',s);
             writeln('        ',s1);
             goto l1;
            end;
       s:=copy(s,15,255);
       inc(nobj);
       if nobj>maxnobj then
          begin
           dec(nobj);
           writeln ('------ too many objects ! (skiped)');
           goto l1;
          end;

{       if nobj=2 then goto l4;}
       obj_names[nobj]:=s;
       writeln('Loading object: ',s);
       writeln('        ',s1);

       s1:=copy(s1,21,255);
       i:=1;
       while s1[i] in ['0'..'9'] do inc(i);
       s2:=copy(s1,1,i-1);
       val(s2,nvertices,i);
       i:=1;
       while s1[i]<>'F' do inc(i);
       s1:=copy(s1,i+7,255);
       val(s1,nfaces,i);

       obj_nfaces[nobj]:=nfaces;
       obj_nvertices[nobj]:=nvertices;

       if obj_nfaces[nobj]>maxnfaces then
          begin
           dec(nobj);
           writeln ('------ too many faces ! (skiped)');
           goto l1;
          end;

       if obj_nvertices[nobj]>maxnvertices then
          begin
           dec(nobj);
           writeln ('------ too many vertices ! (skiped)');
           goto l1;
          end;

       getmem(obj_vertices[nobj],nvertices*3*2);
       getmem(obj_faces[nobj],nfaces*3*2);

       writeln('        Loading vertex list');
       s:=getnextline(ft);
       if s='Mapped' then
         begin
          writeln('Mapped !!!!!!');
          s:=getnextline(ft);
         end;

       for curvertex:=1 to nvertices do
         begin
          write('        Vertex: ',curvertex,#13);
          l2:
          s:=getnextline(ft);
          if copy(s,1,6)<>'Vertex' then goto l2;

          i:=6;
          while s[i]<>':' do inc(i);
          inc(i);

          while s[i]<>':' do inc(i);
          inc(i);
          while s[i]=' ' do inc(i);
          s:=copy(s,i,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val (s1,r,i);
          obj_vertices[nobj]^[curvertex,1]:=round(r*1);

          i:=1;
          while s[i]<>':' do inc(i);
          inc(i);
          while s[i]=' ' do inc(i);
          s:=copy(s,i,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val (s1,r,i);
          obj_vertices[nobj]^[curvertex,2]:=round(r*1);

          i:=1;
          while s[i]<>':' do inc(i);
          inc(i);
          while s[i]=' ' do inc(i);
          s:=copy(s,i,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val (s1,r,i);
          obj_vertices[nobj]^[curvertex,3]:=round(r*1);
         end;
       writeln;
       writeln('        Loading Face list');
       s:=getnextline(ft);

       for curface:=1 to nfaces do
         begin
          write('        Face: ',curface,#13);
          l3:
          s:=getnextline(ft);
          if copy(s,1,4)<>'Face' then goto l3;

          i:=4;
          while s[i]<>':' do inc(i);
          inc(i);
          while s[i]<>':' do inc(i);
          s:=copy(s,i+1,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val (s1,r,i);
          obj_faces[nobj]^[curface,1]:=round(r)+1;

          while s[i]<>':' do inc(i);
          s:=copy(s,i+1,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val(s1,r,i);
          obj_faces[nobj]^[curface,2]:=round(r)+1;

          while s[i]<>':' do inc(i);
          s:=copy(s,i+1,255);
          i:=1;
          while s[i]<>' ' do inc(i);
          s1:=copy(s,1,i-1);
          val(s1,r,i);
          obj_faces[nobj]^[curface,3]:=round(r)+1;
         end;
       writeln;
      end;


    l1:
   end;
l4:
 close(ft);
 writeln('Ok');
 writeln;
end;

procedure calcnormal(norm: pointer);
type
 normalt = array [1..3] of integer;
var
 x1,y1,z1   : integer;
 x21,x31, y21,y31, z21,z31    : longint;
 a,b,c,m : real;
 i,j : word;

begin
 x1:=poly_3d[1,1];
 y1:=poly_3d[1,2];
 z1:=poly_3d[1,3];

 x21:=poly_3d[2,1]-x1;
 y21:=poly_3d[2,2]-y1;
 z21:=poly_3d[2,3]-z1;

 x31:=poly_3d[3,1]-x1;
 y31:=poly_3d[3,2]-y1;
 z31:=poly_3d[3,3]-z1;

 a:= y21*z31 - y31*z21;
 b:= z21*x31 - x21*z31;
 c:= x21*y31 - x31*y21;

 m:=sqrt(sqr(a)+sqr(b)+sqr(c));
if m<>0 then
 begin
  a:=(a*127)/m;
  b:=(b*127)/m;
  c:=(c*127)/m;
 end
   else
     begin
      writeln;
      writeln('------------ normal length = 0 !');
    {  halt;}
     a:=127;
     b:=0;
     c:=0;
     end;
 normalt(norm^)[1]:=round(a);
 normalt(norm^)[2]:=round(b);
 normalt(norm^)[3]:=round(c);
end;

function visible_p (poly: pointer): boolean;
var
 poly2d: array [1..4,1..2] of integer;
begin
 move(poly^,poly2d,sizeof(poly2d));
 if poly2d[1,1]*poly2d[2,2]+
    poly2d[1,2]*poly2d[3,1]+
    poly2d[2,1]*poly2d[3,2]-
    poly2d[3,1]*poly2d[2,2]-
    poly2d[2,1]*poly2d[1,2]-
    poly2d[1,1]*poly2d[3,2]>0 then
       visible_p:=true
            else
             visible_p:=false;
end;

function visible (poly: pointer): boolean; assembler;
 asm
  push ds
  lds si,poly
  mov ax,[si+0*4+0*2]             {1,1}
  imul word ptr [si+1*4+1*2]      {2,2}
  mov cx,ax
  mov di,dx

  mov ax,[si+0*4+1*2]             {1,2}
  imul word ptr [si+2*4+0*2]      {3,1}
  add cx,ax
  adc di,dx

  mov ax,[si+1*4+0*2]             {2,1}
  imul word ptr [si+2*4+1*2]      {3,2}
  add cx,ax
  adc di,dx

  mov ax,[si+2*4+0*2]             {3,1}
  imul word ptr [si+1*4+1*2]      {2,2}
  sub cx,ax
  sbb di,dx

  mov ax,[si+1*4+0*2]             {2,1}
  imul word ptr [si+0*4+1*2]      {1,2}
  sub cx,ax
  sbb di,dx

  mov ax,[si+0*4+0*2]             {1,1}
  imul word ptr [si+2*4+1*2]      {3,2}
  sub cx,ax
  sbb di,dx

  mov al,true
  jns @l1
  mov al,false
  @l1:
  pop ds
 end;

 label l1;

begin
if paramcount =0 then
  begin
   writeln('Try "filename.asc" as parameter :)');
   writeln('In view mode:');
   writeln('  Keys "q","w","e" - alfa,beta,gama roration on/off');
   writeln('       "a","s","d" - zero alfa,beta,bama');
   halt
  end;
 getmem(backbuf,64000+32);
 backbufseg:=laga(backbuf).seg+1;

 getmem(zbuf,64000+16);
 zbufseg:=laga(zbuf).seg+1;
 getmem(zbuf,64000+32);

 getmem(vid3d,sizeof(vid3dtype));
 getmem(obj2d,sizeof(obj2dtype));
 getmem(colors,sizeof(colorstype));
 getmem(newnormals,sizeof(newnormalstype));
 getmem(u_poly_2d,sizeof(u_poly_2dtype));
 getmem(u_poly_3d,sizeof(u_poly_3dtype));
 getmem(u_colors3,sizeof(u_colors3type));

 textmode(3);
{ assign(f,'d:\guropal.pal'); reset(f,1);
 blockread(f,palette,768);
 close(f);}

 fname:=paramstr(1);
{ fname:='c:\tmp\asc\duck.asc';}
 loadascfile(fname);

 writeln('Calculating normals:');
 writeln('============================');

  for i:=1 to nobj do
    begin
     writeln('Object #',i,': ',obj_names[i],
           ', ',obj_nfaces[i],' faces, ',obj_nvertices[i],' vertices');
     writeln('     Calculating face normals:');
     for j:=1 to obj_nfaces[i] do
       begin
        write('     Face: ',j,#13);
        move(obj_vertices[i]^[obj_faces[i]^[j,1]],poly_3d[1],6);
        move(obj_vertices[i]^[obj_faces[i]^[j,2]],poly_3d[2],6);
        move(obj_vertices[i]^[obj_faces[i]^[j,3]],poly_3d[3],6);
        calcnormal(addr(newnormals^[j]));
       end;
     writeln ('     Done.           ');
     writeln('     Calculating normals in vertices:');
     getmem(obj_normals[i],obj_nvertices[i]*2*3);
     for j:=1 to obj_nvertices[i] do
       begin

        write('     Vertex: ',j,#13);
         a:=0; b:=0; c:=0; n:=0;

         for k:=1 to obj_nfaces[i] do
            if (obj_faces[i]^[k,1]=j) or
               (obj_faces[i]^[k,2]=j) or
               (obj_faces[i]^[k,3]=j) then
{                if n=0 then}
                 begin
                  inc(n);
                  inc(a,newnormals^[k,1]);
                  inc(b,newnormals^[k,2]);
                  inc(c,newnormals^[k,3]);
                 end;

         if n=0 then
           begin
            writeln;
            writeln ('-------- null normal !');
            inc(n);
           end;
         obj_normals[i]^[j,1]:=a div n;
         obj_normals[i]^[j,2]:=b div n;
         obj_normals[i]^[j,3]:=c div n;
       end;
     writeln ('     Done.           ');
     writeln;
    end;

 writeln;
 writeln ('Centering....');
 writeln ('=========================');

 minx:=32760;
 miny:=32760;
 minz:=32760;
 maxx:=-32760;
 maxy:=-32760;
 maxz:=-32760;

 for i:=1 to nobj do
   begin
    upcl:=obj_vertices[i];
    for j:=1 to obj_nvertices[i] do
      asm
       les si,upcl
       mov ax,es:[si]
       cmp ax,maxx
       jl @l1
       mov maxx,ax
       @l1:
       cmp ax,minx
       jg @l2
       mov minx,ax
       @l2:

       mov ax,es:[si+2]
       cmp ax,maxy
       jl @l1a
       mov maxy,ax
       @l1a:
       cmp ax,miny
       jg @l2a
       mov miny,ax
       @l2a:

       mov ax,es:[si+2+2]
       cmp ax,maxz
       jl @l1b
       mov maxz,ax
       @l1b:
       cmp ax,minz
       jg @l2b
       mov minz,ax
       @l2b:

       add word ptr upcl,6
      end;
     end;

 minx:=(minx+maxx) div 2;
 miny:=(miny+maxy) div 2;
 minz:=(minz+maxz) div 2;

 for i:=1 to nobj do
   begin
    upcl:=obj_vertices[i];
    for j:=1 to obj_nvertices[i] do
      asm
       les si,upcl

       mov ax,minx
       sub es:[si],ax

       mov ax,miny
       sub es:[si+2],ax

       mov ax,minz
       sub es:[si+2+2],ax

       add word ptr upcl,6
      end;
   end;

 writeln;
 writeln ('Calculating distances');
 writeln ('=========================');

 maxdist:=0;
 for i:=1 to nobj do
   begin
    upcl:=obj_vertices[i];
    write('object #',i,#13);
    for j:=1 to obj_nvertices[i] do
      asm
       les si,upcl
       mov ax,es:[si]
       mov di,ax
       imul di
       mov cx,ax
       mov bx,dx

       mov ax,es:[si+2]
       mov di,ax
       imul di
       add cx,ax
       adc bx,dx

       mov ax,es:[si+2+2]
       mov di,ax
       imul di
       add cx,ax
       adc bx,dx

       cmp word ptr maxdist+2,bx
       ja @l1
       jc @l2
       cmp word ptr maxdist,cx
       ja @l1
       @l2:
       mov word ptr maxdist+2,bx
       mov word ptr maxdist,cx
       @l1:
       add word ptr upcl,6
      end;
   end;

 writeln;
 radius:=round(sqrt(maxdist)*3.2);

 observer.alfa_rad:=0;
 observer.beta_rad:=0;
 observer.gama_rad:=0;

 setgfxmode;
{ setbwpalette256;}
 setpalette(addr(guropal));

 ls_normal[1]:=80;
 ls_normal[2]:=-99;
 ls_normal[3]:=0;

 kr:=15+32+32+32+32+32;
 kd:=16;

 textattr:=$70;
 directvideo:=false;

l1:

 repeat

 t:=timercounter;
 clearvga(backbufseg);
 initzbuf(zbufseg);

 spherelook(addr(observer),radius);

 for i:=1 to nobj do
   begin
    Rotate_3d(obj_nvertices[i],obj_normals[i],addr(observer),newnormals);
    transform(obj_nvertices[i],obj_vertices[i],addr(observer),vid3d);
    proectpoints(obj_nvertices[i],vid3d,obj2d);
    calccolors(obj_nfaces[i],newnormals,colors);

    unpacktriangle (obj_nfaces[i], vid3d, obj2d, obj_faces[i],
           colors, u_poly_3d, u_poly_2d, u_colors3);

    upl3d:=u_poly_3d;
    upl2d:=u_poly_2d;
    upcl:=u_colors3;

       asm
        lea si,obj_nfaces-2
        mov bx,i
        shl bx,1
        mov cx,[si+bx]

        @l2:
        push cx
        push word ptr upl2d+2
        push word ptr upl2d
        call visible
        or al,al
        je @l1

        push word ptr upl3d+2;
        push word ptr upl3d;
        push word ptr upl2d+2;
        push word ptr upl2d;
        les si,upcl
        push word ptr es:[si]
        push word ptr es:[si+2]
        push word ptr es:[si+4]
        push word ptr backbufseg
        push word ptr zbufseg
        call filltriangle_zbuf_guro

        @l1:
        add word ptr upl3d,6*3
        add word ptr upl2d,4*3
        add word ptr upcl,2*3

        pop cx
        dec cx
        jne @l2

      end;

   end;
  copytoscreen(backbufseg);
  gotoxy(1,1); writeln(1024/(timercounter-t):2:3);
  incangles(addr(observer),q1*round(3*1444/200*(timercounter-t)),
        q2*round(2*1444/200*(timercounter-t)),
        q3*round(1*1444/200*(timercounter-t)));
 until keypressed;

 ch:=readkey;
 if ch in ['0'..'6'] then kr:=15+(ord(ch)-ord('0'))*32;

 if ch='q' then if q1=0 then q1:=1 else q1:=0;
 if ch='w' then if q2=0 then q2:=1 else q2:=0;
 if ch='e' then if q3=0 then q3:=1 else q3:=0;

 if ch='a' then observer.alfa_rad:=0;
 if ch='s' then observer.beta_rad:=0;
 if ch='d' then observer.gama_rad:=0;

 if ch<>#27 then goto l1;

 settxtmode;
writeln('(c) HAX');
while keypressed do readkey;
end.