{$G+}
uses gurofill,crt,mode256,threed,realtime,loadpcx,loadasc;

const
 maxnobj = 30;
 maxnfaces = 1800;
 maxnvertices = 1400;
 nobj : byte = 0;
 radius : word = 4000;
 q1: word = 1;
 q2: word = 1;
 q3: word = 1;

type
 VertexArrType  = array [1..10000,1..3] of integer;
 FacesArrType   = array [1..10000,1..3] of word;
 NormalsArrType = array [1..10000,1..3] of integer;
 vid3dtype      = array [1..maxnvertices,1..3] of integer;
 obj2dtype      = array [1..maxnvertices,1..2] of integer;
 colorstype     = array [1..maxnfaces] of word;
 newnormalstype = array [1..maxnfaces,1..3] of integer;
 U_poly_3dtype  = array [1..maxnfaces,1..3,1..3] of integer;
 U_poly_2dtype  = array [1..maxnfaces,1..3,1..2] of integer;
 U_colors3type  = array [1..maxnfaces,1..3] of word;
 facesbmpxyarrtype = array [1..maxnfaces,1..3] of word;

 laga = record
    ofs,seg: word
        end;

var
 t: longint;
 poly_3d : array [1..4,1..3] of integer;
 poly_2d : array [1..4,1..2] of integer;

 obj_vertices: array [1..maxnobj] of ^vertexarrtype;
 obj_faces : array [1..maxnobj] of ^facesarrtype;
 obj_bmpxy : array [1..maxnobj] of ^facesbmpxyarrtype;
 obj_names : array [1..maxnobj] of string;
 obj_normals : array [1..maxnobj] of ^normalsarrtype;
 obj_nfaces : array [1..maxnobj] of word;
 obj_nvertices : array [1..maxnobj] of word;
 i,j,k: integer;
 vid3d : ^vid3dtype;
 obj2d : ^obj2dtype;
 colors : ^colorstype;
 observer : observertype;
 newnormals : ^newnormalstype;
 backbuf : pointer;
 backbufseg: word;
 zbuf: pointer;
 zbufseg : word;
 a,b,c,n : longint;
 u_poly_2d : ^u_poly_2dtype;
 u_poly_3d : ^u_poly_3dtype;
 u_colors3 : ^u_colors3type;
 upl3d,upl2d,upcl,upbmp : pointer;
 f: file;
 fname  :string;
 dist,maxdist : longint;
 ch:char;
 maxx,minx,maxy,miny,maxz,minz : integer;
 texture : pointer;
 textureseg: word;

 {$F+}
procedure guropal; external;
{$L d:\guropal}
{$F-}

function getnextline(var ft:text): string;
var
 s: string;
 label l1,l2;
begin
 l1:
 if eof(ft) then
   begin
    s:='';
    goto l2;
   end;
 readln(ft,s);
 while (length(s)>0) and (s[1]=' ') do s:=copy(s,2,255);
 if s='' then goto l1;
 if copy(s,1,4)='Page' then goto l1;
 l2:
 getnextline:=s;
end;

procedure LoadAscFile_ (fname:string);
var
 nnames: word;
 names : array [1..15] of string;
begin

 loadasclist(fname,@names,nnames,15);

 for nobj:=1 to nnames do
       loadascfile(fname,names[nobj],
          obj_nfaces[nobj],obj_nvertices[nobj],
          pointer(obj_faces[nobj]),pointer(obj_vertices[nobj]),
          pointer(obj_bmpxy[nobj]),
            maxnfaces,maxnvertices,1);
end;

procedure calcnormal(norm: pointer);
type
 normalt = array [1..3] of integer;
var
 x1,y1,z1   : integer;
 x21,x31, y21,y31, z21,z31    : longint;
 a,b,c,m : real;
 i,j : word;

begin
 x1:=poly_3d[1,1];
 y1:=poly_3d[1,2];
 z1:=poly_3d[1,3];

 x21:=poly_3d[2,1]-x1;
 y21:=poly_3d[2,2]-y1;
 z21:=poly_3d[2,3]-z1;

 x31:=poly_3d[3,1]-x1;
 y31:=poly_3d[3,2]-y1;
 z31:=poly_3d[3,3]-z1;

 a:= y21*z31 - y31*z21;
 b:= z21*x31 - x21*z31;
 c:= x21*y31 - x31*y21;

 m:=sqrt(sqr(a)+sqr(b)+sqr(c));
if m<>0 then
 begin
  a:=(a*127)/m;
  b:=(b*127)/m;
  c:=(c*127)/m;
 end
   else
     begin
      writeln;
      writeln('------------ normal length = 0 !');
    {  halt;}
     a:=127;
     b:=0;
     c:=0;
     end;
 normalt(norm^)[1]:=round(a);
 normalt(norm^)[2]:=round(b);
 normalt(norm^)[3]:=round(c);
end;

function visible_p (poly: pointer): boolean;
var
 poly2d: array [1..4,1..2] of integer;
begin
 move(poly^,poly2d,sizeof(poly2d));
 if poly2d[1,1]*poly2d[2,2]+
    poly2d[1,2]*poly2d[3,1]+
    poly2d[2,1]*poly2d[3,2]-
    poly2d[3,1]*poly2d[2,2]-
    poly2d[2,1]*poly2d[1,2]-
    poly2d[1,1]*poly2d[3,2]>0 then
       visible_p:=true
            else
             visible_p:=false;
end;

function visible (poly: pointer): boolean; assembler;
 asm
  push ds
  lds si,poly
  mov ax,[si+0*4+0*2]             {1,1}
  imul word ptr [si+1*4+1*2]      {2,2}
  mov cx,ax
  mov di,dx

  mov ax,[si+0*4+1*2]             {1,2}
  imul word ptr [si+2*4+0*2]      {3,1}
  add cx,ax
  adc di,dx

  mov ax,[si+1*4+0*2]             {2,1}
  imul word ptr [si+2*4+1*2]      {3,2}
  add cx,ax
  adc di,dx

  mov ax,[si+2*4+0*2]             {3,1}
  imul word ptr [si+1*4+1*2]      {2,2}
  sub cx,ax
  sbb di,dx

  mov ax,[si+1*4+0*2]             {2,1}
  imul word ptr [si+0*4+1*2]      {1,2}
  sub cx,ax
  sbb di,dx

  mov ax,[si+0*4+0*2]             {1,1}
  imul word ptr [si+2*4+1*2]      {3,2}
  sub cx,ax
  sbb di,dx

  mov al,true
  jns @l1
  mov al,false
  @l1:
  pop ds
 end;

 label l1;

begin
if paramcount <2 then
  begin
   writeln('Try "filename.asc texture.pcx" as parameter :)');
   writeln('filename.asc - must have mapping coordinates');
   writeln('texture.pcx - 256x256 picture - material');
   writeln('In view mode:');
   writeln('  Keys "q","w","e" - alfa,beta,gama roration on/off');
   writeln('       "a","s","d" - zero alfa,beta,bama');
   halt
  end;
 getmem(texture,60000);
 textureseg:=laga(texture).seg+1;
 getmem(texture,6000);

 if loadpcx_raw_pal(paramstr(2),ptr(textureseg,0),addr(guropal))>0 then
    begin
     writeln('Can`t read PCX ',paramstr(1));
     halt;
    end;
 getmem(backbuf,64000+32);
 backbufseg:=laga(backbuf).seg+1;

 getmem(zbuf,64000+16);
 zbufseg:=laga(zbuf).seg+1;
 getmem(zbuf,64000+32);

 getmem(vid3d,sizeof(vid3dtype));
 getmem(obj2d,sizeof(obj2dtype));
 getmem(colors,sizeof(colorstype));
 getmem(newnormals,sizeof(newnormalstype));
 getmem(u_poly_2d,sizeof(u_poly_2dtype));
 getmem(u_poly_3d,sizeof(u_poly_3dtype));
 getmem(u_colors3,sizeof(u_colors3type));

 textmode(3);

 fname:=paramstr(1);
 loadascfile_(fname);

 writeln('Calculating normals:');
 writeln('============================');

  for i:=1 to nobj do
    begin
     writeln('Object #',i,': ',obj_names[i],
           ', ',obj_nfaces[i],' faces, ',obj_nvertices[i],' vertices');
     writeln('     Calculating face normals:');
     for j:=1 to obj_nfaces[i] do
       begin
        write('     Face: ',j,#13);
        move(obj_vertices[i]^[obj_faces[i]^[j,1]],poly_3d[1],6);
        move(obj_vertices[i]^[obj_faces[i]^[j,2]],poly_3d[2],6);
        move(obj_vertices[i]^[obj_faces[i]^[j,3]],poly_3d[3],6);
        calcnormal(addr(newnormals^[j]));
       end;
     writeln ('     Done.           ');
     writeln('     Calculating normals in vertices:');
     getmem(obj_normals[i],obj_nvertices[i]*2*3);
     for j:=1 to obj_nvertices[i] do
       begin

        write('     Vertex: ',j,#13);
         a:=0; b:=0; c:=0; n:=0;

         for k:=1 to obj_nfaces[i] do
            if (obj_faces[i]^[k,1]=j) or
               (obj_faces[i]^[k,2]=j) or
               (obj_faces[i]^[k,3]=j) then
                 begin
                  inc(n);
                  inc(a,newnormals^[k,1]);
                  inc(b,newnormals^[k,2]);
                  inc(c,newnormals^[k,3]);
                 end;

         if n=0 then
           begin
            writeln;
            writeln ('-------- null normal !');
            inc(n);
           end;
         obj_normals[i]^[j,1]:=a div n;
         obj_normals[i]^[j,2]:=b div n;
         obj_normals[i]^[j,3]:=c div n;
       end;
     writeln ('     Done.           ');
     writeln;
    end;

 writeln;
 writeln ('Centering....');
 writeln ('=========================');

 minx:=32760;
 miny:=32760;
 minz:=32760;
 maxx:=-32760;
 maxy:=-32760;
 maxz:=-32760;

 for i:=1 to nobj do
   begin
    upcl:=obj_vertices[i];
    for j:=1 to obj_nvertices[i] do
      asm
       les si,upcl
       mov ax,es:[si]
       cmp ax,maxx
       jl @l1
       mov maxx,ax
       @l1:
       cmp ax,minx
       jg @l2
       mov minx,ax
       @l2:

       mov ax,es:[si+2]
       cmp ax,maxy
       jl @l1a
       mov maxy,ax
       @l1a:
       cmp ax,miny
       jg @l2a
       mov miny,ax
       @l2a:

       mov ax,es:[si+2+2]
       cmp ax,maxz
       jl @l1b
       mov maxz,ax
       @l1b:
       cmp ax,minz
       jg @l2b
       mov minz,ax
       @l2b:

       add word ptr upcl,6
      end;
     end;

 minx:=(minx+maxx) div 2;
 miny:=(miny+maxy) div 2;
 minz:=(minz+maxz) div 2;

 for i:=1 to nobj do
   begin
    upcl:=obj_vertices[i];
    for j:=1 to obj_nvertices[i] do
      asm
       les si,upcl

       mov ax,minx
       sub es:[si],ax

       mov ax,miny
       sub es:[si+2],ax

       mov ax,minz
       sub es:[si+2+2],ax

       add word ptr upcl,6
      end;
   end;

 writeln;
 writeln ('Calculating distances');
 writeln ('=========================');

 maxdist:=0;
 for i:=1 to nobj do
   begin
    upcl:=obj_vertices[i];
    write('object #',i,#13);
    for j:=1 to obj_nvertices[i] do
      asm
       les si,upcl
       mov ax,es:[si]
       mov di,ax
       imul di
       mov cx,ax
       mov bx,dx

       mov ax,es:[si+2]
       mov di,ax
       imul di
       add cx,ax
       adc bx,dx

       mov ax,es:[si+2+2]
       mov di,ax
       imul di
       add cx,ax
       adc bx,dx

       cmp word ptr maxdist+2,bx
       ja @l1
       jc @l2
       cmp word ptr maxdist,cx
       ja @l1
       @l2:
       mov word ptr maxdist+2,bx
       mov word ptr maxdist,cx
       @l1:
       add word ptr upcl,6
      end;
   end;

 writeln;
 radius:=round(sqrt(maxdist)*3.5);

 observer.alfa_rad:=0;
 observer.beta_rad:=0;
 observer.gama_rad:=0;

 setgfxmode;
{ setbwpalette256;}
 setpalette(addr(guropal));

 ls_normal[1]:=80;
 ls_normal[2]:=-99;
 ls_normal[3]:=0;

 kr:=15+32+32+32+32+32;
 kd:=16;

 textattr:=$70;
 directvideo:=false;

 kr:=0;
 kd:=0;

l1:
 asm
  mov ax,backbufseg
  mov s_scrbuf1seg,ax
  mov ax,zbufseg
  mov s_zbuf1seg,ax
  mov ax,textureseg
  mov s_bmpseg,ax
 end;

 repeat

 t:=timercounter;
 clearvga(backbufseg);
 initzbuf(zbufseg);

 spherelook(addr(observer),radius);

 for i:=1 to nobj do
   begin
    Rotate_3d(obj_nvertices[i],obj_normals[i],addr(observer),newnormals);
    transform(obj_nvertices[i],obj_vertices[i],addr(observer),vid3d);
    proectpoints(obj_nvertices[i],vid3d,obj2d);

    unpacktriangle (obj_nfaces[i], vid3d, obj2d, obj_faces[i],
           colors, u_poly_3d, u_poly_2d, u_colors3);

    upl3d:=u_poly_3d;
    upl2d:=u_poly_2d;
    upcl:=u_colors3;
    upbmp:=@obj_bmpxy[nobj]^;

       asm
        lea si,obj_nfaces-2
        mov bx,i
        shl bx,1
        mov cx,[si+bx]

        @l2:
        push cx
        push word ptr upl2d+2
        push word ptr upl2d
        call visible
        or al,al
        je @l1

        les si,upl2d

        mov ax,es:[si]
        add ax,160
        mov word ptr s_poly2d,ax

        mov ax,es:[si+4]
        add ax,160
        mov word ptr s_poly2d[4],ax

        mov ax,es:[si+8]
        add ax,160
        mov word ptr s_poly2d[8],ax

        mov ax,es:[si+2]
        neg ax
        add ax,100
        mov word ptr s_poly2d[2],ax

        mov ax,es:[si+2+4]
        neg ax
        add ax,100
        mov word ptr s_poly2d[2+4],ax

        mov ax,es:[si+2+8]
        neg ax
        add ax,100
        mov word ptr s_poly2d[2+8],ax

{        push word ptr upl3d+2;
        push word ptr upl3d;
        push word ptr upl2d+2;
        push word ptr upl2d;
        les si,upcl
        push word ptr es:[si]
        push word ptr es:[si+2]
        push word ptr es:[si+4]
        push word ptr backbufseg
        push word ptr zbufseg
        call filltriangle_zbuf_guro}


        les si,upl3d

        @ll1:
        mov ax,es:[si]
        mov word ptr s_poly3d[0],ax
        mov ax,es:[si+2]
        mov word ptr s_poly3d[2],ax
        mov ax,es:[si+4]
        mov word ptr s_poly3d[4],ax
        mov ax,es:[si+6]
        mov word ptr s_poly3d[6],ax
        mov ax,es:[si+8]
        mov word ptr s_poly3d[8],ax
        mov ax,es:[si+10]
        mov word ptr s_poly3d[10],ax
        mov ax,es:[si+12]
        mov word ptr s_poly3d[12],ax
        mov ax,es:[si+14]
        mov word ptr s_poly3d[14],ax
        mov ax,es:[si+16]
        mov word ptr s_poly3d[16],ax

        les si,upbmp

        mov ax,es:[si]
        mov word ptr s_polybmp[0],ax
        mov ax,es:[si+2]
        mov word ptr s_polybmp[2],ax
        mov ax,es:[si+4]
        mov word ptr s_polybmp[4],ax

        call texturemap_simple

        @l1:
        add word ptr upl3d,6*3
        add word ptr upl2d,4*3
        add word ptr upcl,2*3
        add word ptr upbmp,2*3

        pop cx
        dec cx
        jne @l2

      end;

   end;
  copytoscreen(backbufseg);
  gotoxy(1,1); writeln(1024/(timercounter-t):2:3);
  incangles(addr(observer),q1*round(3*1444/200*(timercounter-t)),
        q2*round(2*1444/200*(timercounter-t)),
        q3*round(1*1444/200*(timercounter-t)));
 until keypressed;

 ch:=readkey;

 if ch='q' then if q1=0 then q1:=1 else q1:=0;
 if ch='w' then if q2=0 then q2:=1 else q2:=0;
 if ch='e' then if q3=0 then q3:=1 else q3:=0;

 if ch='a' then observer.alfa_rad:=0;
 if ch='s' then observer.beta_rad:=0;
 if ch='d' then observer.gama_rad:=0;

 if ch<>#27 then goto l1;

 settxtmode;
writeln('(c) HAX');
while keypressed do readkey;
end.